/* Category.c generated by valac 0.56.13, the Vala compiler
 * generated from Category.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgie-appindexer.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

enum  {
	BUDGIE_CATEGORY_0_PROPERTY,
	BUDGIE_CATEGORY_NAME_PROPERTY,
	BUDGIE_CATEGORY_MISC_CATEGORY_PROPERTY,
	BUDGIE_CATEGORY_APPS_PROPERTY,
	BUDGIE_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* budgie_category_properties[BUDGIE_CATEGORY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _BudgieCategoryPrivate {
	gchar* _name;
	gboolean _misc_category;
	GeeArrayList* _apps;
};

static gint BudgieCategory_private_offset;
static gpointer budgie_category_parent_class = NULL;

static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void budgie_category_set_apps (BudgieCategory* self,
                               GeeArrayList* value);
static void budgie_category_finalize (GObject * obj);
static GType budgie_category_get_type_once (void);
static void _vala_budgie_category_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_budgie_category_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
budgie_category_get_instance_private (BudgieCategory* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieCategory_private_offset);
}

/**
* Create a new category with a name.
*
* Optionally mark this category as a miscellaneous catch-all category
* by passing in `true` for the `misc` parameter.
*/
BudgieCategory*
budgie_category_construct (GType object_type,
                           const gchar* name,
                           gboolean misc)
{
	BudgieCategory * self = NULL;
#line 39 "../src/appindexer/Category.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 40 "../src/appindexer/Category.vala"
	self = (BudgieCategory*) g_object_new (object_type, "name", name, "misc-category", misc, NULL);
#line 39 "../src/appindexer/Category.vala"
	return self;
#line 93 "Category.c"
}

BudgieCategory*
budgie_category_new (const gchar* name,
                     gboolean misc)
{
#line 39 "../src/appindexer/Category.vala"
	return budgie_category_construct (BUDGIE_TYPE_CATEGORY, name, misc);
#line 102 "Category.c"
}

/**
 * Create a new category from a file.
 *
 * Errors are thrown if the file doesn't exist or is a directory,
 * or if the input stream is closed while reading the file.
 */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 131 "Category.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 140 "Category.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 159 "Category.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 163 "Category.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 169 "Category.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 179 "Category.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 187 "Category.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 191 "Category.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 197 "Category.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 207 "Category.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 228 "Category.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 250 "Category.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 254 "Category.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 260 "Category.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 264 "Category.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 268 "Category.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 276 "Category.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 304 "Category.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 313 "Category.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 327 "Category.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 336 "Category.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 350 "Category.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 359 "Category.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 368 "Category.c"
}

BudgieCategory*
budgie_category_new_for_file (GFile* file,
                              GError** error)
{
	gchar* name = NULL;
	gchar* _tmp0_;
	GFileInputStream* input_stream = NULL;
	GFileInputStream* _tmp1_;
	GDataInputStream* data_stream = NULL;
	GFileInputStream* _tmp2_;
	GDataInputStream* _tmp3_;
	gchar* line = NULL;
	gchar* filename_without_ext = NULL;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_;
	BudgieCategory* _tmp24_ = NULL;
	GError* _inner_error0_ = NULL;
	BudgieCategory* result;
#line 49 "../src/appindexer/Category.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 51 "../src/appindexer/Category.vala"
	_tmp0_ = g_strdup (_ ("New Category"));
#line 51 "../src/appindexer/Category.vala"
	name = _tmp0_;
#line 54 "../src/appindexer/Category.vala"
	_tmp1_ = g_file_read (file, NULL, &_inner_error0_);
#line 54 "../src/appindexer/Category.vala"
	input_stream = _tmp1_;
#line 54 "../src/appindexer/Category.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../src/appindexer/Category.vala"
		g_propagate_error (error, _inner_error0_);
#line 54 "../src/appindexer/Category.vala"
		_g_free0 (name);
#line 54 "../src/appindexer/Category.vala"
		return NULL;
#line 415 "Category.c"
	}
#line 55 "../src/appindexer/Category.vala"
	_tmp2_ = input_stream;
#line 55 "../src/appindexer/Category.vala"
	_tmp3_ = g_data_input_stream_new ((GInputStream*) _tmp2_);
#line 55 "../src/appindexer/Category.vala"
	data_stream = _tmp3_;
#line 58 "../src/appindexer/Category.vala"
	line = NULL;
#line 59 "../src/appindexer/Category.vala"
	while (TRUE) {
#line 427 "Category.c"
		gchar* _tmp4_ = NULL;
		GDataInputStream* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 59 "../src/appindexer/Category.vala"
		_tmp5_ = data_stream;
#line 59 "../src/appindexer/Category.vala"
		_tmp6_ = g_data_input_stream_read_line (_tmp5_, NULL, NULL, &_inner_error0_);
#line 59 "../src/appindexer/Category.vala"
		_tmp4_ = _tmp6_;
#line 59 "../src/appindexer/Category.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../src/appindexer/Category.vala"
			g_propagate_error (error, _inner_error0_);
#line 59 "../src/appindexer/Category.vala"
			_g_free0 (line);
#line 59 "../src/appindexer/Category.vala"
			_g_object_unref0 (data_stream);
#line 59 "../src/appindexer/Category.vala"
			_g_object_unref0 (input_stream);
#line 59 "../src/appindexer/Category.vala"
			_g_free0 (name);
#line 59 "../src/appindexer/Category.vala"
			return NULL;
#line 454 "Category.c"
		}
#line 59 "../src/appindexer/Category.vala"
		_tmp7_ = _tmp4_;
#line 59 "../src/appindexer/Category.vala"
		_tmp4_ = NULL;
#line 59 "../src/appindexer/Category.vala"
		_g_free0 (line);
#line 59 "../src/appindexer/Category.vala"
		line = _tmp7_;
#line 59 "../src/appindexer/Category.vala"
		_tmp8_ = line;
#line 59 "../src/appindexer/Category.vala"
		if (!(_tmp8_ != NULL)) {
#line 59 "../src/appindexer/Category.vala"
			_g_free0 (_tmp4_);
#line 59 "../src/appindexer/Category.vala"
			break;
#line 472 "Category.c"
		}
#line 61 "../src/appindexer/Category.vala"
		_tmp9_ = line;
#line 61 "../src/appindexer/Category.vala"
		if (g_str_has_prefix (_tmp9_, "Name=")) {
#line 478 "Category.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 62 "../src/appindexer/Category.vala"
			_tmp10_ = line;
#line 62 "../src/appindexer/Category.vala"
			_tmp11_ = string_substring (_tmp10_, (glong) 5, (glong) -1);
#line 62 "../src/appindexer/Category.vala"
			_tmp12_ = _tmp11_;
#line 62 "../src/appindexer/Category.vala"
			_tmp13_ = string_strip (_tmp12_);
#line 62 "../src/appindexer/Category.vala"
			_g_free0 (name);
#line 62 "../src/appindexer/Category.vala"
			name = _tmp13_;
#line 62 "../src/appindexer/Category.vala"
			_g_free0 (_tmp12_);
#line 63 "../src/appindexer/Category.vala"
			_g_free0 (_tmp4_);
#line 63 "../src/appindexer/Category.vala"
			break;
#line 501 "Category.c"
		}
#line 59 "../src/appindexer/Category.vala"
		_g_free0 (_tmp4_);
#line 505 "Category.c"
	}
#line 67 "../src/appindexer/Category.vala"
	_tmp14_ = g_file_get_basename (file);
#line 67 "../src/appindexer/Category.vala"
	_tmp15_ = _tmp14_;
#line 67 "../src/appindexer/Category.vala"
	_tmp16_ = string_replace (_tmp15_, ".directory", "");
#line 67 "../src/appindexer/Category.vala"
	_tmp17_ = _tmp16_;
#line 67 "../src/appindexer/Category.vala"
	_g_free0 (_tmp15_);
#line 67 "../src/appindexer/Category.vala"
	filename_without_ext = _tmp17_;
#line 69 "../src/appindexer/Category.vala"
	_tmp18_ = name;
#line 69 "../src/appindexer/Category.vala"
	_tmp19_ = name;
#line 69 "../src/appindexer/Category.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 69 "../src/appindexer/Category.vala"
	_tmp21_ = filename_without_ext;
#line 69 "../src/appindexer/Category.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 69 "../src/appindexer/Category.vala"
	_tmp23_ = g_new0 (gchar*, 2 + 1);
#line 69 "../src/appindexer/Category.vala"
	_tmp23_[0] = _tmp20_;
#line 69 "../src/appindexer/Category.vala"
	_tmp23_[1] = _tmp22_;
#line 69 "../src/appindexer/Category.vala"
	_tmp24_ = budgie_category_new (_tmp18_, FALSE);
#line 69 "../src/appindexer/Category.vala"
	_tmp24_->included_categories = (_vala_array_free (_tmp24_->included_categories, _tmp24_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/appindexer/Category.vala"
	_tmp24_->included_categories = _tmp23_;
#line 69 "../src/appindexer/Category.vala"
	_tmp24_->included_categories_length1 = 2;
#line 69 "../src/appindexer/Category.vala"
	result = _tmp24_;
#line 69 "../src/appindexer/Category.vala"
	_g_free0 (filename_without_ext);
#line 69 "../src/appindexer/Category.vala"
	_g_free0 (line);
#line 69 "../src/appindexer/Category.vala"
	_g_object_unref0 (data_stream);
#line 69 "../src/appindexer/Category.vala"
	_g_object_unref0 (input_stream);
#line 69 "../src/appindexer/Category.vala"
	_g_free0 (name);
#line 69 "../src/appindexer/Category.vala"
	return result;
#line 557 "Category.c"
}

/**
* Add an application to this category if the app belongs in
* this category.
*
* Returns `true` if the application should be in this category,
* otherwise `false`.
*/
static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 83 "../src/appindexer/Category.vala"
	for (i = 0; i < stack_length; i++) {
#line 83 "../src/appindexer/Category.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 83 "../src/appindexer/Category.vala"
			return TRUE;
#line 579 "Category.c"
		}
	}
#line 83 "../src/appindexer/Category.vala"
	return FALSE;
#line 584 "Category.c"
}

gboolean
budgie_category_maybe_add_app (BudgieCategory* self,
                               BudgieApplication* app)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* categories = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean found_category = FALSE;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gboolean _tmp19_;
	gboolean result;
#line 81 "../src/appindexer/Category.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "../src/appindexer/Category.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 83 "../src/appindexer/Category.vala"
	_tmp0_ = budgie_application_get_desktop_id (app);
#line 83 "../src/appindexer/Category.vala"
	_tmp1_ = _tmp0_;
#line 83 "../src/appindexer/Category.vala"
	_tmp2_ = self->excluded_applications;
#line 83 "../src/appindexer/Category.vala"
	_tmp2__length1 = self->excluded_applications_length1;
#line 83 "../src/appindexer/Category.vala"
	if (_vala_string_array_contains (_tmp2_, _tmp2__length1, _tmp1_)) {
#line 84 "../src/appindexer/Category.vala"
		result = FALSE;
#line 84 "../src/appindexer/Category.vala"
		return result;
#line 623 "Category.c"
	}
#line 88 "../src/appindexer/Category.vala"
	_tmp3_ = budgie_application_get_categories (app);
#line 88 "../src/appindexer/Category.vala"
	_tmp4_ = _tmp3_;
#line 88 "../src/appindexer/Category.vala"
	categories = _tmp4_;
#line 89 "../src/appindexer/Category.vala"
	_tmp5_ = categories;
#line 89 "../src/appindexer/Category.vala"
	if (_tmp5_ == NULL) {
#line 635 "Category.c"
		gboolean _tmp6_;
		GeeArrayList* _tmp7_;
#line 90 "../src/appindexer/Category.vala"
		_tmp6_ = self->priv->_misc_category;
#line 90 "../src/appindexer/Category.vala"
		if (!_tmp6_) {
#line 91 "../src/appindexer/Category.vala"
			result = FALSE;
#line 91 "../src/appindexer/Category.vala"
			return result;
#line 646 "Category.c"
		}
#line 95 "../src/appindexer/Category.vala"
		_tmp7_ = self->priv->_apps;
#line 95 "../src/appindexer/Category.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, app);
#line 96 "../src/appindexer/Category.vala"
		result = TRUE;
#line 96 "../src/appindexer/Category.vala"
		return result;
#line 656 "Category.c"
	}
#line 100 "../src/appindexer/Category.vala"
	found_category = FALSE;
#line 101 "../src/appindexer/Category.vala"
	_tmp8_ = categories;
#line 101 "../src/appindexer/Category.vala"
	_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, ";", 0);
#line 664 "Category.c"
	{
		gchar** category_collection = NULL;
		gint category_collection_length1 = 0;
		gint _category_collection_size_ = 0;
		gint category_it = 0;
#line 101 "../src/appindexer/Category.vala"
		category_collection = _tmp10_;
#line 101 "../src/appindexer/Category.vala"
		category_collection_length1 = _vala_array_length (_tmp9_);
#line 101 "../src/appindexer/Category.vala"
		for (category_it = 0; category_it < category_collection_length1; category_it = category_it + 1) {
#line 676 "Category.c"
			const gchar* category = NULL;
#line 101 "../src/appindexer/Category.vala"
			category = category_collection[category_it];
#line 680 "Category.c"
			{
				const gchar* _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar** _tmp14_;
				gint _tmp14__length1;
#line 103 "../src/appindexer/Category.vala"
				_tmp11_ = category;
#line 103 "../src/appindexer/Category.vala"
				_tmp12_ = self->excluded_categories;
#line 103 "../src/appindexer/Category.vala"
				_tmp12__length1 = self->excluded_categories_length1;
#line 103 "../src/appindexer/Category.vala"
				if (_vala_string_array_contains (_tmp12_, _tmp12__length1, _tmp11_)) {
#line 104 "../src/appindexer/Category.vala"
					result = FALSE;
#line 104 "../src/appindexer/Category.vala"
					category_collection = (_vala_array_free (category_collection, category_collection_length1, (GDestroyNotify) g_free), NULL);
#line 104 "../src/appindexer/Category.vala"
					return result;
#line 702 "Category.c"
				}
#line 107 "../src/appindexer/Category.vala"
				_tmp13_ = category;
#line 107 "../src/appindexer/Category.vala"
				_tmp14_ = self->included_categories;
#line 107 "../src/appindexer/Category.vala"
				_tmp14__length1 = self->included_categories_length1;
#line 107 "../src/appindexer/Category.vala"
				if (_vala_string_array_contains (_tmp14_, _tmp14__length1, _tmp13_)) {
#line 109 "../src/appindexer/Category.vala"
					found_category = TRUE;
#line 714 "Category.c"
				}
			}
		}
#line 101 "../src/appindexer/Category.vala"
		category_collection = (_vala_array_free (category_collection, category_collection_length1, (GDestroyNotify) g_free), NULL);
#line 720 "Category.c"
	}
#line 114 "../src/appindexer/Category.vala"
	if (found_category) {
#line 724 "Category.c"
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GeeArrayList* _tmp18_;
#line 115 "../src/appindexer/Category.vala"
		_tmp15_ = budgie_application_get_name (app);
#line 115 "../src/appindexer/Category.vala"
		_tmp16_ = _tmp15_;
#line 115 "../src/appindexer/Category.vala"
		_tmp17_ = self->priv->_name;
#line 115 "../src/appindexer/Category.vala"
		g_debug ("Category.vala:115: Adding '%s' to category '%s'", _tmp16_, _tmp17_);
#line 117 "../src/appindexer/Category.vala"
		_tmp18_ = self->priv->_apps;
#line 117 "../src/appindexer/Category.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, app);
#line 118 "../src/appindexer/Category.vala"
		result = TRUE;
#line 118 "../src/appindexer/Category.vala"
		return result;
#line 745 "Category.c"
	}
#line 122 "../src/appindexer/Category.vala"
	_tmp19_ = self->priv->_misc_category;
#line 122 "../src/appindexer/Category.vala"
	if (_tmp19_) {
#line 751 "Category.c"
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		GeeArrayList* _tmp23_;
#line 123 "../src/appindexer/Category.vala"
		_tmp20_ = budgie_application_get_name (app);
#line 123 "../src/appindexer/Category.vala"
		_tmp21_ = _tmp20_;
#line 123 "../src/appindexer/Category.vala"
		_tmp22_ = self->priv->_name;
#line 123 "../src/appindexer/Category.vala"
		g_debug ("Category.vala:123: Adding '%s' to category '%s'", _tmp21_, _tmp22_);
#line 125 "../src/appindexer/Category.vala"
		_tmp23_ = self->priv->_apps;
#line 125 "../src/appindexer/Category.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, app);
#line 126 "../src/appindexer/Category.vala"
		result = TRUE;
#line 126 "../src/appindexer/Category.vala"
		return result;
#line 772 "Category.c"
	}
#line 129 "../src/appindexer/Category.vala"
	result = FALSE;
#line 129 "../src/appindexer/Category.vala"
	return result;
#line 778 "Category.c"
}

const gchar*
budgie_category_get_name (BudgieCategory* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 18 "../src/appindexer/Category.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/appindexer/Category.vala"
	_tmp0_ = self->priv->_name;
#line 18 "../src/appindexer/Category.vala"
	result = _tmp0_;
#line 18 "../src/appindexer/Category.vala"
	return result;
#line 794 "Category.c"
}

static void
budgie_category_set_name (BudgieCategory* self,
                          const gchar* value)
{
	gchar* old_value;
#line 18 "../src/appindexer/Category.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/appindexer/Category.vala"
	old_value = budgie_category_get_name (self);
#line 18 "../src/appindexer/Category.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 808 "Category.c"
		gchar* _tmp0_;
#line 18 "../src/appindexer/Category.vala"
		_tmp0_ = g_strdup (value);
#line 18 "../src/appindexer/Category.vala"
		_g_free0 (self->priv->_name);
#line 18 "../src/appindexer/Category.vala"
		self->priv->_name = _tmp0_;
#line 18 "../src/appindexer/Category.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_category_properties[BUDGIE_CATEGORY_NAME_PROPERTY]);
#line 818 "Category.c"
	}
}

gboolean
budgie_category_get_misc_category (BudgieCategory* self)
{
	gboolean result;
#line 24 "../src/appindexer/Category.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../src/appindexer/Category.vala"
	result = self->priv->_misc_category;
#line 24 "../src/appindexer/Category.vala"
	return result;
#line 832 "Category.c"
}

static void
budgie_category_set_misc_category (BudgieCategory* self,
                                   gboolean value)
{
	gboolean old_value;
#line 24 "../src/appindexer/Category.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/appindexer/Category.vala"
	old_value = budgie_category_get_misc_category (self);
#line 24 "../src/appindexer/Category.vala"
	if (old_value != value) {
#line 24 "../src/appindexer/Category.vala"
		self->priv->_misc_category = value;
#line 24 "../src/appindexer/Category.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_category_properties[BUDGIE_CATEGORY_MISC_CATEGORY_PROPERTY]);
#line 850 "Category.c"
	}
}

GeeArrayList*
budgie_category_get_apps (BudgieCategory* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 31 "../src/appindexer/Category.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/appindexer/Category.vala"
	_tmp0_ = self->priv->_apps;
#line 31 "../src/appindexer/Category.vala"
	result = _tmp0_;
#line 31 "../src/appindexer/Category.vala"
	return result;
#line 867 "Category.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../src/appindexer/Category.vala"
	return self ? g_object_ref (self) : NULL;
#line 875 "Category.c"
}

static void
budgie_category_set_apps (BudgieCategory* self,
                          GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 31 "../src/appindexer/Category.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/appindexer/Category.vala"
	old_value = budgie_category_get_apps (self);
#line 31 "../src/appindexer/Category.vala"
	if (old_value != value) {
#line 889 "Category.c"
		GeeArrayList* _tmp0_;
#line 31 "../src/appindexer/Category.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/appindexer/Category.vala"
		_g_object_unref0 (self->priv->_apps);
#line 31 "../src/appindexer/Category.vala"
		self->priv->_apps = _tmp0_;
#line 31 "../src/appindexer/Category.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_category_properties[BUDGIE_CATEGORY_APPS_PROPERTY]);
#line 899 "Category.c"
	}
}

static void
budgie_category_class_init (BudgieCategoryClass * klass,
                            gpointer klass_data)
{
#line 16 "../src/appindexer/Category.vala"
	budgie_category_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/appindexer/Category.vala"
	g_type_class_adjust_private_offset (klass, &BudgieCategory_private_offset);
#line 16 "../src/appindexer/Category.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_category_get_property;
#line 16 "../src/appindexer/Category.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_category_set_property;
#line 16 "../src/appindexer/Category.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_category_finalize;
#line 917 "Category.c"
	/** The name of this category. */
#line 16 "../src/appindexer/Category.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_CATEGORY_NAME_PROPERTY, budgie_category_properties[BUDGIE_CATEGORY_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 921 "Category.c"
	/**
	* True if this category should be a catch-all for applicatiosn that
	* that don't go in any other category.
	*/
#line 16 "../src/appindexer/Category.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_CATEGORY_MISC_CATEGORY_PROPERTY, budgie_category_properties[BUDGIE_CATEGORY_MISC_CATEGORY_PROPERTY] = g_param_spec_boolean ("misc-category", "misc-category", "misc-category", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 928 "Category.c"
	/** The list of applications in this category. */
#line 16 "../src/appindexer/Category.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_CATEGORY_APPS_PROPERTY, budgie_category_properties[BUDGIE_CATEGORY_APPS_PROPERTY] = g_param_spec_object ("apps", "apps", "apps", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 932 "Category.c"
}

static void
budgie_category_instance_init (BudgieCategory * self,
                               gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 16 "../src/appindexer/Category.vala"
	self->priv = budgie_category_get_instance_private (self);
#line 31 "../src/appindexer/Category.vala"
	_tmp0_ = gee_array_list_new (BUDGIE_TYPE_APPLICATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 31 "../src/appindexer/Category.vala"
	self->priv->_apps = _tmp0_;
#line 946 "Category.c"
}

static void
budgie_category_finalize (GObject * obj)
{
	BudgieCategory * self;
#line 16 "../src/appindexer/Category.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_CATEGORY, BudgieCategory);
#line 18 "../src/appindexer/Category.vala"
	_g_free0 (self->priv->_name);
#line 26 "../src/appindexer/Category.vala"
	self->included_categories = (_vala_array_free (self->included_categories, self->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 27 "../src/appindexer/Category.vala"
	self->excluded_categories = (_vala_array_free (self->excluded_categories, self->excluded_categories_length1, (GDestroyNotify) g_free), NULL);
#line 28 "../src/appindexer/Category.vala"
	self->excluded_applications = (_vala_array_free (self->excluded_applications, self->excluded_applications_length1, (GDestroyNotify) g_free), NULL);
#line 31 "../src/appindexer/Category.vala"
	_g_object_unref0 (self->priv->_apps);
#line 16 "../src/appindexer/Category.vala"
	G_OBJECT_CLASS (budgie_category_parent_class)->finalize (obj);
#line 967 "Category.c"
}

/**
* Represents a category of applications.
*/
static GType
budgie_category_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieCategory), 0, (GInstanceInitFunc) budgie_category_instance_init, NULL };
	GType budgie_category_type_id;
	budgie_category_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieCategory", &g_define_type_info, 0);
	BudgieCategory_private_offset = g_type_add_instance_private (budgie_category_type_id, sizeof (BudgieCategoryPrivate));
	return budgie_category_type_id;
}

GType
budgie_category_get_type (void)
{
	static volatile gsize budgie_category_type_id__once = 0;
	if (g_once_init_enter (&budgie_category_type_id__once)) {
		GType budgie_category_type_id;
		budgie_category_type_id = budgie_category_get_type_once ();
		g_once_init_leave (&budgie_category_type_id__once, budgie_category_type_id);
	}
	return budgie_category_type_id__once;
}

static void
_vala_budgie_category_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	BudgieCategory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_CATEGORY, BudgieCategory);
#line 16 "../src/appindexer/Category.vala"
	switch (property_id) {
#line 16 "../src/appindexer/Category.vala"
		case BUDGIE_CATEGORY_NAME_PROPERTY:
#line 16 "../src/appindexer/Category.vala"
		g_value_set_string (value, budgie_category_get_name (self));
#line 16 "../src/appindexer/Category.vala"
		break;
#line 16 "../src/appindexer/Category.vala"
		case BUDGIE_CATEGORY_MISC_CATEGORY_PROPERTY:
#line 16 "../src/appindexer/Category.vala"
		g_value_set_boolean (value, budgie_category_get_misc_category (self));
#line 16 "../src/appindexer/Category.vala"
		break;
#line 16 "../src/appindexer/Category.vala"
		case BUDGIE_CATEGORY_APPS_PROPERTY:
#line 16 "../src/appindexer/Category.vala"
		g_value_set_object (value, budgie_category_get_apps (self));
#line 16 "../src/appindexer/Category.vala"
		break;
#line 1023 "Category.c"
		default:
#line 16 "../src/appindexer/Category.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/appindexer/Category.vala"
		break;
#line 1029 "Category.c"
	}
}

static void
_vala_budgie_category_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	BudgieCategory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_CATEGORY, BudgieCategory);
#line 16 "../src/appindexer/Category.vala"
	switch (property_id) {
#line 16 "../src/appindexer/Category.vala"
		case BUDGIE_CATEGORY_NAME_PROPERTY:
#line 16 "../src/appindexer/Category.vala"
		budgie_category_set_name (self, g_value_get_string (value));
#line 16 "../src/appindexer/Category.vala"
		break;
#line 16 "../src/appindexer/Category.vala"
		case BUDGIE_CATEGORY_MISC_CATEGORY_PROPERTY:
#line 16 "../src/appindexer/Category.vala"
		budgie_category_set_misc_category (self, g_value_get_boolean (value));
#line 16 "../src/appindexer/Category.vala"
		break;
#line 16 "../src/appindexer/Category.vala"
		case BUDGIE_CATEGORY_APPS_PROPERTY:
#line 16 "../src/appindexer/Category.vala"
		budgie_category_set_apps (self, g_value_get_object (value));
#line 16 "../src/appindexer/Category.vala"
		break;
#line 1061 "Category.c"
		default:
#line 16 "../src/appindexer/Category.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/appindexer/Category.vala"
		break;
#line 1067 "Category.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

