/* settings.c generated by valac 0.56.13, the Vala compiler
 * generated from settings.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <string.h>
#include <stdlib.h>
#include <libnotify/notify.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define BUDGIE_TYPE_POWER_SCREEN (budgie_power_screen_get_type ())
#define BUDGIE_POWER_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_POWER_SCREEN, BudgiePowerScreen))
#define BUDGIE_IS_POWER_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_POWER_SCREEN))
#define BUDGIE_POWER_SCREEN_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BUDGIE_TYPE_POWER_SCREEN, BudgiePowerScreenIface))

typedef struct _BudgiePowerScreen BudgiePowerScreen;
typedef struct _BudgiePowerScreenIface BudgiePowerScreenIface;

#define BUDGIE_TYPE_POWER_SCREEN_PROXY (budgie_power_screen_proxy_get_type ())
typedef GDBusProxy BudgiePowerScreenProxy;
typedef GDBusProxyClass BudgiePowerScreenProxyClass;
typedef enum  {
	BUDGIE_BUTTON_POSITION_LEFT = 1 << 0,
	BUDGIE_BUTTON_POSITION_TRADITIONAL = 1 << 1
} BudgieButtonPosition;

#define BUDGIE_TYPE_BUTTON_POSITION (budgie_button_position_get_type ())
typedef enum  {
	BUDGIE_COLOR_SCHEME_DEFAULT,
	BUDGIE_COLOR_SCHEME_PREFER_DARK,
	BUDGIE_COLOR_SCHEME_PREFER_LIGHT
} BudgieColorScheme;

#define BUDGIE_TYPE_COLOR_SCHEME (budgie_color_scheme_get_type ())

#define BUDGIE_TYPE_SETTINGS_MANAGER (budgie_settings_manager_get_type ())
#define BUDGIE_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManager))
#define BUDGIE_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManagerClass))
#define BUDGIE_IS_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_SETTINGS_MANAGER))
#define BUDGIE_IS_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TYPE_SETTINGS_MANAGER))
#define BUDGIE_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManagerClass))

typedef struct _BudgieSettingsManager BudgieSettingsManager;
typedef struct _BudgieSettingsManagerClass BudgieSettingsManagerClass;
typedef struct _BudgieSettingsManagerPrivate BudgieSettingsManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
typedef struct _BudgieParamSpecSettingsManager BudgieParamSpecSettingsManager;

struct _BudgiePowerScreenIface {
	GTypeInterface parent_iface;
	gint32 (*get_brightness) (BudgiePowerScreen* self);
	void (*set_brightness) (BudgiePowerScreen* self, gint32 value);
};

struct _BudgieSettingsManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BudgieSettingsManagerPrivate * priv;
};

struct _BudgieSettingsManagerClass {
	GTypeClass parent_class;
	void (*finalize) (BudgieSettingsManager *self);
};

struct _BudgieSettingsManagerPrivate {
	GApplication* _parent_app;
	GSettings* mutter_settings;
	GSettings* gnome_desktop_settings;
	GSettings* gnome_power_settings;
	BudgiePowerScreen* gnome_power_props;
	GSettings* gnome_session_settings;
	GSettings* gnome_sound_settings;
	GSettings* gnome_wm_settings;
	GSettings* panel_settings;
	GSettings* raven_settings;
	GSettings* wm_settings;
	GSettings* xoverrides;
	gint32* default_brightness;
	guint32* default_idle_delay;
	gboolean* default_idle_dim;
	gint* default_sleep_inactive_ac_timeout;
	gint* default_sleep_inactive_battery_timeout;
	gchar* caffeine_full_cup;
	gchar* caffeine_empty_cup;
	NotifyNotification* caffeine_notification;
	gboolean temporary_notification_disabled;
};

struct _BudgieParamSpecSettingsManager {
	GParamSpec parent_instance;
};

static gint BudgieSettingsManager_private_offset;
static gpointer budgie_settings_manager_parent_class = NULL;

VALA_EXTERN GType budgie_power_screen_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BudgiePowerScreen, g_object_unref)
VALA_EXTERN GType budgie_power_screen_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint budgie_power_screen_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN gint32 budgie_power_screen_get_brightness (BudgiePowerScreen* self);
VALA_EXTERN void budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                         gint32 value);
static GType budgie_power_screen_get_type_once (void);
static void budgie_power_screen_proxy_g_signal (GDBusProxy* proxy,
                                         const gchar* sender_name,
                                         const gchar* signal_name,
                                         GVariant* parameters);
static gint32 budgie_power_screen_dbus_proxy_get_brightness (BudgiePowerScreen* self);
static void budgie_power_screen_dbus_proxy_set_brightness (BudgiePowerScreen* self,
                                                    gint32 value);
static void budgie_power_screen_proxy_budgie_power_screen_interface_init (BudgiePowerScreenIface* iface);
static void budgie_power_screen_dbus_interface_method_call (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* method_name,
                                                     GVariant* parameters,
                                                     GDBusMethodInvocation* invocation,
                                                     gpointer user_data);
static GVariant* budgie_power_screen_dbus_interface_get_property (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* property_name,
                                                           GError** error,
                                                           gpointer user_data);
static GVariant* _dbus_budgie_power_screen_get_brightness (BudgiePowerScreen* self);
static gboolean budgie_power_screen_dbus_interface_set_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GVariant* value,
                                                          GError** error,
                                                          gpointer user_data);
static void _dbus_budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                               GVariant* _value);
static void _budgie_power_screen_unregister_object (gpointer user_data);
VALA_EXTERN GType budgie_button_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType budgie_color_scheme_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer budgie_settings_manager_ref (gpointer instance);
VALA_EXTERN void budgie_settings_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* budgie_param_spec_settings_manager (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void budgie_value_set_settings_manager (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void budgie_value_take_settings_manager (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer budgie_value_get_settings_manager (const GValue* value);
VALA_EXTERN GType budgie_settings_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BudgieSettingsManager, budgie_settings_manager_unref)
static gint32* _int32_dup (gint32* self);
static guint32* _uint32_dup (guint32* self);
static gboolean* _bool_dup (gboolean* self);
static gint* _int_dup (gint* self);
VALA_EXTERN BudgieSettingsManager* budgie_settings_manager_new (void);
VALA_EXTERN BudgieSettingsManager* budgie_settings_manager_construct (GType object_type);
static void budgie_settings_manager_set_supported_caffeine_icons (BudgieSettingsManager* self);
static void budgie_settings_manager_fetch_defaults (BudgieSettingsManager* self);
static void budgie_settings_manager_enforce_mutter_settings (BudgieSettingsManager* self);
static void budgie_settings_manager_on_raven_sound_overdrive_change (BudgieSettingsManager* self);
static void _budgie_settings_manager_on_raven_sound_overdrive_change_g_settings_changed (GSettings* _sender,
                                                                                  const gchar* key,
                                                                                  gpointer self);
static void __lambda68_ (BudgieSettingsManager* self,
                  const gchar* key);
static void budgie_settings_manager_apply_dark_theme_pref (BudgieSettingsManager* self);
static void ___lambda68__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void budgie_settings_manager_update_idle_delay (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_idle_delay_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self);
static void budgie_settings_manager_update_idle_dim (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_idle_dim_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self);
static void budgie_settings_manager_update_ac_timeout (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_ac_timeout_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self);
static void budgie_settings_manager_update_battery_timeout (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_battery_timeout_g_settings_changed (GSettings* _sender,
                                                                         const gchar* key,
                                                                         gpointer self);
static void budgie_settings_manager_on_wm_settings_changed (BudgieSettingsManager* self,
                                                     const gchar* key);
static void _budgie_settings_manager_on_wm_settings_changed_g_settings_changed (GSettings* _sender,
                                                                         const gchar* key,
                                                                         gpointer self);
static void budgie_settings_manager_caffeine_settings_sync (BudgieSettingsManager* self);
static void budgie_settings_manager_change_brightness (BudgieSettingsManager* self,
                                                gint32 value);
static gboolean budgie_settings_manager_do_disable (BudgieSettingsManager* self);
static gboolean budgie_settings_manager_get_caffeine_mode (BudgieSettingsManager* self);
static void budgie_settings_manager_reset_values (BudgieSettingsManager* self);
VALA_EXTERN void budgie_settings_manager_do_disable_quietly (BudgieSettingsManager* self);
static void budgie_settings_manager_get_power_defaults (BudgieSettingsManager* self);
static GVariant* budgie_settings_manager_new_filtered_xsetting (BudgieSettingsManager* self,
                                                         const gchar* button_layout);
static void budgie_settings_manager_set_button_style (BudgieSettingsManager* self,
                                               BudgieButtonPosition style);
static void budgie_settings_manager_set_caffeine_mode (BudgieSettingsManager* self,
                                                gboolean enabled,
                                                gboolean disable_notification);
static void budgie_settings_manager_set_focus_mode (BudgieSettingsManager* self,
                                             gboolean enable);
static GVariant* _variant_new2 (const gchar* value);
static gboolean ____lambda69_ (BudgieSettingsManager* self);
static gboolean _____lambda69__gsource_func (gpointer self);
static gboolean _budgie_settings_manager_do_disable_gsource_func (gpointer self);
static gboolean ___lambda70_ (BudgieSettingsManager* self);
static gboolean ____lambda70__gsource_func (gpointer self);
static gboolean ___lambda71_ (BudgieSettingsManager* self);
static gboolean ____lambda71__gsource_func (gpointer self);
static GVariant* _variant_new3 (const gchar* value);
VALA_EXTERN GApplication* budgie_settings_manager_get_parent_app (BudgieSettingsManager* self);
VALA_EXTERN void budgie_settings_manager_set_parent_app (BudgieSettingsManager* self,
                                             GApplication* value);
static void budgie_settings_manager_finalize (BudgieSettingsManager * obj);
static GType budgie_settings_manager_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusMethodInfo * const _budgie_power_screen_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _budgie_power_screen_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _budgie_power_screen_dbus_property_info_brightness = {-1, "Brightness", "i", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo * const _budgie_power_screen_dbus_property_info[] = {&_budgie_power_screen_dbus_property_info_brightness, NULL};
static const GDBusInterfaceInfo _budgie_power_screen_dbus_interface_info = {-1, "org.gnome.SettingsDaemon.Power.Screen", (GDBusMethodInfo **) (&_budgie_power_screen_dbus_method_info), (GDBusSignalInfo **) (&_budgie_power_screen_dbus_signal_info), (GDBusPropertyInfo **) (&_budgie_power_screen_dbus_property_info), NULL};
static const GDBusInterfaceVTable _budgie_power_screen_dbus_interface_vtable = {budgie_power_screen_dbus_interface_method_call, budgie_power_screen_dbus_interface_get_property, budgie_power_screen_dbus_interface_set_property};

gint32
budgie_power_screen_get_brightness (BudgiePowerScreen* self)
{
	BudgiePowerScreenIface* _iface_;
#line 15 "../src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 15 "../src/daemon/settings.vala"
	_iface_ = BUDGIE_POWER_SCREEN_GET_INTERFACE (self);
#line 15 "../src/daemon/settings.vala"
	if (_iface_->get_brightness) {
#line 15 "../src/daemon/settings.vala"
		return _iface_->get_brightness (self);
#line 283 "settings.c"
	}
#line 15 "../src/daemon/settings.vala"
	return -1;
#line 287 "settings.c"
}

void
budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                    gint32 value)
{
	BudgiePowerScreenIface* _iface_;
#line 15 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/daemon/settings.vala"
	_iface_ = BUDGIE_POWER_SCREEN_GET_INTERFACE (self);
#line 15 "../src/daemon/settings.vala"
	if (_iface_->set_brightness) {
#line 15 "../src/daemon/settings.vala"
		_iface_->set_brightness (self, value);
#line 303 "settings.c"
	}
}

static void
budgie_power_screen_default_init (BudgiePowerScreenIface * iface,
                                  gpointer iface_data)
{
}

static GType
budgie_power_screen_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgiePowerScreenIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_power_screen_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType budgie_power_screen_type_id;
	budgie_power_screen_type_id = g_type_register_static (G_TYPE_INTERFACE, "BudgiePowerScreen", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (budgie_power_screen_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) budgie_power_screen_proxy_get_type);
	g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SettingsDaemon.Power.Screen");
	g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_budgie_power_screen_dbus_interface_info));
	g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) budgie_power_screen_register_object);
	return budgie_power_screen_type_id;
}

GType
budgie_power_screen_get_type (void)
{
	static volatile gsize budgie_power_screen_type_id__once = 0;
	if (g_once_init_enter (&budgie_power_screen_type_id__once)) {
		GType budgie_power_screen_type_id;
		budgie_power_screen_type_id = budgie_power_screen_get_type_once ();
		g_once_init_leave (&budgie_power_screen_type_id__once, budgie_power_screen_type_id);
	}
	return budgie_power_screen_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (BudgiePowerScreenProxy, budgie_power_screen_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (BUDGIE_TYPE_POWER_SCREEN, budgie_power_screen_proxy_budgie_power_screen_interface_init) )
static void
budgie_power_screen_proxy_class_init (BudgiePowerScreenProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = budgie_power_screen_proxy_g_signal;
}

static void
budgie_power_screen_proxy_g_signal (GDBusProxy* proxy,
                                    const gchar* sender_name,
                                    const gchar* signal_name,
                                    GVariant* parameters)
{
}

static void
budgie_power_screen_proxy_init (BudgiePowerScreenProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_budgie_power_screen_dbus_interface_info));
}

static gint32
budgie_power_screen_dbus_proxy_get_brightness (BudgiePowerScreen* self)
{
	GVariant *_inner_reply;
	gint32 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Brightness");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.SettingsDaemon.Power.Screen"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Brightness"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint32 _tmp79_ = 0;
			return _tmp79_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
budgie_power_screen_dbus_proxy_set_brightness (BudgiePowerScreen* self,
                                               gint32 value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.SettingsDaemon.Power.Screen"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Brightness"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}

static void
budgie_power_screen_proxy_budgie_power_screen_interface_init (BudgiePowerScreenIface* iface)
{
	iface->get_brightness = budgie_power_screen_dbus_proxy_get_brightness;
	iface->set_brightness = budgie_power_screen_dbus_proxy_set_brightness;
}

static void
budgie_power_screen_dbus_interface_method_call (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* method_name,
                                                GVariant* parameters,
                                                GDBusMethodInvocation* invocation,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_budgie_power_screen_get_brightness (BudgiePowerScreen* self)
{
	gint32 result;
	GVariant* _reply;
	result = budgie_power_screen_get_brightness (self);
	_reply = g_variant_new_int32 (result);
	return _reply;
}

static GVariant*
budgie_power_screen_dbus_interface_get_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Brightness") == 0) {
		return _dbus_budgie_power_screen_get_brightness (object);
	}
	return NULL;
}

static void
_dbus_budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                          GVariant* _value)
{
	gint32 value = 0;
	value = g_variant_get_int32 (_value);
	budgie_power_screen_set_brightness (self, value);
}

static gboolean
budgie_power_screen_dbus_interface_set_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GVariant* value,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Brightness") == 0) {
		_dbus_budgie_power_screen_set_brightness (object, value);
		return TRUE;
	}
	return FALSE;
}

guint
budgie_power_screen_register_object (gpointer object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_budgie_power_screen_dbus_interface_info), &_budgie_power_screen_dbus_interface_vtable, data, _budgie_power_screen_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_budgie_power_screen_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

/**
* The button layout style as set in budgie
*/
static GType
budgie_button_position_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_BUTTON_POSITION_LEFT, "BUDGIE_BUTTON_POSITION_LEFT", "left"}, {BUDGIE_BUTTON_POSITION_TRADITIONAL, "BUDGIE_BUTTON_POSITION_TRADITIONAL", "traditional"}, {0, NULL, NULL}};
	GType budgie_button_position_type_id;
	budgie_button_position_type_id = g_enum_register_static ("BudgieButtonPosition", values);
	return budgie_button_position_type_id;
}

GType
budgie_button_position_get_type (void)
{
	static volatile gsize budgie_button_position_type_id__once = 0;
	if (g_once_init_enter (&budgie_button_position_type_id__once)) {
		GType budgie_button_position_type_id;
		budgie_button_position_type_id = budgie_button_position_get_type_once ();
		g_once_init_leave (&budgie_button_position_type_id__once, budgie_button_position_type_id);
	}
	return budgie_button_position_type_id__once;
}

static GType
budgie_color_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_COLOR_SCHEME_DEFAULT, "BUDGIE_COLOR_SCHEME_DEFAULT", "default"}, {BUDGIE_COLOR_SCHEME_PREFER_DARK, "BUDGIE_COLOR_SCHEME_PREFER_DARK", "prefer-dark"}, {BUDGIE_COLOR_SCHEME_PREFER_LIGHT, "BUDGIE_COLOR_SCHEME_PREFER_LIGHT", "prefer-light"}, {0, NULL, NULL}};
	GType budgie_color_scheme_type_id;
	budgie_color_scheme_type_id = g_enum_register_static ("BudgieColorScheme", values);
	return budgie_color_scheme_type_id;
}

GType
budgie_color_scheme_get_type (void)
{
	static volatile gsize budgie_color_scheme_type_id__once = 0;
	if (g_once_init_enter (&budgie_color_scheme_type_id__once)) {
		GType budgie_color_scheme_type_id;
		budgie_color_scheme_type_id = budgie_color_scheme_get_type_once ();
		g_once_init_leave (&budgie_color_scheme_type_id__once, budgie_color_scheme_type_id);
	}
	return budgie_color_scheme_type_id__once;
}

static inline gpointer
budgie_settings_manager_get_instance_private (BudgieSettingsManager* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieSettingsManager_private_offset);
}

static gint32*
_int32_dup (gint32* self)
{
	gint32* dup;
#line 61 "../src/daemon/settings.vala"
	dup = g_new0 (gint32, 1);
#line 61 "../src/daemon/settings.vala"
	memcpy (dup, self, sizeof (gint32));
#line 61 "../src/daemon/settings.vala"
	return dup;
#line 582 "settings.c"
}

static gpointer
__int32_dup0 (gpointer self)
{
#line 61 "../src/daemon/settings.vala"
	return self ? _int32_dup (self) : NULL;
#line 590 "settings.c"
}

static guint32*
_uint32_dup (guint32* self)
{
	guint32* dup;
#line 62 "../src/daemon/settings.vala"
	dup = g_new0 (guint32, 1);
#line 62 "../src/daemon/settings.vala"
	memcpy (dup, self, sizeof (guint32));
#line 62 "../src/daemon/settings.vala"
	return dup;
#line 603 "settings.c"
}

static gpointer
__uint32_dup0 (gpointer self)
{
#line 62 "../src/daemon/settings.vala"
	return self ? _uint32_dup (self) : NULL;
#line 611 "settings.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 63 "../src/daemon/settings.vala"
	dup = g_new0 (gboolean, 1);
#line 63 "../src/daemon/settings.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 63 "../src/daemon/settings.vala"
	return dup;
#line 624 "settings.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 63 "../src/daemon/settings.vala"
	return self ? _bool_dup (self) : NULL;
#line 632 "settings.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 64 "../src/daemon/settings.vala"
	dup = g_new0 (gint, 1);
#line 64 "../src/daemon/settings.vala"
	memcpy (dup, self, sizeof (gint));
#line 64 "../src/daemon/settings.vala"
	return dup;
#line 645 "settings.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 64 "../src/daemon/settings.vala"
	return self ? _int_dup (self) : NULL;
#line 653 "settings.c"
}

static void
_budgie_settings_manager_on_raven_sound_overdrive_change_g_settings_changed (GSettings* _sender,
                                                                             const gchar* key,
                                                                             gpointer self)
{
#line 99 "../src/daemon/settings.vala"
	budgie_settings_manager_on_raven_sound_overdrive_change ((BudgieSettingsManager*) self);
#line 663 "settings.c"
}

static void
__lambda68_ (BudgieSettingsManager* self,
             const gchar* key)
{
#line 102 "../src/daemon/settings.vala"
	g_return_if_fail (key != NULL);
#line 102 "../src/daemon/settings.vala"
	budgie_settings_manager_apply_dark_theme_pref (self);
#line 674 "settings.c"
}

static void
___lambda68__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 102 "../src/daemon/settings.vala"
	__lambda68_ ((BudgieSettingsManager*) self, key);
#line 684 "settings.c"
}

static void
_budgie_settings_manager_update_idle_delay_g_settings_changed (GSettings* _sender,
                                                               const gchar* key,
                                                               gpointer self)
{
#line 105 "../src/daemon/settings.vala"
	budgie_settings_manager_update_idle_delay ((BudgieSettingsManager*) self);
#line 694 "settings.c"
}

static void
_budgie_settings_manager_update_idle_dim_g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self)
{
#line 106 "../src/daemon/settings.vala"
	budgie_settings_manager_update_idle_dim ((BudgieSettingsManager*) self);
#line 704 "settings.c"
}

static void
_budgie_settings_manager_update_ac_timeout_g_settings_changed (GSettings* _sender,
                                                               const gchar* key,
                                                               gpointer self)
{
#line 107 "../src/daemon/settings.vala"
	budgie_settings_manager_update_ac_timeout ((BudgieSettingsManager*) self);
#line 714 "settings.c"
}

static void
_budgie_settings_manager_update_battery_timeout_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self)
{
#line 108 "../src/daemon/settings.vala"
	budgie_settings_manager_update_battery_timeout ((BudgieSettingsManager*) self);
#line 724 "settings.c"
}

static void
_budgie_settings_manager_on_wm_settings_changed_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self)
{
#line 110 "../src/daemon/settings.vala"
	budgie_settings_manager_on_wm_settings_changed ((BudgieSettingsManager*) self, key);
#line 734 "settings.c"
}

BudgieSettingsManager*
budgie_settings_manager_construct (GType object_type)
{
	BudgieSettingsManager* self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 75 "../src/daemon/settings.vala"
	self = (BudgieSettingsManager*) g_type_create_instance (object_type);
#line 76 "../src/daemon/settings.vala"
	budgie_settings_manager_set_supported_caffeine_icons (self);
#line 79 "../src/daemon/settings.vala"
	_tmp0_ = g_settings_new ("org.gnome.mutter");
#line 79 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->mutter_settings);
#line 79 "../src/daemon/settings.vala"
	self->priv->mutter_settings = _tmp0_;
#line 80 "../src/daemon/settings.vala"
	_tmp1_ = g_settings_new ("org.gnome.desktop.interface");
#line 80 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_desktop_settings);
#line 80 "../src/daemon/settings.vala"
	self->priv->gnome_desktop_settings = _tmp1_;
#line 81 "../src/daemon/settings.vala"
	_tmp2_ = g_settings_new ("org.gnome.settings-daemon.plugins.power");
#line 81 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_power_settings);
#line 81 "../src/daemon/settings.vala"
	self->priv->gnome_power_settings = _tmp2_;
#line 82 "../src/daemon/settings.vala"
	_tmp3_ = g_settings_new ("org.gnome.desktop.session");
#line 82 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_session_settings);
#line 82 "../src/daemon/settings.vala"
	self->priv->gnome_session_settings = _tmp3_;
#line 83 "../src/daemon/settings.vala"
	_tmp4_ = g_settings_new ("org.gnome.desktop.sound");
#line 83 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_sound_settings);
#line 83 "../src/daemon/settings.vala"
	self->priv->gnome_sound_settings = _tmp4_;
#line 84 "../src/daemon/settings.vala"
	_tmp5_ = g_settings_new ("org.gnome.desktop.wm.preferences");
#line 84 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_wm_settings);
#line 84 "../src/daemon/settings.vala"
	self->priv->gnome_wm_settings = _tmp5_;
#line 85 "../src/daemon/settings.vala"
	_tmp6_ = g_settings_new ("com.solus-project.budgie-panel");
#line 85 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->panel_settings);
#line 85 "../src/daemon/settings.vala"
	self->priv->panel_settings = _tmp6_;
#line 86 "../src/daemon/settings.vala"
	_tmp7_ = g_settings_new ("com.solus-project.budgie-raven");
#line 86 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 86 "../src/daemon/settings.vala"
	self->priv->raven_settings = _tmp7_;
#line 87 "../src/daemon/settings.vala"
	_tmp8_ = g_settings_new ("org.gnome.settings-daemon.plugins.xsettings");
#line 87 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->xoverrides);
#line 87 "../src/daemon/settings.vala"
	self->priv->xoverrides = _tmp8_;
#line 88 "../src/daemon/settings.vala"
	_tmp9_ = g_settings_new ("com.solus-project.budgie-wm");
#line 88 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->wm_settings);
#line 88 "../src/daemon/settings.vala"
	self->priv->wm_settings = _tmp9_;
#line 823 "settings.c"
	{
		BudgiePowerScreen* _tmp10_ = NULL;
		BudgiePowerScreen* _tmp11_;
		BudgiePowerScreen* _tmp12_;
#line 91 "../src/daemon/settings.vala"
		_tmp11_ = (BudgiePowerScreen*) g_initable_new (BUDGIE_TYPE_POWER_SCREEN_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.gnome.SettingsDaemon.Power", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SettingsDaemon/Power", "g-interface-name", "org.gnome.SettingsDaemon.Power.Screen", NULL);
#line 91 "../src/daemon/settings.vala"
		_tmp10_ = (BudgiePowerScreen*) _tmp11_;
#line 91 "../src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/daemon/settings.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 836 "settings.c"
				goto __catch0_g_io_error;
			}
#line 91 "../src/daemon/settings.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 91 "../src/daemon/settings.vala"
			return NULL;
#line 845 "settings.c"
		}
#line 91 "../src/daemon/settings.vala"
		_tmp12_ = _tmp10_;
#line 91 "../src/daemon/settings.vala"
		_tmp10_ = NULL;
#line 91 "../src/daemon/settings.vala"
		_g_object_unref0 (self->priv->gnome_power_props);
#line 91 "../src/daemon/settings.vala"
		self->priv->gnome_power_props = _tmp12_;
#line 90 "../src/daemon/settings.vala"
		_g_object_unref0 (_tmp10_);
#line 857 "settings.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 90 "../src/daemon/settings.vala"
		e = _inner_error0_;
#line 90 "../src/daemon/settings.vala"
		_inner_error0_ = NULL;
#line 93 "../src/daemon/settings.vala"
		_tmp13_ = e;
#line 93 "../src/daemon/settings.vala"
		_tmp14_ = _tmp13_->message;
#line 93 "../src/daemon/settings.vala"
		g_warning ("settings.vala:93: Failed to acquire bus for org.gnome.SettingsDaemon.P" \
"ower: %s\n", _tmp14_);
#line 90 "../src/daemon/settings.vala"
		_g_error_free0 (e);
#line 877 "settings.c"
	}
	__finally0:
#line 90 "../src/daemon/settings.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../src/daemon/settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../src/daemon/settings.vala"
		g_clear_error (&_inner_error0_);
#line 90 "../src/daemon/settings.vala"
		return NULL;
#line 888 "settings.c"
	}
#line 96 "../src/daemon/settings.vala"
	budgie_settings_manager_fetch_defaults (self);
#line 98 "../src/daemon/settings.vala"
	budgie_settings_manager_enforce_mutter_settings (self);
#line 99 "../src/daemon/settings.vala"
	_tmp15_ = self->priv->raven_settings;
#line 99 "../src/daemon/settings.vala"
	g_signal_connect (_tmp15_, "changed::allow-volume-overdrive", (GCallback) _budgie_settings_manager_on_raven_sound_overdrive_change_g_settings_changed, self);
#line 102 "../src/daemon/settings.vala"
	_tmp16_ = self->priv->panel_settings;
#line 102 "../src/daemon/settings.vala"
	g_signal_connect (_tmp16_, "changed::dark-theme", (GCallback) ___lambda68__g_settings_changed, self);
#line 103 "../src/daemon/settings.vala"
	budgie_settings_manager_apply_dark_theme_pref (self);
#line 105 "../src/daemon/settings.vala"
	_tmp17_ = self->priv->gnome_session_settings;
#line 105 "../src/daemon/settings.vala"
	g_signal_connect (_tmp17_, "changed::idle-delay", (GCallback) _budgie_settings_manager_update_idle_delay_g_settings_changed, self);
#line 106 "../src/daemon/settings.vala"
	_tmp18_ = self->priv->gnome_power_settings;
#line 106 "../src/daemon/settings.vala"
	g_signal_connect (_tmp18_, "changed::idle-dim", (GCallback) _budgie_settings_manager_update_idle_dim_g_settings_changed, self);
#line 107 "../src/daemon/settings.vala"
	_tmp19_ = self->priv->gnome_power_settings;
#line 107 "../src/daemon/settings.vala"
	g_signal_connect (_tmp19_, "changed::sleep-inactive-ac-timeout", (GCallback) _budgie_settings_manager_update_ac_timeout_g_settings_changed, self);
#line 108 "../src/daemon/settings.vala"
	_tmp20_ = self->priv->gnome_power_settings;
#line 108 "../src/daemon/settings.vala"
	g_signal_connect (_tmp20_, "changed::sleep-inactive-battery-timeout", (GCallback) _budgie_settings_manager_update_battery_timeout_g_settings_changed, self);
#line 110 "../src/daemon/settings.vala"
	_tmp21_ = self->priv->wm_settings;
#line 110 "../src/daemon/settings.vala"
	g_signal_connect (_tmp21_, "changed", (GCallback) _budgie_settings_manager_on_wm_settings_changed_g_settings_changed, self);
#line 111 "../src/daemon/settings.vala"
	budgie_settings_manager_on_wm_settings_changed (self, "button-style");
#line 75 "../src/daemon/settings.vala"
	return self;
#line 928 "settings.c"
}

BudgieSettingsManager*
budgie_settings_manager_new (void)
{
#line 75 "../src/daemon/settings.vala"
	return budgie_settings_manager_construct (BUDGIE_TYPE_SETTINGS_MANAGER);
#line 936 "settings.c"
}

/**
* caffeine_settings_sync will call to sync / ensure write operations for session and power, which are relevant to Caffeine Mode
*/
static void
budgie_settings_manager_caffeine_settings_sync (BudgieSettingsManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 117 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_session_settings;
#line 118 "../src/daemon/settings.vala"
	g_settings_apply (_tmp0_);
#line 119 "../src/daemon/settings.vala"
	_tmp1_ = self->priv->gnome_power_settings;
#line 119 "../src/daemon/settings.vala"
	g_settings_apply (_tmp1_);
#line 120 "../src/daemon/settings.vala"
	g_settings_sync ();
#line 121 "../src/daemon/settings.vala"
	g_settings_sync ();
#line 961 "settings.c"
}

/**
* change_brightness will attempt to change our brightness in the power properties
*/
static void
budgie_settings_manager_change_brightness (BudgieSettingsManager* self,
                                           gint32 value)
{
	BudgiePowerScreen* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 127 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_power_props;
#line 128 "../src/daemon/settings.vala"
	if (_tmp0_ != NULL) {
#line 979 "settings.c"
		{
			BudgiePowerScreen* _tmp1_;
#line 130 "../src/daemon/settings.vala"
			_tmp1_ = self->priv->gnome_power_props;
#line 130 "../src/daemon/settings.vala"
			budgie_power_screen_set_brightness (_tmp1_, value);
#line 986 "settings.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 129 "../src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 132 "../src/daemon/settings.vala"
			g_warning ("settings.vala:132: Error: Failed to change change the brightness durin" \
"g Caffeine Mode toggle.");
#line 995 "settings.c"
		}
		__finally0:
#line 129 "../src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../src/daemon/settings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 129 "../src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 129 "../src/daemon/settings.vala"
			return;
#line 1006 "settings.c"
		}
	}
}

/**
* do_disable is triggered when our timeout is called
*/
static gboolean
budgie_settings_manager_do_disable (BudgieSettingsManager* self)
{
	gboolean result;
#line 140 "../src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 141 "../src/daemon/settings.vala"
	if (budgie_settings_manager_get_caffeine_mode (self)) {
#line 1022 "settings.c"
		GSettings* _tmp0_;
#line 142 "../src/daemon/settings.vala"
		_tmp0_ = self->priv->wm_settings;
#line 142 "../src/daemon/settings.vala"
		g_settings_set_boolean (_tmp0_, "caffeine-mode", FALSE);
#line 143 "../src/daemon/settings.vala"
		g_settings_sync ();
#line 144 "../src/daemon/settings.vala"
		budgie_settings_manager_reset_values (self);
#line 1032 "settings.c"
	}
#line 147 "../src/daemon/settings.vala"
	result = FALSE;
#line 147 "../src/daemon/settings.vala"
	return result;
#line 1038 "settings.c"
}

/**
* do_disable_quietly will quietly disable Caffeine Mode
*/
void
budgie_settings_manager_do_disable_quietly (BudgieSettingsManager* self)
{
	GSettings* _tmp0_;
#line 153 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/daemon/settings.vala"
	self->priv->temporary_notification_disabled = TRUE;
#line 155 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->wm_settings;
#line 155 "../src/daemon/settings.vala"
	g_settings_set_boolean (_tmp0_, "caffeine-mode", FALSE);
#line 156 "../src/daemon/settings.vala"
	g_settings_sync ();
#line 157 "../src/daemon/settings.vala"
	budgie_settings_manager_reset_values (self);
#line 1060 "settings.c"
}

/**
* enforce_mutter_settings will apply Mutter schema changes to BudgieWM for supported keys
*/
static void
budgie_settings_manager_enforce_mutter_settings (BudgieSettingsManager* self)
{
	gboolean center_windows = FALSE;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 163 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->mutter_settings;
#line 164 "../src/daemon/settings.vala"
	center_windows = g_settings_get_boolean (_tmp0_, "center-new-windows");
#line 165 "../src/daemon/settings.vala"
	_tmp1_ = self->priv->wm_settings;
#line 165 "../src/daemon/settings.vala"
	g_settings_set_boolean (_tmp1_, "center-windows", center_windows);
#line 1082 "settings.c"
}

/**
* fetch_defaults will fetch the default values for various idle, sleep, and brightness settings
*/
static void
budgie_settings_manager_fetch_defaults (BudgieSettingsManager* self)
{
	BudgiePowerScreen* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 172 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/daemon/settings.vala"
	if (budgie_settings_manager_get_caffeine_mode (self)) {
#line 1097 "settings.c"
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
#line 174 "../src/daemon/settings.vala"
		_tmp0_ = self->priv->gnome_session_settings;
#line 174 "../src/daemon/settings.vala"
		g_settings_reset (_tmp0_, "idle-delay");
#line 175 "../src/daemon/settings.vala"
		_tmp1_ = self->priv->gnome_power_settings;
#line 175 "../src/daemon/settings.vala"
		g_settings_reset (_tmp1_, "idle-dim");
#line 176 "../src/daemon/settings.vala"
		_tmp2_ = self->priv->gnome_power_settings;
#line 176 "../src/daemon/settings.vala"
		g_settings_reset (_tmp2_, "sleep-inactive-ac-timeout");
#line 177 "../src/daemon/settings.vala"
		_tmp3_ = self->priv->gnome_power_settings;
#line 177 "../src/daemon/settings.vala"
		g_settings_reset (_tmp3_, "sleep-inactive-battery-timeout");
#line 178 "../src/daemon/settings.vala"
		budgie_settings_manager_caffeine_settings_sync (self);
#line 180 "../src/daemon/settings.vala"
		self->priv->temporary_notification_disabled = TRUE;
#line 181 "../src/daemon/settings.vala"
		_tmp4_ = self->priv->wm_settings;
#line 181 "../src/daemon/settings.vala"
		g_settings_set_boolean (_tmp4_, "caffeine-mode", FALSE);
#line 182 "../src/daemon/settings.vala"
		g_settings_sync ();
#line 1129 "settings.c"
	}
#line 185 "../src/daemon/settings.vala"
	budgie_settings_manager_get_power_defaults (self);
#line 187 "../src/daemon/settings.vala"
	_tmp5_ = self->priv->gnome_power_props;
#line 187 "../src/daemon/settings.vala"
	if (_tmp5_ != NULL) {
#line 1137 "settings.c"
		{
			BudgiePowerScreen* _tmp6_;
			gint32 _tmp7_;
			gint32 _tmp8_;
			gint32* _tmp9_;
#line 189 "../src/daemon/settings.vala"
			_tmp6_ = self->priv->gnome_power_props;
#line 189 "../src/daemon/settings.vala"
			_tmp7_ = budgie_power_screen_get_brightness (_tmp6_);
#line 189 "../src/daemon/settings.vala"
			_tmp8_ = _tmp7_;
#line 189 "../src/daemon/settings.vala"
			_tmp9_ = __int32_dup0 (&_tmp8_);
#line 189 "../src/daemon/settings.vala"
			_g_free0 (self->priv->default_brightness);
#line 189 "../src/daemon/settings.vala"
			self->priv->default_brightness = _tmp9_;
#line 1155 "settings.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 188 "../src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 191 "../src/daemon/settings.vala"
			g_warning ("settings.vala:191: Could not set default value.");
#line 1164 "settings.c"
		}
		__finally0:
#line 188 "../src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/daemon/settings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 188 "../src/daemon/settings.vala"
			return;
#line 1175 "settings.c"
		}
	}
}

/**
* get_caffeine_mode will get the current Caffeine Mode status
*/
static gboolean
budgie_settings_manager_get_caffeine_mode (BudgieSettingsManager* self)
{
	GSettings* _tmp0_;
	gboolean result;
#line 199 "../src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 200 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->wm_settings;
#line 200 "../src/daemon/settings.vala"
	result = g_settings_get_boolean (_tmp0_, "caffeine-mode");
#line 200 "../src/daemon/settings.vala"
	return result;
#line 1196 "settings.c"
}

/**
* get_power_defaults will call all of our update defaults functions
*/
static void
budgie_settings_manager_get_power_defaults (BudgieSettingsManager* self)
{
#line 206 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/daemon/settings.vala"
	budgie_settings_manager_update_ac_timeout (self);
#line 208 "../src/daemon/settings.vala"
	budgie_settings_manager_update_battery_timeout (self);
#line 209 "../src/daemon/settings.vala"
	budgie_settings_manager_update_idle_delay (self);
#line 210 "../src/daemon/settings.vala"
	budgie_settings_manager_update_idle_dim (self);
#line 1215 "settings.c"
}

/**
* Create a new xsettings override based on the *Existing* key so that
* we don't dump any settings like Gdk/ScaleFactor, etc.
*/
static GVariant*
budgie_settings_manager_new_filtered_xsetting (BudgieSettingsManager* self,
                                               const gchar* button_layout)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GVariantBuilder* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariantBuilder* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* existing_vars = NULL;
	GSettings* _tmp10_;
	GVariant* _tmp11_;
	GVariantIter* it = NULL;
	GVariant* _tmp12_;
	GVariantIter* _tmp13_;
	gchar* k = NULL;
	GVariant* v = NULL;
	GVariantBuilder* _tmp21_;
	GVariant* _tmp22_;
	GVariant* result;
#line 217 "../src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 217 "../src/daemon/settings.vala"
	g_return_val_if_fail (button_layout != NULL, NULL);
#line 219 "../src/daemon/settings.vala"
	_tmp0_ = g_variant_type_new ("a{sv}");
#line 219 "../src/daemon/settings.vala"
	_tmp1_ = _tmp0_;
#line 219 "../src/daemon/settings.vala"
	_tmp2_ = g_variant_builder_new (_tmp1_);
#line 219 "../src/daemon/settings.vala"
	_tmp3_ = _tmp2_;
#line 219 "../src/daemon/settings.vala"
	_g_variant_type_free0 (_tmp1_);
#line 219 "../src/daemon/settings.vala"
	builder = _tmp3_;
#line 220 "../src/daemon/settings.vala"
	_tmp4_ = builder;
#line 220 "../src/daemon/settings.vala"
	_tmp5_ = g_variant_new_int32 ((gint32) 0);
#line 220 "../src/daemon/settings.vala"
	g_variant_ref_sink (_tmp5_);
#line 220 "../src/daemon/settings.vala"
	_tmp6_ = _tmp5_;
#line 220 "../src/daemon/settings.vala"
	g_variant_builder_add (_tmp4_, "{sv}", "Gtk/ShellShowsAppMenu", _tmp6_, NULL);
#line 220 "../src/daemon/settings.vala"
	_g_variant_unref0 (_tmp6_);
#line 221 "../src/daemon/settings.vala"
	_tmp7_ = builder;
#line 221 "../src/daemon/settings.vala"
	_tmp8_ = g_variant_new_string (button_layout);
#line 221 "../src/daemon/settings.vala"
	g_variant_ref_sink (_tmp8_);
#line 221 "../src/daemon/settings.vala"
	_tmp9_ = _tmp8_;
#line 221 "../src/daemon/settings.vala"
	g_variant_builder_add (_tmp7_, "{sv}", "Gtk/DecorationLayout", _tmp9_, NULL);
#line 221 "../src/daemon/settings.vala"
	_g_variant_unref0 (_tmp9_);
#line 223 "../src/daemon/settings.vala"
	_tmp10_ = self->priv->xoverrides;
#line 223 "../src/daemon/settings.vala"
	_tmp11_ = g_settings_get_value (_tmp10_, "overrides");
#line 223 "../src/daemon/settings.vala"
	existing_vars = _tmp11_;
#line 224 "../src/daemon/settings.vala"
	_tmp12_ = existing_vars;
#line 224 "../src/daemon/settings.vala"
	_tmp13_ = g_variant_iter_new (_tmp12_);
#line 224 "../src/daemon/settings.vala"
	it = _tmp13_;
#line 225 "../src/daemon/settings.vala"
	k = NULL;
#line 226 "../src/daemon/settings.vala"
	v = NULL;
#line 227 "../src/daemon/settings.vala"
	while (TRUE) {
#line 1306 "settings.c"
		GVariantIter* _tmp14_;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
		GVariantBuilder* _tmp18_;
		const gchar* _tmp19_;
		GVariant* _tmp20_;
#line 227 "../src/daemon/settings.vala"
		_tmp14_ = it;
#line 227 "../src/daemon/settings.vala"
		if (!g_variant_iter_next (_tmp14_, "{sv}", &k, &v, NULL)) {
#line 227 "../src/daemon/settings.vala"
			break;
#line 1319 "settings.c"
		}
#line 228 "../src/daemon/settings.vala"
		_tmp16_ = k;
#line 228 "../src/daemon/settings.vala"
		if (g_strcmp0 (_tmp16_, "Gtk/ShellShowsAppMenu") == 0) {
#line 228 "../src/daemon/settings.vala"
			_tmp15_ = TRUE;
#line 1327 "settings.c"
		} else {
			const gchar* _tmp17_;
#line 228 "../src/daemon/settings.vala"
			_tmp17_ = k;
#line 228 "../src/daemon/settings.vala"
			_tmp15_ = g_strcmp0 (_tmp17_, "Gtk/DecorationLayout") == 0;
#line 1334 "settings.c"
		}
#line 228 "../src/daemon/settings.vala"
		if (_tmp15_) {
#line 229 "../src/daemon/settings.vala"
			continue;
#line 1340 "settings.c"
		}
#line 231 "../src/daemon/settings.vala"
		_tmp18_ = builder;
#line 231 "../src/daemon/settings.vala"
		_tmp19_ = k;
#line 231 "../src/daemon/settings.vala"
		_tmp20_ = v;
#line 231 "../src/daemon/settings.vala"
		g_variant_builder_add (_tmp18_, "{sv}", _tmp19_, _tmp20_, NULL);
#line 1350 "settings.c"
	}
#line 233 "../src/daemon/settings.vala"
	_tmp21_ = builder;
#line 233 "../src/daemon/settings.vala"
	_tmp22_ = g_variant_builder_end (_tmp21_);
#line 233 "../src/daemon/settings.vala"
	g_variant_ref_sink (_tmp22_);
#line 233 "../src/daemon/settings.vala"
	result = _tmp22_;
#line 233 "../src/daemon/settings.vala"
	_g_variant_unref0 (v);
#line 233 "../src/daemon/settings.vala"
	_g_free0 (k);
#line 233 "../src/daemon/settings.vala"
	_g_variant_iter_free0 (it);
#line 233 "../src/daemon/settings.vala"
	_g_variant_unref0 (existing_vars);
#line 233 "../src/daemon/settings.vala"
	_g_variant_builder_unref0 (builder);
#line 233 "../src/daemon/settings.vala"
	return result;
#line 1372 "settings.c"
}

static void
budgie_settings_manager_on_raven_sound_overdrive_change (BudgieSettingsManager* self)
{
	gboolean allow_volume_overdrive = FALSE;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 236 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->raven_settings;
#line 237 "../src/daemon/settings.vala"
	allow_volume_overdrive = g_settings_get_boolean (_tmp0_, "allow-volume-overdrive");
#line 238 "../src/daemon/settings.vala"
	_tmp1_ = self->priv->gnome_sound_settings;
#line 238 "../src/daemon/settings.vala"
	g_settings_set_boolean (_tmp1_, "allow-volume-above-100-percent", allow_volume_overdrive);
#line 1391 "settings.c"
}

static void
budgie_settings_manager_on_wm_settings_changed (BudgieSettingsManager* self,
                                                const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 242 "../src/daemon/settings.vala"
	static GQuark _tmp1_label0 = 0;
#line 242 "../src/daemon/settings.vala"
	static GQuark _tmp1_label1 = 0;
#line 242 "../src/daemon/settings.vala"
	static GQuark _tmp1_label2 = 0;
#line 242 "../src/daemon/settings.vala"
	static GQuark _tmp1_label3 = 0;
#line 242 "../src/daemon/settings.vala"
	static GQuark _tmp1_label4 = 0;
#line 242 "../src/daemon/settings.vala"
	static GQuark _tmp1_label5 = 0;
#line 241 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/daemon/settings.vala"
	g_return_if_fail (key != NULL);
#line 242 "../src/daemon/settings.vala"
	_tmp0_ = key;
#line 242 "../src/daemon/settings.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 242 "../src/daemon/settings.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("attach-modal-dialogs")))) {
#line 242 "../src/daemon/settings.vala"
		switch (0) {
#line 1424 "settings.c"
			default:
			{
				gboolean attach = FALSE;
				GSettings* _tmp3_;
				GSettings* _tmp4_;
#line 244 "../src/daemon/settings.vala"
				_tmp3_ = self->priv->wm_settings;
#line 244 "../src/daemon/settings.vala"
				attach = g_settings_get_boolean (_tmp3_, key);
#line 245 "../src/daemon/settings.vala"
				_tmp4_ = self->priv->mutter_settings;
#line 245 "../src/daemon/settings.vala"
				g_settings_set_boolean (_tmp4_, "attach-modal-dialogs", attach);
#line 246 "../src/daemon/settings.vala"
				break;
#line 1440 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("button-style")))) {
#line 242 "../src/daemon/settings.vala"
		switch (0) {
#line 1446 "settings.c"
			default:
			{
				BudgieButtonPosition style = 0;
				GSettings* _tmp5_;
#line 248 "../src/daemon/settings.vala"
				_tmp5_ = self->priv->wm_settings;
#line 248 "../src/daemon/settings.vala"
				style = (BudgieButtonPosition) g_settings_get_enum (_tmp5_, key);
#line 249 "../src/daemon/settings.vala"
				budgie_settings_manager_set_button_style (self, style);
#line 250 "../src/daemon/settings.vala"
				break;
#line 1459 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("center-windows")))) {
#line 242 "../src/daemon/settings.vala"
		switch (0) {
#line 1465 "settings.c"
			default:
			{
				gboolean center = FALSE;
				GSettings* _tmp6_;
				GSettings* _tmp7_;
#line 252 "../src/daemon/settings.vala"
				_tmp6_ = self->priv->wm_settings;
#line 252 "../src/daemon/settings.vala"
				center = g_settings_get_boolean (_tmp6_, key);
#line 253 "../src/daemon/settings.vala"
				_tmp7_ = self->priv->mutter_settings;
#line 253 "../src/daemon/settings.vala"
				g_settings_set_boolean (_tmp7_, "center-new-windows", center);
#line 254 "../src/daemon/settings.vala"
				break;
#line 1481 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("caffeine-mode")))) {
#line 242 "../src/daemon/settings.vala"
		switch (0) {
#line 1487 "settings.c"
			default:
			{
				gboolean enabled = FALSE;
				GSettings* _tmp8_;
#line 256 "../src/daemon/settings.vala"
				_tmp8_ = self->priv->wm_settings;
#line 256 "../src/daemon/settings.vala"
				enabled = g_settings_get_boolean (_tmp8_, key);
#line 257 "../src/daemon/settings.vala"
				budgie_settings_manager_set_caffeine_mode (self, enabled, FALSE);
#line 258 "../src/daemon/settings.vala"
				break;
#line 1500 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("edge-tiling")))) {
#line 242 "../src/daemon/settings.vala"
		switch (0) {
#line 1506 "settings.c"
			default:
			{
				gboolean edge_setting = FALSE;
				GSettings* _tmp9_;
				GSettings* _tmp10_;
#line 260 "../src/daemon/settings.vala"
				_tmp9_ = self->priv->wm_settings;
#line 260 "../src/daemon/settings.vala"
				edge_setting = g_settings_get_boolean (_tmp9_, key);
#line 261 "../src/daemon/settings.vala"
				_tmp10_ = self->priv->mutter_settings;
#line 261 "../src/daemon/settings.vala"
				g_settings_set_boolean (_tmp10_, "edge-tiling", edge_setting);
#line 262 "../src/daemon/settings.vala"
				break;
#line 1522 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("focus-mode")))) {
#line 242 "../src/daemon/settings.vala"
		switch (0) {
#line 1528 "settings.c"
			default:
			{
				gboolean mode = FALSE;
				GSettings* _tmp11_;
#line 264 "../src/daemon/settings.vala"
				_tmp11_ = self->priv->wm_settings;
#line 264 "../src/daemon/settings.vala"
				mode = g_settings_get_boolean (_tmp11_, key);
#line 265 "../src/daemon/settings.vala"
				budgie_settings_manager_set_focus_mode (self, mode);
#line 266 "../src/daemon/settings.vala"
				break;
#line 1541 "settings.c"
			}
		}
	} else {
#line 242 "../src/daemon/settings.vala"
		switch (0) {
#line 1547 "settings.c"
			default:
			{
#line 268 "../src/daemon/settings.vala"
				break;
#line 1552 "settings.c"
			}
		}
	}
}

/**
* reset_values will reset select power and session keys
*/
static void
budgie_settings_manager_reset_values (BudgieSettingsManager* self)
{
	GSettings* _tmp0_;
	guint32* _tmp1_;
	GSettings* _tmp2_;
	gboolean* _tmp3_;
	GSettings* _tmp4_;
	gint* _tmp5_;
	GSettings* _tmp6_;
	gint* _tmp7_;
#line 275 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_session_settings;
#line 276 "../src/daemon/settings.vala"
	_tmp1_ = self->priv->default_idle_delay;
#line 276 "../src/daemon/settings.vala"
	g_settings_set_uint (_tmp0_, "idle-delay", *_tmp1_);
#line 277 "../src/daemon/settings.vala"
	_tmp2_ = self->priv->gnome_power_settings;
#line 277 "../src/daemon/settings.vala"
	_tmp3_ = self->priv->default_idle_dim;
#line 277 "../src/daemon/settings.vala"
	g_settings_set_boolean (_tmp2_, "idle-dim", *_tmp3_);
#line 278 "../src/daemon/settings.vala"
	_tmp4_ = self->priv->gnome_power_settings;
#line 278 "../src/daemon/settings.vala"
	_tmp5_ = self->priv->default_sleep_inactive_ac_timeout;
#line 278 "../src/daemon/settings.vala"
	g_settings_set_int (_tmp4_, "sleep-inactive-ac-timeout", *_tmp5_);
#line 279 "../src/daemon/settings.vala"
	_tmp6_ = self->priv->gnome_power_settings;
#line 279 "../src/daemon/settings.vala"
	_tmp7_ = self->priv->default_sleep_inactive_battery_timeout;
#line 279 "../src/daemon/settings.vala"
	g_settings_set_int (_tmp6_, "sleep-inactive-battery-timeout", *_tmp7_);
#line 280 "../src/daemon/settings.vala"
	budgie_settings_manager_caffeine_settings_sync (self);
#line 1600 "settings.c"
}

/**
* Set the button layout to one of left or traditional
*/
static GVariant*
_variant_new2 (const gchar* value)
{
#line 304 "../src/daemon/settings.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1611 "settings.c"
}

static void
budgie_settings_manager_set_button_style (BudgieSettingsManager* self,
                                          BudgieButtonPosition style)
{
	GVariant* xset = NULL;
	gchar* wm_set = NULL;
	GSettings* _tmp4_;
	GVariant* _tmp5_;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
	GSettings* _tmp8_;
	const gchar* _tmp9_;
	GVariant* _tmp10_;
#line 286 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/daemon/settings.vala"
	xset = NULL;
#line 288 "../src/daemon/settings.vala"
	wm_set = NULL;
#line 290 "../src/daemon/settings.vala"
	switch (style) {
#line 290 "../src/daemon/settings.vala"
		case BUDGIE_BUTTON_POSITION_LEFT:
#line 1637 "settings.c"
		{
			GVariant* _tmp0_;
			gchar* _tmp1_;
#line 292 "../src/daemon/settings.vala"
			_tmp0_ = budgie_settings_manager_new_filtered_xsetting (self, "close,minimize,maximize:menu");
#line 292 "../src/daemon/settings.vala"
			_g_variant_unref0 (xset);
#line 292 "../src/daemon/settings.vala"
			xset = _tmp0_;
#line 293 "../src/daemon/settings.vala"
			_tmp1_ = g_strdup ("close,minimize,maximize:appmenu");
#line 293 "../src/daemon/settings.vala"
			_g_free0 (wm_set);
#line 293 "../src/daemon/settings.vala"
			wm_set = _tmp1_;
#line 294 "../src/daemon/settings.vala"
			break;
#line 1655 "settings.c"
		}
		default:
#line 290 "../src/daemon/settings.vala"
		case BUDGIE_BUTTON_POSITION_TRADITIONAL:
#line 1660 "settings.c"
		{
			GVariant* _tmp2_;
			gchar* _tmp3_;
#line 297 "../src/daemon/settings.vala"
			_tmp2_ = budgie_settings_manager_new_filtered_xsetting (self, "menu:minimize,maximize,close");
#line 297 "../src/daemon/settings.vala"
			_g_variant_unref0 (xset);
#line 297 "../src/daemon/settings.vala"
			xset = _tmp2_;
#line 298 "../src/daemon/settings.vala"
			_tmp3_ = g_strdup ("appmenu:minimize,maximize,close");
#line 298 "../src/daemon/settings.vala"
			_g_free0 (wm_set);
#line 298 "../src/daemon/settings.vala"
			wm_set = _tmp3_;
#line 299 "../src/daemon/settings.vala"
			break;
#line 1678 "settings.c"
		}
	}
#line 302 "../src/daemon/settings.vala"
	_tmp4_ = self->priv->xoverrides;
#line 302 "../src/daemon/settings.vala"
	_tmp5_ = xset;
#line 302 "../src/daemon/settings.vala"
	g_settings_set_value (_tmp4_, "overrides", _tmp5_);
#line 303 "../src/daemon/settings.vala"
	_tmp6_ = self->priv->wm_settings;
#line 303 "../src/daemon/settings.vala"
	_tmp7_ = wm_set;
#line 303 "../src/daemon/settings.vala"
	g_settings_set_string (_tmp6_, "button-layout", _tmp7_);
#line 304 "../src/daemon/settings.vala"
	_tmp8_ = self->priv->gnome_wm_settings;
#line 304 "../src/daemon/settings.vala"
	_tmp9_ = wm_set;
#line 304 "../src/daemon/settings.vala"
	_tmp10_ = _variant_new2 (_tmp9_);
#line 304 "../src/daemon/settings.vala"
	g_settings_set_value (_tmp8_, "button-layout", _tmp10_);
#line 304 "../src/daemon/settings.vala"
	_g_variant_unref0 (_tmp10_);
#line 286 "../src/daemon/settings.vala"
	_g_free0 (wm_set);
#line 286 "../src/daemon/settings.vala"
	_g_variant_unref0 (xset);
#line 1707 "settings.c"
}

/**
* set_caffeine_mode will set our various settings for caffeine mode
*/
static gboolean
____lambda69_ (BudgieSettingsManager* self)
{
	gboolean _tmp0_ = FALSE;
	GSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 320 "../src/daemon/settings.vala"
	_tmp1_ = self->priv->gnome_session_settings;
#line 320 "../src/daemon/settings.vala"
	_tmp2_ = g_settings_get_has_unapplied (_tmp1_);
#line 320 "../src/daemon/settings.vala"
	_tmp3_ = _tmp2_;
#line 320 "../src/daemon/settings.vala"
	if (!_tmp3_) {
#line 1729 "settings.c"
		GSettings* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 320 "../src/daemon/settings.vala"
		_tmp4_ = self->priv->gnome_power_settings;
#line 320 "../src/daemon/settings.vala"
		_tmp5_ = g_settings_get_has_unapplied (_tmp4_);
#line 320 "../src/daemon/settings.vala"
		_tmp6_ = _tmp5_;
#line 320 "../src/daemon/settings.vala"
		_tmp0_ = !_tmp6_;
#line 1741 "settings.c"
	} else {
#line 320 "../src/daemon/settings.vala"
		_tmp0_ = FALSE;
#line 1745 "settings.c"
	}
#line 320 "../src/daemon/settings.vala"
	if (_tmp0_) {
#line 321 "../src/daemon/settings.vala"
		budgie_settings_manager_reset_values (self);
#line 322 "../src/daemon/settings.vala"
		result = FALSE;
#line 322 "../src/daemon/settings.vala"
		return result;
#line 1755 "settings.c"
	} else {
#line 324 "../src/daemon/settings.vala"
		result = TRUE;
#line 324 "../src/daemon/settings.vala"
		return result;
#line 1761 "settings.c"
	}
}

static gboolean
_____lambda69__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda69_ ((BudgieSettingsManager*) self);
#line 319 "../src/daemon/settings.vala"
	return result;
#line 1772 "settings.c"
}

static gboolean
_budgie_settings_manager_do_disable_gsource_func (gpointer self)
{
	gboolean result;
	result = budgie_settings_manager_do_disable ((BudgieSettingsManager*) self);
#line 339 "../src/daemon/settings.vala"
	return result;
#line 1782 "settings.c"
}

static gboolean
___lambda70_ (BudgieSettingsManager* self)
{
	gint countdown = 0;
	GSettings* _tmp0_;
	gboolean result;
#line 341 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->wm_settings;
#line 341 "../src/daemon/settings.vala"
	countdown = g_settings_get_int (_tmp0_, "caffeine-mode-timer");
#line 342 "../src/daemon/settings.vala"
	if (countdown != 0) {
#line 1797 "settings.c"
		GSettings* _tmp1_;
#line 343 "../src/daemon/settings.vala"
		countdown -= 1;
#line 344 "../src/daemon/settings.vala"
		_tmp1_ = self->priv->wm_settings;
#line 344 "../src/daemon/settings.vala"
		g_settings_set_int (_tmp1_, "caffeine-mode-timer", countdown);
#line 1805 "settings.c"
	}
#line 347 "../src/daemon/settings.vala"
	result = countdown != 0;
#line 347 "../src/daemon/settings.vala"
	return result;
#line 1811 "settings.c"
}

static gboolean
____lambda70__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda70_ ((BudgieSettingsManager*) self);
#line 340 "../src/daemon/settings.vala"
	return result;
#line 1821 "settings.c"
}

static gboolean
___lambda71_ (BudgieSettingsManager* self)
{
	gboolean result;
#line 382 "../src/daemon/settings.vala"
	self->priv->temporary_notification_disabled = FALSE;
#line 383 "../src/daemon/settings.vala"
	result = FALSE;
#line 383 "../src/daemon/settings.vala"
	return result;
#line 1834 "settings.c"
}

static gboolean
____lambda71__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda71_ ((BudgieSettingsManager*) self);
#line 381 "../src/daemon/settings.vala"
	return result;
#line 1844 "settings.c"
}

static void
budgie_settings_manager_set_caffeine_mode (BudgieSettingsManager* self,
                                           gboolean enabled,
                                           gboolean disable_notification)
{
	GSettings* _tmp11_;
	gint time = 0;
	GSettings* _tmp15_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	GSettings* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 310 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/daemon/settings.vala"
	if (enabled) {
#line 1865 "settings.c"
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
#line 312 "../src/daemon/settings.vala"
		_tmp0_ = self->priv->gnome_power_settings;
#line 312 "../src/daemon/settings.vala"
		g_settings_set_boolean (_tmp0_, "idle-dim", FALSE);
#line 313 "../src/daemon/settings.vala"
		_tmp1_ = self->priv->gnome_power_settings;
#line 313 "../src/daemon/settings.vala"
		g_settings_set_int (_tmp1_, "sleep-inactive-ac-timeout", 0);
#line 314 "../src/daemon/settings.vala"
		_tmp2_ = self->priv->gnome_power_settings;
#line 314 "../src/daemon/settings.vala"
		g_settings_set_int (_tmp2_, "sleep-inactive-battery-timeout", 0);
#line 315 "../src/daemon/settings.vala"
		_tmp3_ = self->priv->gnome_session_settings;
#line 315 "../src/daemon/settings.vala"
		g_settings_set_uint (_tmp3_, "idle-delay", (guint) 0);
#line 316 "../src/daemon/settings.vala"
		budgie_settings_manager_caffeine_settings_sync (self);
#line 1888 "settings.c"
	} else {
		gboolean _tmp4_ = FALSE;
		GSettings* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 318 "../src/daemon/settings.vala"
		_tmp5_ = self->priv->gnome_session_settings;
#line 318 "../src/daemon/settings.vala"
		_tmp6_ = g_settings_get_has_unapplied (_tmp5_);
#line 318 "../src/daemon/settings.vala"
		_tmp7_ = _tmp6_;
#line 318 "../src/daemon/settings.vala"
		if (_tmp7_) {
#line 318 "../src/daemon/settings.vala"
			_tmp4_ = TRUE;
#line 1904 "settings.c"
		} else {
			GSettings* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 318 "../src/daemon/settings.vala"
			_tmp8_ = self->priv->gnome_power_settings;
#line 318 "../src/daemon/settings.vala"
			_tmp9_ = g_settings_get_has_unapplied (_tmp8_);
#line 318 "../src/daemon/settings.vala"
			_tmp10_ = _tmp9_;
#line 318 "../src/daemon/settings.vala"
			_tmp4_ = _tmp10_;
#line 1917 "settings.c"
		}
#line 318 "../src/daemon/settings.vala"
		if (_tmp4_) {
#line 319 "../src/daemon/settings.vala"
			g_timeout_add_seconds_full (G_PRIORITY_HIGH, (guint) 1, _____lambda69__gsource_func, budgie_settings_manager_ref (self), budgie_settings_manager_unref);
#line 1923 "settings.c"
		} else {
#line 328 "../src/daemon/settings.vala"
			budgie_settings_manager_reset_values (self);
#line 1927 "settings.c"
		}
	}
#line 332 "../src/daemon/settings.vala"
	_tmp11_ = self->priv->wm_settings;
#line 332 "../src/daemon/settings.vala"
	if (g_settings_get_boolean (_tmp11_, "caffeine-mode-toggle-brightness")) {
#line 1934 "settings.c"
		gint32 set_brightness = 0;
		GSettings* _tmp12_;
		gint32 _tmp13_ = 0;
#line 333 "../src/daemon/settings.vala"
		_tmp12_ = self->priv->wm_settings;
#line 333 "../src/daemon/settings.vala"
		set_brightness = (gint32) g_settings_get_int (_tmp12_, "caffeine-mode-screen-brightness");
#line 334 "../src/daemon/settings.vala"
		if (enabled) {
#line 334 "../src/daemon/settings.vala"
			_tmp13_ = set_brightness;
#line 1946 "settings.c"
		} else {
			gint32* _tmp14_;
#line 334 "../src/daemon/settings.vala"
			_tmp14_ = self->priv->default_brightness;
#line 334 "../src/daemon/settings.vala"
			_tmp13_ = *_tmp14_;
#line 1953 "settings.c"
		}
#line 334 "../src/daemon/settings.vala"
		budgie_settings_manager_change_brightness (self, _tmp13_);
#line 1957 "settings.c"
	}
#line 337 "../src/daemon/settings.vala"
	_tmp15_ = self->priv->wm_settings;
#line 337 "../src/daemon/settings.vala"
	time = g_settings_get_int (_tmp15_, "caffeine-mode-timer");
#line 338 "../src/daemon/settings.vala"
	if (enabled) {
#line 338 "../src/daemon/settings.vala"
		_tmp16_ = time > 0;
#line 1967 "settings.c"
	} else {
#line 338 "../src/daemon/settings.vala"
		_tmp16_ = FALSE;
#line 1971 "settings.c"
	}
#line 338 "../src/daemon/settings.vala"
	if (_tmp16_) {
#line 339 "../src/daemon/settings.vala"
		g_timeout_add_seconds_full (G_PRIORITY_HIGH, (guint) (time * 60), _budgie_settings_manager_do_disable_gsource_func, budgie_settings_manager_ref (self), budgie_settings_manager_unref);
#line 340 "../src/daemon/settings.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 60, ____lambda70__gsource_func, budgie_settings_manager_ref (self), budgie_settings_manager_unref);
#line 1979 "settings.c"
	}
#line 351 "../src/daemon/settings.vala"
	_tmp20_ = self->priv->wm_settings;
#line 351 "../src/daemon/settings.vala"
	if (g_settings_get_boolean (_tmp20_, "caffeine-mode-notification")) {
#line 351 "../src/daemon/settings.vala"
		_tmp19_ = !disable_notification;
#line 1987 "settings.c"
	} else {
#line 351 "../src/daemon/settings.vala"
		_tmp19_ = FALSE;
#line 1991 "settings.c"
	}
#line 351 "../src/daemon/settings.vala"
	if (_tmp19_) {
#line 351 "../src/daemon/settings.vala"
		_tmp18_ = !self->priv->temporary_notification_disabled;
#line 1997 "settings.c"
	} else {
#line 351 "../src/daemon/settings.vala"
		_tmp18_ = FALSE;
#line 2001 "settings.c"
	}
#line 351 "../src/daemon/settings.vala"
	if (_tmp18_) {
#line 351 "../src/daemon/settings.vala"
		_tmp17_ = notify_is_initted ();
#line 2007 "settings.c"
	} else {
#line 351 "../src/daemon/settings.vala"
		_tmp17_ = FALSE;
#line 2011 "settings.c"
	}
#line 351 "../src/daemon/settings.vala"
	if (_tmp17_) {
#line 2015 "settings.c"
		const gchar* _tmp21_ = NULL;
		gchar* title = NULL;
		gchar* _tmp22_;
		gchar* body = NULL;
		gchar* _tmp23_;
		const gchar* _tmp24_ = NULL;
		gchar* icon = NULL;
		gchar* _tmp27_;
		gboolean _tmp28_ = FALSE;
		NotifyNotification* _tmp30_;
#line 352 "../src/daemon/settings.vala"
		if (enabled) {
#line 352 "../src/daemon/settings.vala"
			_tmp21_ = _ ("Turned on Caffeine Boost");
#line 2030 "settings.c"
		} else {
#line 352 "../src/daemon/settings.vala"
			_tmp21_ = _ ("Turned off Caffeine Boost");
#line 2034 "settings.c"
		}
#line 352 "../src/daemon/settings.vala"
		_tmp22_ = g_strdup (_tmp21_);
#line 352 "../src/daemon/settings.vala"
		title = _tmp22_;
#line 353 "../src/daemon/settings.vala"
		_tmp23_ = g_strdup ("");
#line 353 "../src/daemon/settings.vala"
		body = _tmp23_;
#line 354 "../src/daemon/settings.vala"
		if (enabled) {
#line 2046 "settings.c"
			const gchar* _tmp25_;
#line 354 "../src/daemon/settings.vala"
			_tmp25_ = self->priv->caffeine_full_cup;
#line 354 "../src/daemon/settings.vala"
			_tmp24_ = _tmp25_;
#line 2052 "settings.c"
		} else {
			const gchar* _tmp26_;
#line 354 "../src/daemon/settings.vala"
			_tmp26_ = self->priv->caffeine_empty_cup;
#line 354 "../src/daemon/settings.vala"
			_tmp24_ = _tmp26_;
#line 2059 "settings.c"
		}
#line 354 "../src/daemon/settings.vala"
		_tmp27_ = g_strdup (_tmp24_);
#line 354 "../src/daemon/settings.vala"
		icon = _tmp27_;
#line 356 "../src/daemon/settings.vala"
		if (enabled) {
#line 356 "../src/daemon/settings.vala"
			_tmp28_ = time > 0;
#line 2069 "settings.c"
		} else {
#line 356 "../src/daemon/settings.vala"
			_tmp28_ = FALSE;
#line 2073 "settings.c"
		}
#line 356 "../src/daemon/settings.vala"
		if (_tmp28_) {
#line 2077 "settings.c"
			gchar* _tmp29_;
#line 357 "../src/daemon/settings.vala"
			_tmp29_ = g_strdup_printf (ngettext ("Will turn off in a minute", "Will turn off in %d minutes", (gulong) time), time);
#line 357 "../src/daemon/settings.vala"
			_g_free0 (body);
#line 357 "../src/daemon/settings.vala"
			body = _tmp29_;
#line 2085 "settings.c"
		}
#line 360 "../src/daemon/settings.vala"
		_tmp30_ = self->priv->caffeine_notification;
#line 360 "../src/daemon/settings.vala"
		if (_tmp30_ == NULL) {
#line 2091 "settings.c"
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			NotifyNotification* _tmp34_;
			NotifyNotification* _tmp35_;
#line 361 "../src/daemon/settings.vala"
			_tmp31_ = title;
#line 361 "../src/daemon/settings.vala"
			_tmp32_ = body;
#line 361 "../src/daemon/settings.vala"
			_tmp33_ = icon;
#line 361 "../src/daemon/settings.vala"
			_tmp34_ = notify_notification_new (_tmp31_, _tmp32_, _tmp33_);
#line 361 "../src/daemon/settings.vala"
			_g_object_unref0 (self->priv->caffeine_notification);
#line 361 "../src/daemon/settings.vala"
			self->priv->caffeine_notification = _tmp34_;
#line 362 "../src/daemon/settings.vala"
			_tmp35_ = self->priv->caffeine_notification;
#line 362 "../src/daemon/settings.vala"
			notify_notification_set_urgency (_tmp35_, NOTIFY_URGENCY_CRITICAL);
#line 2113 "settings.c"
		} else {
			NotifyNotification* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			{
				NotifyNotification* _tmp36_;
#line 365 "../src/daemon/settings.vala"
				_tmp36_ = self->priv->caffeine_notification;
#line 365 "../src/daemon/settings.vala"
				notify_notification_close (_tmp36_, &_inner_error0_);
#line 365 "../src/daemon/settings.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2127 "settings.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp37_;
				const gchar* _tmp38_;
#line 364 "../src/daemon/settings.vala"
				e = _inner_error0_;
#line 364 "../src/daemon/settings.vala"
				_inner_error0_ = NULL;
#line 367 "../src/daemon/settings.vala"
				_tmp37_ = e;
#line 367 "../src/daemon/settings.vala"
				_tmp38_ = _tmp37_->message;
#line 367 "../src/daemon/settings.vala"
				g_warning ("settings.vala:367: Failed to close previous notification: %s", _tmp38_);
#line 364 "../src/daemon/settings.vala"
				_g_error_free0 (e);
#line 2149 "settings.c"
			}
			__finally0:
#line 364 "../src/daemon/settings.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 364 "../src/daemon/settings.vala"
				_g_free0 (icon);
#line 364 "../src/daemon/settings.vala"
				_g_free0 (body);
#line 364 "../src/daemon/settings.vala"
				_g_free0 (title);
#line 364 "../src/daemon/settings.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 364 "../src/daemon/settings.vala"
				g_clear_error (&_inner_error0_);
#line 364 "../src/daemon/settings.vala"
				return;
#line 2166 "settings.c"
			}
#line 370 "../src/daemon/settings.vala"
			_tmp39_ = self->priv->caffeine_notification;
#line 370 "../src/daemon/settings.vala"
			_tmp40_ = title;
#line 370 "../src/daemon/settings.vala"
			_tmp41_ = body;
#line 370 "../src/daemon/settings.vala"
			_tmp42_ = icon;
#line 370 "../src/daemon/settings.vala"
			notify_notification_update (_tmp39_, _tmp40_, _tmp41_, _tmp42_);
#line 2178 "settings.c"
		}
		{
			NotifyNotification* _tmp43_;
#line 374 "../src/daemon/settings.vala"
			_tmp43_ = self->priv->caffeine_notification;
#line 374 "../src/daemon/settings.vala"
			notify_notification_show (_tmp43_, &_inner_error0_);
#line 374 "../src/daemon/settings.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2188 "settings.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp44_;
			const gchar* _tmp45_;
#line 373 "../src/daemon/settings.vala"
			e = _inner_error0_;
#line 373 "../src/daemon/settings.vala"
			_inner_error0_ = NULL;
#line 376 "../src/daemon/settings.vala"
			_tmp44_ = e;
#line 376 "../src/daemon/settings.vala"
			_tmp45_ = _tmp44_->message;
#line 376 "../src/daemon/settings.vala"
			g_warning ("settings.vala:376: Failed to send our Caffeine notification: %s", _tmp45_);
#line 373 "../src/daemon/settings.vala"
			_g_error_free0 (e);
#line 2210 "settings.c"
		}
		__finally1:
#line 373 "../src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 373 "../src/daemon/settings.vala"
			_g_free0 (icon);
#line 373 "../src/daemon/settings.vala"
			_g_free0 (body);
#line 373 "../src/daemon/settings.vala"
			_g_free0 (title);
#line 373 "../src/daemon/settings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 373 "../src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 373 "../src/daemon/settings.vala"
			return;
#line 2227 "settings.c"
		}
#line 351 "../src/daemon/settings.vala"
		_g_free0 (icon);
#line 351 "../src/daemon/settings.vala"
		_g_free0 (body);
#line 351 "../src/daemon/settings.vala"
		_g_free0 (title);
#line 2235 "settings.c"
	}
#line 380 "../src/daemon/settings.vala"
	if (self->priv->temporary_notification_disabled) {
#line 381 "../src/daemon/settings.vala"
		g_timeout_add_seconds_full (G_PRIORITY_HIGH, (guint) 60, ____lambda71__gsource_func, budgie_settings_manager_ref (self), budgie_settings_manager_unref);
#line 2241 "settings.c"
	}
}

/**
* set_focus_mode will set the window focus mode
*/
static GVariant*
_variant_new3 (const gchar* value)
{
#line 399 "../src/daemon/settings.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2253 "settings.c"
}

static void
budgie_settings_manager_set_focus_mode (BudgieSettingsManager* self,
                                        gboolean enable)
{
	gchar* gfocus_mode = NULL;
	gchar* _tmp0_;
	gint _tmp1_ = 0;
	gint raise_delay = 0;
	GSettings* _tmp3_;
	const gchar* _tmp4_;
	GVariant* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
#line 391 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/daemon/settings.vala"
	_tmp0_ = g_strdup ("click");
#line 392 "../src/daemon/settings.vala"
	gfocus_mode = _tmp0_;
#line 393 "../src/daemon/settings.vala"
	if (enable) {
#line 393 "../src/daemon/settings.vala"
		_tmp1_ = 0;
#line 2279 "settings.c"
	} else {
#line 393 "../src/daemon/settings.vala"
		_tmp1_ = 250;
#line 2283 "settings.c"
	}
#line 393 "../src/daemon/settings.vala"
	raise_delay = _tmp1_;
#line 395 "../src/daemon/settings.vala"
	if (enable) {
#line 2289 "settings.c"
		gchar* _tmp2_;
#line 396 "../src/daemon/settings.vala"
		_tmp2_ = g_strdup ("mouse");
#line 396 "../src/daemon/settings.vala"
		_g_free0 (gfocus_mode);
#line 396 "../src/daemon/settings.vala"
		gfocus_mode = _tmp2_;
#line 2297 "settings.c"
	}
#line 399 "../src/daemon/settings.vala"
	_tmp3_ = self->priv->gnome_wm_settings;
#line 399 "../src/daemon/settings.vala"
	_tmp4_ = gfocus_mode;
#line 399 "../src/daemon/settings.vala"
	_tmp5_ = _variant_new3 (_tmp4_);
#line 399 "../src/daemon/settings.vala"
	g_settings_set_value (_tmp3_, "focus-mode", _tmp5_);
#line 399 "../src/daemon/settings.vala"
	_g_variant_unref0 (_tmp5_);
#line 400 "../src/daemon/settings.vala"
	_tmp6_ = self->priv->gnome_wm_settings;
#line 400 "../src/daemon/settings.vala"
	g_settings_set_boolean (_tmp6_, "auto-raise", enable);
#line 401 "../src/daemon/settings.vala"
	_tmp7_ = self->priv->gnome_wm_settings;
#line 401 "../src/daemon/settings.vala"
	g_settings_set_int (_tmp7_, "auto-raise-delay", raise_delay);
#line 391 "../src/daemon/settings.vala"
	_g_free0 (gfocus_mode);
#line 2319 "settings.c"
}

/**
* set_supported_caffeine_icons will determine whether or not to use the current IconTheme's caffeine icons, if supported.
* If it is not supported, it will fall back to our budgie vendored icons.
*/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 409 "../src/daemon/settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 2331 "settings.c"
}

static void
budgie_settings_manager_set_supported_caffeine_icons (BudgieSettingsManager* self)
{
	GtkIconTheme* current_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	gchar* full = NULL;
	gchar* _tmp2_;
	gchar* empty = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	GtkIconTheme* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	GtkIconTheme* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp19_;
#line 408 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 409 "../src/daemon/settings.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 409 "../src/daemon/settings.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 409 "../src/daemon/settings.vala"
	current_theme = _tmp1_;
#line 410 "../src/daemon/settings.vala"
	_tmp2_ = g_strdup ("caffeine-cup-full");
#line 410 "../src/daemon/settings.vala"
	full = _tmp2_;
#line 411 "../src/daemon/settings.vala"
	_tmp3_ = g_strdup ("caffeine-cup-empty");
#line 411 "../src/daemon/settings.vala"
	empty = _tmp3_;
#line 412 "../src/daemon/settings.vala"
	_tmp5_ = current_theme;
#line 412 "../src/daemon/settings.vala"
	_tmp6_ = full;
#line 412 "../src/daemon/settings.vala"
	if (gtk_icon_theme_has_icon (_tmp5_, _tmp6_)) {
#line 2374 "settings.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 412 "../src/daemon/settings.vala"
		_tmp7_ = full;
#line 412 "../src/daemon/settings.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 412 "../src/daemon/settings.vala"
		_g_free0 (_tmp4_);
#line 412 "../src/daemon/settings.vala"
		_tmp4_ = _tmp8_;
#line 2385 "settings.c"
	} else {
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 412 "../src/daemon/settings.vala"
		_tmp9_ = full;
#line 412 "../src/daemon/settings.vala"
		_tmp10_ = g_strconcat ("budgie-", _tmp9_, NULL);
#line 412 "../src/daemon/settings.vala"
		_g_free0 (_tmp4_);
#line 412 "../src/daemon/settings.vala"
		_tmp4_ = _tmp10_;
#line 2397 "settings.c"
	}
#line 412 "../src/daemon/settings.vala"
	_tmp11_ = g_strdup (_tmp4_);
#line 412 "../src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_full_cup);
#line 412 "../src/daemon/settings.vala"
	self->priv->caffeine_full_cup = _tmp11_;
#line 413 "../src/daemon/settings.vala"
	_tmp13_ = current_theme;
#line 413 "../src/daemon/settings.vala"
	_tmp14_ = empty;
#line 413 "../src/daemon/settings.vala"
	if (gtk_icon_theme_has_icon (_tmp13_, _tmp14_)) {
#line 2411 "settings.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 413 "../src/daemon/settings.vala"
		_tmp15_ = empty;
#line 413 "../src/daemon/settings.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 413 "../src/daemon/settings.vala"
		_g_free0 (_tmp12_);
#line 413 "../src/daemon/settings.vala"
		_tmp12_ = _tmp16_;
#line 2422 "settings.c"
	} else {
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 413 "../src/daemon/settings.vala"
		_tmp17_ = empty;
#line 413 "../src/daemon/settings.vala"
		_tmp18_ = g_strconcat ("budgie-", _tmp17_, NULL);
#line 413 "../src/daemon/settings.vala"
		_g_free0 (_tmp12_);
#line 413 "../src/daemon/settings.vala"
		_tmp12_ = _tmp18_;
#line 2434 "settings.c"
	}
#line 413 "../src/daemon/settings.vala"
	_tmp19_ = g_strdup (_tmp12_);
#line 413 "../src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_empty_cup);
#line 413 "../src/daemon/settings.vala"
	self->priv->caffeine_empty_cup = _tmp19_;
#line 408 "../src/daemon/settings.vala"
	_g_free0 (_tmp12_);
#line 408 "../src/daemon/settings.vala"
	_g_free0 (_tmp4_);
#line 408 "../src/daemon/settings.vala"
	_g_free0 (empty);
#line 408 "../src/daemon/settings.vala"
	_g_free0 (full);
#line 408 "../src/daemon/settings.vala"
	_g_object_unref0 (current_theme);
#line 2452 "settings.c"
}

/**
* update_ac_timeout will update our default sleep inactive ac timeout value, if it is a non-Caffeine mode value
*/
static void
budgie_settings_manager_update_ac_timeout (BudgieSettingsManager* self)
{
	gint current_ac_timeout = 0;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 419 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_power_settings;
#line 420 "../src/daemon/settings.vala"
	current_ac_timeout = g_settings_get_int (_tmp0_, "sleep-inactive-ac-timeout");
#line 422 "../src/daemon/settings.vala"
	if (current_ac_timeout != 0) {
#line 422 "../src/daemon/settings.vala"
		_tmp1_ = TRUE;
#line 2474 "settings.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 422 "../src/daemon/settings.vala"
		if (current_ac_timeout == 0) {
#line 422 "../src/daemon/settings.vala"
			_tmp2_ = !budgie_settings_manager_get_caffeine_mode (self);
#line 2481 "settings.c"
		} else {
#line 422 "../src/daemon/settings.vala"
			_tmp2_ = FALSE;
#line 2485 "settings.c"
		}
#line 422 "../src/daemon/settings.vala"
		_tmp1_ = _tmp2_;
#line 2489 "settings.c"
	}
#line 422 "../src/daemon/settings.vala"
	if (_tmp1_) {
#line 2493 "settings.c"
		gint* _tmp3_;
#line 423 "../src/daemon/settings.vala"
		_tmp3_ = __int_dup0 (&current_ac_timeout);
#line 423 "../src/daemon/settings.vala"
		_g_free0 (self->priv->default_sleep_inactive_ac_timeout);
#line 423 "../src/daemon/settings.vala"
		self->priv->default_sleep_inactive_ac_timeout = _tmp3_;
#line 2501 "settings.c"
	}
}

/**
* update_battery_timeout will update our default sleep inactive battery timeout, if it is a non-Caffeine mode value
*/
static void
budgie_settings_manager_update_battery_timeout (BudgieSettingsManager* self)
{
	gint current_battery_timeout = 0;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 430 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 431 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_power_settings;
#line 431 "../src/daemon/settings.vala"
	current_battery_timeout = g_settings_get_int (_tmp0_, "sleep-inactive-battery-timeout");
#line 433 "../src/daemon/settings.vala"
	if (current_battery_timeout != 0) {
#line 433 "../src/daemon/settings.vala"
		_tmp1_ = TRUE;
#line 2524 "settings.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 433 "../src/daemon/settings.vala"
		if (current_battery_timeout == 0) {
#line 433 "../src/daemon/settings.vala"
			_tmp2_ = !budgie_settings_manager_get_caffeine_mode (self);
#line 2531 "settings.c"
		} else {
#line 433 "../src/daemon/settings.vala"
			_tmp2_ = FALSE;
#line 2535 "settings.c"
		}
#line 433 "../src/daemon/settings.vala"
		_tmp1_ = _tmp2_;
#line 2539 "settings.c"
	}
#line 433 "../src/daemon/settings.vala"
	if (_tmp1_) {
#line 2543 "settings.c"
		gint* _tmp3_;
#line 434 "../src/daemon/settings.vala"
		_tmp3_ = __int_dup0 (&current_battery_timeout);
#line 434 "../src/daemon/settings.vala"
		_g_free0 (self->priv->default_sleep_inactive_battery_timeout);
#line 434 "../src/daemon/settings.vala"
		self->priv->default_sleep_inactive_battery_timeout = _tmp3_;
#line 2551 "settings.c"
	}
}

/**
* update_idle_delay will update our default idle delay, if it is a non-Caffeine mode value
*/
static void
budgie_settings_manager_update_idle_delay (BudgieSettingsManager* self)
{
	guint current_idle_delay = 0U;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 441 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_session_settings;
#line 442 "../src/daemon/settings.vala"
	current_idle_delay = g_settings_get_uint (_tmp0_, "idle-delay");
#line 444 "../src/daemon/settings.vala"
	if (current_idle_delay != ((guint) 0)) {
#line 444 "../src/daemon/settings.vala"
		_tmp1_ = TRUE;
#line 2574 "settings.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 444 "../src/daemon/settings.vala"
		if (current_idle_delay == ((guint) 0)) {
#line 444 "../src/daemon/settings.vala"
			_tmp2_ = !budgie_settings_manager_get_caffeine_mode (self);
#line 2581 "settings.c"
		} else {
#line 444 "../src/daemon/settings.vala"
			_tmp2_ = FALSE;
#line 2585 "settings.c"
		}
#line 444 "../src/daemon/settings.vala"
		_tmp1_ = _tmp2_;
#line 2589 "settings.c"
	}
#line 444 "../src/daemon/settings.vala"
	if (_tmp1_) {
#line 2593 "settings.c"
		guint32 _tmp3_;
		guint32* _tmp4_;
#line 445 "../src/daemon/settings.vala"
		_tmp3_ = (guint32) current_idle_delay;
#line 445 "../src/daemon/settings.vala"
		_tmp4_ = __uint32_dup0 (&_tmp3_);
#line 445 "../src/daemon/settings.vala"
		_g_free0 (self->priv->default_idle_delay);
#line 445 "../src/daemon/settings.vala"
		self->priv->default_idle_delay = _tmp4_;
#line 2604 "settings.c"
	}
}

/**
* update_idle_dim will update our default idle dim, if we are not in Caffeine Mode
*/
static void
budgie_settings_manager_update_idle_dim (BudgieSettingsManager* self)
{
#line 452 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/daemon/settings.vala"
	if (!budgie_settings_manager_get_caffeine_mode (self)) {
#line 2618 "settings.c"
		GSettings* _tmp0_;
		gboolean _tmp1_;
		gboolean* _tmp2_;
#line 454 "../src/daemon/settings.vala"
		_tmp0_ = self->priv->gnome_power_settings;
#line 454 "../src/daemon/settings.vala"
		_tmp1_ = g_settings_get_boolean (_tmp0_, "idle-dim");
#line 454 "../src/daemon/settings.vala"
		_tmp2_ = __bool_dup0 (&_tmp1_);
#line 454 "../src/daemon/settings.vala"
		_g_free0 (self->priv->default_idle_dim);
#line 454 "../src/daemon/settings.vala"
		self->priv->default_idle_dim = _tmp2_;
#line 2632 "settings.c"
	}
}

static void
budgie_settings_manager_apply_dark_theme_pref (BudgieSettingsManager* self)
{
	BudgieColorScheme _tmp0_ = 0;
	GSettings* _tmp1_;
	BudgieColorScheme scheme = 0;
	GSettings* _tmp2_;
#line 458 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 459 "../src/daemon/settings.vala"
	_tmp1_ = self->priv->panel_settings;
#line 459 "../src/daemon/settings.vala"
	if (g_settings_get_boolean (_tmp1_, "dark-theme")) {
#line 459 "../src/daemon/settings.vala"
		_tmp0_ = BUDGIE_COLOR_SCHEME_PREFER_DARK;
#line 2651 "settings.c"
	} else {
#line 459 "../src/daemon/settings.vala"
		_tmp0_ = BUDGIE_COLOR_SCHEME_PREFER_LIGHT;
#line 2655 "settings.c"
	}
#line 459 "../src/daemon/settings.vala"
	scheme = _tmp0_;
#line 460 "../src/daemon/settings.vala"
	_tmp2_ = self->priv->gnome_desktop_settings;
#line 460 "../src/daemon/settings.vala"
	g_settings_set_enum (_tmp2_, "color-scheme", (gint) scheme);
#line 2663 "settings.c"
}

GApplication*
budgie_settings_manager_get_parent_app (BudgieSettingsManager* self)
{
	GApplication* result;
	GApplication* _tmp0_;
#line 39 "../src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/daemon/settings.vala"
	_tmp0_ = self->priv->_parent_app;
#line 39 "../src/daemon/settings.vala"
	result = _tmp0_;
#line 39 "../src/daemon/settings.vala"
	return result;
#line 2679 "settings.c"
}

void
budgie_settings_manager_set_parent_app (BudgieSettingsManager* self,
                                        GApplication* value)
{
#line 40 "../src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/daemon/settings.vala"
	self->priv->_parent_app = value;
#line 2690 "settings.c"
}

static void
budgie_value_settings_manager_init (GValue* value)
{
#line 36 "../src/daemon/settings.vala"
	value->data[0].v_pointer = NULL;
#line 2698 "settings.c"
}

static void
budgie_value_settings_manager_free_value (GValue* value)
{
#line 36 "../src/daemon/settings.vala"
	if (value->data[0].v_pointer) {
#line 36 "../src/daemon/settings.vala"
		budgie_settings_manager_unref (value->data[0].v_pointer);
#line 2708 "settings.c"
	}
}

static void
budgie_value_settings_manager_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 36 "../src/daemon/settings.vala"
	if (src_value->data[0].v_pointer) {
#line 36 "../src/daemon/settings.vala"
		dest_value->data[0].v_pointer = budgie_settings_manager_ref (src_value->data[0].v_pointer);
#line 2720 "settings.c"
	} else {
#line 36 "../src/daemon/settings.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2724 "settings.c"
	}
}

static gpointer
budgie_value_settings_manager_peek_pointer (const GValue* value)
{
#line 36 "../src/daemon/settings.vala"
	return value->data[0].v_pointer;
#line 2733 "settings.c"
}

static gchar*
budgie_value_settings_manager_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 36 "../src/daemon/settings.vala"
	if (collect_values[0].v_pointer) {
#line 2744 "settings.c"
		BudgieSettingsManager * object;
		object = collect_values[0].v_pointer;
#line 36 "../src/daemon/settings.vala"
		if (object->parent_instance.g_class == NULL) {
#line 36 "../src/daemon/settings.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2751 "settings.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 36 "../src/daemon/settings.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2755 "settings.c"
		}
#line 36 "../src/daemon/settings.vala"
		value->data[0].v_pointer = budgie_settings_manager_ref (object);
#line 2759 "settings.c"
	} else {
#line 36 "../src/daemon/settings.vala"
		value->data[0].v_pointer = NULL;
#line 2763 "settings.c"
	}
#line 36 "../src/daemon/settings.vala"
	return NULL;
#line 2767 "settings.c"
}

static gchar*
budgie_value_settings_manager_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	BudgieSettingsManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 36 "../src/daemon/settings.vala"
	if (!object_p) {
#line 36 "../src/daemon/settings.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2782 "settings.c"
	}
#line 36 "../src/daemon/settings.vala"
	if (!value->data[0].v_pointer) {
#line 36 "../src/daemon/settings.vala"
		*object_p = NULL;
#line 2788 "settings.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 36 "../src/daemon/settings.vala"
		*object_p = value->data[0].v_pointer;
#line 2792 "settings.c"
	} else {
#line 36 "../src/daemon/settings.vala"
		*object_p = budgie_settings_manager_ref (value->data[0].v_pointer);
#line 2796 "settings.c"
	}
#line 36 "../src/daemon/settings.vala"
	return NULL;
#line 2800 "settings.c"
}

GParamSpec*
budgie_param_spec_settings_manager (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	BudgieParamSpecSettingsManager* spec;
#line 36 "../src/daemon/settings.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BUDGIE_TYPE_SETTINGS_MANAGER), NULL);
#line 36 "../src/daemon/settings.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 36 "../src/daemon/settings.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 36 "../src/daemon/settings.vala"
	return G_PARAM_SPEC (spec);
#line 2819 "settings.c"
}

gpointer
budgie_value_get_settings_manager (const GValue* value)
{
#line 36 "../src/daemon/settings.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BUDGIE_TYPE_SETTINGS_MANAGER), NULL);
#line 36 "../src/daemon/settings.vala"
	return value->data[0].v_pointer;
#line 2829 "settings.c"
}

void
budgie_value_set_settings_manager (GValue* value,
                                   gpointer v_object)
{
	BudgieSettingsManager * old;
#line 36 "../src/daemon/settings.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 36 "../src/daemon/settings.vala"
	old = value->data[0].v_pointer;
#line 36 "../src/daemon/settings.vala"
	if (v_object) {
#line 36 "../src/daemon/settings.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 36 "../src/daemon/settings.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 36 "../src/daemon/settings.vala"
		value->data[0].v_pointer = v_object;
#line 36 "../src/daemon/settings.vala"
		budgie_settings_manager_ref (value->data[0].v_pointer);
#line 2851 "settings.c"
	} else {
#line 36 "../src/daemon/settings.vala"
		value->data[0].v_pointer = NULL;
#line 2855 "settings.c"
	}
#line 36 "../src/daemon/settings.vala"
	if (old) {
#line 36 "../src/daemon/settings.vala"
		budgie_settings_manager_unref (old);
#line 2861 "settings.c"
	}
}

void
budgie_value_take_settings_manager (GValue* value,
                                    gpointer v_object)
{
	BudgieSettingsManager * old;
#line 36 "../src/daemon/settings.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 36 "../src/daemon/settings.vala"
	old = value->data[0].v_pointer;
#line 36 "../src/daemon/settings.vala"
	if (v_object) {
#line 36 "../src/daemon/settings.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 36 "../src/daemon/settings.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 36 "../src/daemon/settings.vala"
		value->data[0].v_pointer = v_object;
#line 2882 "settings.c"
	} else {
#line 36 "../src/daemon/settings.vala"
		value->data[0].v_pointer = NULL;
#line 2886 "settings.c"
	}
#line 36 "../src/daemon/settings.vala"
	if (old) {
#line 36 "../src/daemon/settings.vala"
		budgie_settings_manager_unref (old);
#line 2892 "settings.c"
	}
}

static void
budgie_settings_manager_class_init (BudgieSettingsManagerClass * klass,
                                    gpointer klass_data)
{
#line 36 "../src/daemon/settings.vala"
	budgie_settings_manager_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/daemon/settings.vala"
	((BudgieSettingsManagerClass *) klass)->finalize = budgie_settings_manager_finalize;
#line 36 "../src/daemon/settings.vala"
	g_type_class_adjust_private_offset (klass, &BudgieSettingsManager_private_offset);
#line 2906 "settings.c"
}

static void
budgie_settings_manager_instance_init (BudgieSettingsManager * self,
                                       gpointer klass)
{
	gint32 _tmp0_;
	gint32* _tmp1_;
	guint32 _tmp2_;
	guint32* _tmp3_;
	gboolean _tmp4_;
	gboolean* _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp8_;
	gint* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 36 "../src/daemon/settings.vala"
	self->priv = budgie_settings_manager_get_instance_private (self);
#line 37 "../src/daemon/settings.vala"
	self->priv->_parent_app = NULL;
#line 46 "../src/daemon/settings.vala"
	self->priv->mutter_settings = NULL;
#line 47 "../src/daemon/settings.vala"
	self->priv->gnome_desktop_settings = NULL;
#line 48 "../src/daemon/settings.vala"
	self->priv->gnome_power_settings = NULL;
#line 49 "../src/daemon/settings.vala"
	self->priv->gnome_power_props = NULL;
#line 50 "../src/daemon/settings.vala"
	self->priv->gnome_session_settings = NULL;
#line 51 "../src/daemon/settings.vala"
	self->priv->gnome_sound_settings = NULL;
#line 52 "../src/daemon/settings.vala"
	self->priv->gnome_wm_settings = NULL;
#line 53 "../src/daemon/settings.vala"
	self->priv->panel_settings = NULL;
#line 54 "../src/daemon/settings.vala"
	self->priv->raven_settings = NULL;
#line 55 "../src/daemon/settings.vala"
	self->priv->wm_settings = NULL;
#line 56 "../src/daemon/settings.vala"
	self->priv->xoverrides = NULL;
#line 61 "../src/daemon/settings.vala"
	_tmp0_ = (gint32) 30;
#line 61 "../src/daemon/settings.vala"
	_tmp1_ = __int32_dup0 (&_tmp0_);
#line 61 "../src/daemon/settings.vala"
	self->priv->default_brightness = _tmp1_;
#line 62 "../src/daemon/settings.vala"
	_tmp2_ = (guint32) 0;
#line 62 "../src/daemon/settings.vala"
	_tmp3_ = __uint32_dup0 (&_tmp2_);
#line 62 "../src/daemon/settings.vala"
	self->priv->default_idle_delay = _tmp3_;
#line 63 "../src/daemon/settings.vala"
	_tmp4_ = FALSE;
#line 63 "../src/daemon/settings.vala"
	_tmp5_ = __bool_dup0 (&_tmp4_);
#line 63 "../src/daemon/settings.vala"
	self->priv->default_idle_dim = _tmp5_;
#line 64 "../src/daemon/settings.vala"
	_tmp6_ = 0;
#line 64 "../src/daemon/settings.vala"
	_tmp7_ = __int_dup0 (&_tmp6_);
#line 64 "../src/daemon/settings.vala"
	self->priv->default_sleep_inactive_ac_timeout = _tmp7_;
#line 65 "../src/daemon/settings.vala"
	_tmp8_ = 0;
#line 65 "../src/daemon/settings.vala"
	_tmp9_ = __int_dup0 (&_tmp8_);
#line 65 "../src/daemon/settings.vala"
	self->priv->default_sleep_inactive_battery_timeout = _tmp9_;
#line 70 "../src/daemon/settings.vala"
	_tmp10_ = g_strdup ("");
#line 70 "../src/daemon/settings.vala"
	self->priv->caffeine_full_cup = _tmp10_;
#line 71 "../src/daemon/settings.vala"
	_tmp11_ = g_strdup ("");
#line 71 "../src/daemon/settings.vala"
	self->priv->caffeine_empty_cup = _tmp11_;
#line 72 "../src/daemon/settings.vala"
	self->priv->caffeine_notification = NULL;
#line 73 "../src/daemon/settings.vala"
	self->priv->temporary_notification_disabled = FALSE;
#line 36 "../src/daemon/settings.vala"
	self->ref_count = 1;
#line 2995 "settings.c"
}

static void
budgie_settings_manager_finalize (BudgieSettingsManager * obj)
{
	BudgieSettingsManager * self;
#line 36 "../src/daemon/settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManager);
#line 36 "../src/daemon/settings.vala"
	g_signal_handlers_destroy (self);
#line 46 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->mutter_settings);
#line 47 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_desktop_settings);
#line 48 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_power_settings);
#line 49 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_power_props);
#line 50 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_session_settings);
#line 51 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_sound_settings);
#line 52 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_wm_settings);
#line 53 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->panel_settings);
#line 54 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 55 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->wm_settings);
#line 56 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->xoverrides);
#line 61 "../src/daemon/settings.vala"
	_g_free0 (self->priv->default_brightness);
#line 62 "../src/daemon/settings.vala"
	_g_free0 (self->priv->default_idle_delay);
#line 63 "../src/daemon/settings.vala"
	_g_free0 (self->priv->default_idle_dim);
#line 64 "../src/daemon/settings.vala"
	_g_free0 (self->priv->default_sleep_inactive_ac_timeout);
#line 65 "../src/daemon/settings.vala"
	_g_free0 (self->priv->default_sleep_inactive_battery_timeout);
#line 70 "../src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_full_cup);
#line 71 "../src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_empty_cup);
#line 72 "../src/daemon/settings.vala"
	_g_object_unref0 (self->priv->caffeine_notification);
#line 3044 "settings.c"
}

/**
* The SettingsManager currently only has a very simple job, and looks for
* session wide settings changes to respond to
*/
static GType
budgie_settings_manager_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { budgie_value_settings_manager_init, budgie_value_settings_manager_free_value, budgie_value_settings_manager_copy_value, budgie_value_settings_manager_peek_pointer, "p", budgie_value_settings_manager_collect_value, "p", budgie_value_settings_manager_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BudgieSettingsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_settings_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieSettingsManager), 0, (GInstanceInitFunc) budgie_settings_manager_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType budgie_settings_manager_type_id;
	budgie_settings_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BudgieSettingsManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
	BudgieSettingsManager_private_offset = g_type_add_instance_private (budgie_settings_manager_type_id, sizeof (BudgieSettingsManagerPrivate));
	return budgie_settings_manager_type_id;
}

GType
budgie_settings_manager_get_type (void)
{
	static volatile gsize budgie_settings_manager_type_id__once = 0;
	if (g_once_init_enter (&budgie_settings_manager_type_id__once)) {
		GType budgie_settings_manager_type_id;
		budgie_settings_manager_type_id = budgie_settings_manager_get_type_once ();
		g_once_init_leave (&budgie_settings_manager_type_id__once, budgie_settings_manager_type_id);
	}
	return budgie_settings_manager_type_id__once;
}

gpointer
budgie_settings_manager_ref (gpointer instance)
{
	BudgieSettingsManager * self;
	self = instance;
#line 36 "../src/daemon/settings.vala"
	g_atomic_int_inc (&self->ref_count);
#line 36 "../src/daemon/settings.vala"
	return instance;
#line 3084 "settings.c"
}

void
budgie_settings_manager_unref (gpointer instance)
{
	BudgieSettingsManager * self;
	self = instance;
#line 36 "../src/daemon/settings.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 36 "../src/daemon/settings.vala"
		BUDGIE_SETTINGS_MANAGER_GET_CLASS (self)->finalize (self);
#line 36 "../src/daemon/settings.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3098 "settings.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

