/* MenuItem.c generated by valac 0.56.13, the Vala compiler
 * generated from MenuItem.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgiemenuapplet.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	MENU_ITEM_0_PROPERTY,
	MENU_ITEM_IMAGE_SOURCE_PROPERTY,
	MENU_ITEM_LABEL_TEXT_PROPERTY,
	MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* menu_item_properties[MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MenuItemPrivate {
	GtkBox* menu_item;
	GtkImage* button_image;
	GtkLabel* button_label;
	gchar* _image_source;
	gchar* _label_text;
};

static gint MenuItem_private_offset;
static gpointer menu_item_parent_class = NULL;
static GType menu_item_type_id = 0;

static GObject * menu_item_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void menu_item_finalize (GObject * obj);
static void _vala_menu_item_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_menu_item_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
menu_item_get_instance_private (MenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, MenuItem_private_offset);
}

MenuItem*
menu_item_construct (GType object_type,
                     const gchar* label_text,
                     const gchar* image_source)
{
	MenuItem * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkImage* _tmp2_;
	GtkBox* _tmp3_;
	GtkLabel* _tmp4_;
	GtkBox* _tmp5_;
#line 38 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_val_if_fail (label_text != NULL, NULL);
#line 38 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_val_if_fail (image_source != NULL, NULL);
#line 39 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self = (MenuItem*) g_object_new (object_type, "can-focus", TRUE, NULL);
#line 41 "../src/panel/applets/budgie-menu/MenuItem.vala"
	menu_item_set_image (self, image_source);
#line 42 "../src/panel/applets/budgie-menu/MenuItem.vala"
	menu_item_set_label (self, label_text);
#line 44 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 8);
#line 44 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 44 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_object_unref0 (self->priv->menu_item);
#line 44 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->menu_item = _tmp0_;
#line 45 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp1_ = self->priv->menu_item;
#line 45 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp2_ = self->priv->button_image;
#line 45 "../src/panel/applets/budgie-menu/MenuItem.vala"
	gtk_box_pack_start (_tmp1_, (GtkWidget*) _tmp2_, FALSE, FALSE, (guint) 0);
#line 46 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp3_ = self->priv->menu_item;
#line 46 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp4_ = self->priv->button_label;
#line 46 "../src/panel/applets/budgie-menu/MenuItem.vala"
	gtk_box_pack_end (_tmp3_, (GtkWidget*) _tmp4_, TRUE, TRUE, (guint) 0);
#line 48 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp5_ = self->priv->menu_item;
#line 48 "../src/panel/applets/budgie-menu/MenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 38 "../src/panel/applets/budgie-menu/MenuItem.vala"
	return self;
#line 112 "MenuItem.c"
}

MenuItem*
menu_item_new (const gchar* label_text,
               const gchar* image_source)
{
#line 38 "../src/panel/applets/budgie-menu/MenuItem.vala"
	return menu_item_construct (TYPE_MENU_ITEM, label_text, image_source);
#line 121 "MenuItem.c"
}

/**
 * Set the image for this item.
 */
void
menu_item_set_image (MenuItem* self,
                     const gchar* source)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp2_;
#line 61 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_if_fail (source != NULL);
#line 62 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = self->priv->button_image;
#line 62 "../src/panel/applets/budgie-menu/MenuItem.vala"
	if (_tmp0_ == NULL) {
#line 141 "MenuItem.c"
		GtkImage* _tmp1_;
#line 63 "../src/panel/applets/budgie-menu/MenuItem.vala"
		_tmp1_ = (GtkImage*) gtk_image_new ();
#line 63 "../src/panel/applets/budgie-menu/MenuItem.vala"
		g_object_ref_sink (_tmp1_);
#line 63 "../src/panel/applets/budgie-menu/MenuItem.vala"
		_g_object_unref0 (self->priv->button_image);
#line 63 "../src/panel/applets/budgie-menu/MenuItem.vala"
		self->priv->button_image = _tmp1_;
#line 151 "MenuItem.c"
	}
#line 66 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp2_ = self->priv->button_image;
#line 66 "../src/panel/applets/budgie-menu/MenuItem.vala"
	gtk_image_set_from_icon_name (_tmp2_, source, (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 157 "MenuItem.c"
}

/**
 * Sets the label for this item.
 */
void
menu_item_set_label (MenuItem* self,
                     const gchar* text)
{
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 72 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_if_fail (text != NULL);
#line 73 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = g_strdup (text);
#line 73 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_free0 (self->priv->_label_text);
#line 73 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->_label_text = _tmp0_;
#line 75 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp1_ = self->priv->button_label;
#line 75 "../src/panel/applets/budgie-menu/MenuItem.vala"
	if (_tmp1_ == NULL) {
#line 183 "MenuItem.c"
		const gchar* _tmp2_;
		GtkLabel* _tmp3_ = NULL;
#line 76 "../src/panel/applets/budgie-menu/MenuItem.vala"
		_tmp2_ = self->priv->_label_text;
#line 76 "../src/panel/applets/budgie-menu/MenuItem.vala"
		_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 76 "../src/panel/applets/budgie-menu/MenuItem.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 76 "../src/panel/applets/budgie-menu/MenuItem.vala"
		g_object_ref_sink (_tmp3_);
#line 76 "../src/panel/applets/budgie-menu/MenuItem.vala"
		_g_object_unref0 (self->priv->button_label);
#line 76 "../src/panel/applets/budgie-menu/MenuItem.vala"
		self->priv->button_label = _tmp3_;
#line 198 "MenuItem.c"
	} else {
		GtkLabel* _tmp4_;
		const gchar* _tmp5_;
#line 80 "../src/panel/applets/budgie-menu/MenuItem.vala"
		_tmp4_ = self->priv->button_label;
#line 80 "../src/panel/applets/budgie-menu/MenuItem.vala"
		_tmp5_ = self->priv->_label_text;
#line 80 "../src/panel/applets/budgie-menu/MenuItem.vala"
		gtk_label_set_text (_tmp4_, _tmp5_);
#line 208 "MenuItem.c"
	}
}

const gchar*
menu_item_get_image_source (MenuItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = self->priv->_image_source;
#line 23 "../src/panel/applets/budgie-menu/MenuItem.vala"
	result = _tmp0_;
#line 23 "../src/panel/applets/budgie-menu/MenuItem.vala"
	return result;
#line 225 "MenuItem.c"
}

void
menu_item_set_image_source (MenuItem* self,
                            const gchar* value)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 24 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = menu_item_get_image_source (self);
#line 25 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp1_ = _tmp0_;
#line 25 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 25 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_free0 (self->priv->_image_source);
#line 25 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->_image_source = _tmp2_;
#line 26 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp3_ = menu_item_get_image_source (self);
#line 26 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp4_ = _tmp3_;
#line 26 "../src/panel/applets/budgie-menu/MenuItem.vala"
	menu_item_set_image (self, _tmp4_);
#line 24 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_object_notify_by_pspec ((GObject *) self, menu_item_properties[MENU_ITEM_IMAGE_SOURCE_PROPERTY]);
#line 257 "MenuItem.c"
}

const gchar*
menu_item_get_label_text (MenuItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = self->priv->_label_text;
#line 32 "../src/panel/applets/budgie-menu/MenuItem.vala"
	result = _tmp0_;
#line 32 "../src/panel/applets/budgie-menu/MenuItem.vala"
	return result;
#line 273 "MenuItem.c"
}

void
menu_item_set_label_text (MenuItem* self,
                          const gchar* value)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 33 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = menu_item_get_label_text (self);
#line 34 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp1_ = _tmp0_;
#line 34 "../src/panel/applets/budgie-menu/MenuItem.vala"
	menu_item_set_label (self, _tmp1_);
#line 33 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_object_notify_by_pspec ((GObject *) self, menu_item_properties[MENU_ITEM_LABEL_TEXT_PROPERTY]);
#line 292 "MenuItem.c"
}

static GObject *
menu_item_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MenuItem * self;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 51 "../src/panel/applets/budgie-menu/MenuItem.vala"
	parent_class = G_OBJECT_CLASS (menu_item_parent_class);
#line 51 "../src/panel/applets/budgie-menu/MenuItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_ITEM, MenuItem);
#line 52 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 52 "../src/panel/applets/budgie-menu/MenuItem.vala"
	gtk_style_context_add_class (_tmp0_, "flat");
#line 53 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 53 "../src/panel/applets/budgie-menu/MenuItem.vala"
	gtk_style_context_add_class (_tmp1_, "menuitem");
#line 55 "../src/panel/applets/budgie-menu/MenuItem.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 51 "../src/panel/applets/budgie-menu/MenuItem.vala"
	return obj;
#line 323 "MenuItem.c"
}

static void
menu_item_class_init (MenuItemClass * klass,
                      gpointer klass_data)
{
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	menu_item_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_type_class_adjust_private_offset (klass, &MenuItem_private_offset);
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_menu_item_get_property;
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_menu_item_set_property;
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	G_OBJECT_CLASS (klass)->constructor = menu_item_constructor;
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = menu_item_finalize;
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_ITEM_IMAGE_SOURCE_PROPERTY, menu_item_properties[MENU_ITEM_IMAGE_SOURCE_PROPERTY] = g_param_spec_string ("image-source", "image-source", "image-source", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_ITEM_LABEL_TEXT_PROPERTY, menu_item_properties[MENU_ITEM_LABEL_TEXT_PROPERTY] = g_param_spec_string ("label-text", "label-text", "label-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 346 "MenuItem.c"
}

static void
menu_item_instance_init (MenuItem * self,
                         gpointer klass)
{
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv = menu_item_get_instance_private (self);
#line 17 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->menu_item = NULL;
#line 18 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->button_image = NULL;
#line 19 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->button_label = NULL;
#line 21 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->_image_source = NULL;
#line 30 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self->priv->_label_text = NULL;
#line 365 "MenuItem.c"
}

static void
menu_item_finalize (GObject * obj)
{
	MenuItem * self;
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_ITEM, MenuItem);
#line 17 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_object_unref0 (self->priv->menu_item);
#line 18 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_object_unref0 (self->priv->button_image);
#line 19 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_object_unref0 (self->priv->button_label);
#line 21 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_free0 (self->priv->_image_source);
#line 30 "../src/panel/applets/budgie-menu/MenuItem.vala"
	_g_free0 (self->priv->_label_text);
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	G_OBJECT_CLASS (menu_item_parent_class)->finalize (obj);
#line 386 "MenuItem.c"
}

/**
 * Wraps a `Gtk.Button` so we can have more control over the menu
 * item widgets and layout.
 */
GType
menu_item_get_type (void)
{
	return menu_item_type_id;
}

GType
menu_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MenuItem), 0, (GInstanceInitFunc) menu_item_instance_init, NULL };
	menu_item_type_id = g_type_module_register_type (module, gtk_button_get_type (), "MenuItem", &g_define_type_info, 0);
	MenuItem_private_offset = sizeof (MenuItemPrivate);
	return menu_item_type_id;
}

static void
_vala_menu_item_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	MenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_ITEM, MenuItem);
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	switch (property_id) {
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		case MENU_ITEM_IMAGE_SOURCE_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		g_value_set_string (value, menu_item_get_image_source (self));
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		case MENU_ITEM_LABEL_TEXT_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		g_value_set_string (value, menu_item_get_label_text (self));
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		break;
#line 430 "MenuItem.c"
		default:
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		break;
#line 436 "MenuItem.c"
	}
}

static void
_vala_menu_item_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	MenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_ITEM, MenuItem);
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
	switch (property_id) {
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		case MENU_ITEM_IMAGE_SOURCE_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		menu_item_set_image_source (self, g_value_get_string (value));
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		case MENU_ITEM_LABEL_TEXT_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		menu_item_set_label_text (self, g_value_get_string (value));
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		break;
#line 462 "MenuItem.c"
		default:
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/panel/applets/budgie-menu/MenuItem.vala"
		break;
#line 468 "MenuItem.c"
	}
}

