/* app_sound_control.c generated by valac 0.56.13, the Vala compiler
 * generated from app_sound_control.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "org.buddiesofbudgie.budgie-desktop.raven.widget.SoundOutput.h"
#include <pulse/pulseaudio.h>
#include <gvc-mixer-control.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gvc-mixer-stream.h>
#include <gio/gdesktopappinfo.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	BUDGIE_APP_SOUND_CONTROL_0_PROPERTY,
	BUDGIE_APP_SOUND_CONTROL_NUM_PROPERTIES
};
static GParamSpec* budgie_app_sound_control_properties[BUDGIE_APP_SOUND_CONTROL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _BudgieAppSoundControlPrivate {
	GvcMixerControl* mixer;
	GtkBox* app_info_header;
	GtkImage* app_image;
	GtkLabel* app_label;
	GtkButton* app_mute_button;
	GtkScale* volume_slider;
	guint32* volume;
	GtkImage* audio_not_muted;
	GtkImage* audio_muted;
	gulong scale_id;
};

static gint BudgieAppSoundControl_private_offset;
static gpointer budgie_app_sound_control_parent_class = NULL;
static GType budgie_app_sound_control_type_id = 0;

static void budgie_app_sound_control_toggle_mute_state (BudgieAppSoundControl* self);
static void _budgie_app_sound_control_toggle_mute_state_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static guint32 budgie_app_sound_control_get_base_volume (BudgieAppSoundControl* self);
static void budgie_app_sound_control_set_mute_ui (BudgieAppSoundControl* self);
static guint32* _uint32_dup (guint32* self);
static void budgie_app_sound_control_on_slider_change (BudgieAppSoundControl* self);
static void _budgie_app_sound_control_on_slider_change_gtk_range_value_changed (GtkRange* _sender,
                                                                         gpointer self);
static void budgie_app_sound_control_finalize (GObject * obj);

static inline gpointer
budgie_app_sound_control_get_instance_private (BudgieAppSoundControl* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieAppSoundControl_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/raven/widgets/sound-output/app_sound_control.vala"
	return self ? g_object_ref (self) : NULL;
#line 78 "app_sound_control.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 100 "app_sound_control.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 104 "app_sound_control.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 110 "app_sound_control.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 114 "app_sound_control.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 118 "app_sound_control.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 126 "app_sound_control.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 154 "app_sound_control.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 163 "app_sound_control.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 177 "app_sound_control.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 186 "app_sound_control.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 200 "app_sound_control.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 209 "app_sound_control.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 218 "app_sound_control.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 241 "app_sound_control.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 250 "app_sound_control.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 269 "app_sound_control.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 273 "app_sound_control.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 279 "app_sound_control.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 289 "app_sound_control.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 297 "app_sound_control.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 301 "app_sound_control.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 307 "app_sound_control.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 317 "app_sound_control.c"
}

static void
_budgie_app_sound_control_toggle_mute_state_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
#line 106 "../src/raven/widgets/sound-output/app_sound_control.vala"
	budgie_app_sound_control_toggle_mute_state ((BudgieAppSoundControl*) self);
#line 326 "app_sound_control.c"
}

static guint32*
_uint32_dup (guint32* self)
{
	guint32* dup;
#line 121 "../src/raven/widgets/sound-output/app_sound_control.vala"
	dup = g_new0 (guint32, 1);
#line 121 "../src/raven/widgets/sound-output/app_sound_control.vala"
	memcpy (dup, self, sizeof (guint32));
#line 121 "../src/raven/widgets/sound-output/app_sound_control.vala"
	return dup;
#line 339 "app_sound_control.c"
}

static gpointer
__uint32_dup0 (gpointer self)
{
#line 121 "../src/raven/widgets/sound-output/app_sound_control.vala"
	return self ? _uint32_dup (self) : NULL;
#line 347 "app_sound_control.c"
}

static void
_budgie_app_sound_control_on_slider_change_gtk_range_value_changed (GtkRange* _sender,
                                                                    gpointer self)
{
#line 124 "../src/raven/widgets/sound-output/app_sound_control.vala"
	budgie_app_sound_control_on_slider_change ((BudgieAppSoundControl*) self);
#line 356 "app_sound_control.c"
}

BudgieAppSoundControl*
budgie_app_sound_control_construct (GType object_type,
                                    GvcMixerControl* c_mixer,
                                    GvcMixerStream* c_primary,
                                    GvcMixerStream* c_stream,
                                    const gchar* c_icon,
                                    const gchar* c_name)
{
	BudgieAppSoundControl * self = NULL;
	GvcMixerControl* _tmp0_;
	GvcMixerStream* _tmp1_;
	GvcMixerStream* _tmp2_;
	gchar* _tmp3_;
	gchar* alsa_beg = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GDesktopAppInfo* info = NULL;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GDesktopAppInfo* _tmp18_;
	GDesktopAppInfo* _tmp19_;
	GDesktopAppInfo* _tmp20_;
	gchar* stream_name = NULL;
	GvcMixerStream* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	GtkIconTheme* current_theme = NULL;
	GtkIconTheme* _tmp31_;
	GtkIconTheme* _tmp32_;
	gchar* usable_icon_name = NULL;
	gchar* _tmp33_;
	GtkIconTheme* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp42_;
	GtkImage* _tmp52_;
	GtkImage* _tmp53_;
	GtkImage* _tmp54_;
	GtkImage* _tmp55_;
	GtkBox* app_info = NULL;
	GtkBox* _tmp56_;
	GtkBox* _tmp57_;
	const gchar* _tmp58_;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkLabel* _tmp63_;
	GtkButton* _tmp64_;
	GtkButton* _tmp65_;
	GtkStyleContext* _tmp66_;
	GtkButton* _tmp67_;
	GtkBox* _tmp68_;
	GtkLabel* _tmp69_;
	GtkBox* _tmp70_;
	GtkButton* _tmp71_;
	guint32 max_vol = 0U;
	guint32 stream_volume = 0U;
	GvcMixerStream* _tmp72_;
	guint32 max_vol_step = 0U;
	GtkScale* _tmp73_;
	GtkScale* _tmp74_;
	GtkScale* _tmp75_;
	guint32* _tmp76_;
	GtkScale* _tmp77_;
	GtkScale* _tmp78_;
	gulong _tmp79_;
	GtkBox* _tmp80_;
	GtkBox* _tmp81_;
	GtkBox* _tmp82_;
	GtkScale* _tmp83_;
	const gchar* _tmp84_;
	GtkImage* _tmp85_;
	GtkImage* _tmp86_;
	GtkBox* _tmp88_;
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_val_if_fail (c_mixer != NULL, NULL);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_val_if_fail (c_primary != NULL, NULL);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_val_if_fail (c_stream != NULL, NULL);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_val_if_fail (c_icon != NULL, NULL);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_val_if_fail (c_name != NULL, NULL);
#line 31 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self = (BudgieAppSoundControl*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, "margin", 4, NULL);
#line 33 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
#line 34 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 10);
#line 35 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 10);
#line 37 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (c_mixer == NULL) {
#line 38 "../src/raven/widgets/sound-output/app_sound_control.vala"
		return self;
#line 457 "app_sound_control.c"
	}
#line 41 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (c_primary == NULL) {
#line 42 "../src/raven/widgets/sound-output/app_sound_control.vala"
		return self;
#line 463 "app_sound_control.c"
	}
#line 45 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = _g_object_ref0 (c_mixer);
#line 45 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->mixer);
#line 45 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->mixer = _tmp0_;
#line 46 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp1_ = _g_object_ref0 (c_primary);
#line 46 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->primary_stream);
#line 46 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->primary_stream = _tmp1_;
#line 47 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp2_ = _g_object_ref0 (c_stream);
#line 47 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->stream);
#line 47 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->stream = _tmp2_;
#line 48 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp3_ = g_strdup (c_name);
#line 48 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (self->app_name);
#line 48 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->app_name = _tmp3_;
#line 56 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp4_ = g_strdup ("ALSA plug-in [");
#line 56 "../src/raven/widgets/sound-output/app_sound_control.vala"
	alsa_beg = _tmp4_;
#line 57 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp5_ = self->app_name;
#line 57 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp6_ = alsa_beg;
#line 57 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (g_str_has_prefix (_tmp5_, _tmp6_)) {
#line 499 "app_sound_control.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
#line 58 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp7_ = self->app_name;
#line 58 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp8_ = alsa_beg;
#line 58 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp9_ = string_replace (_tmp7_, _tmp8_, "");
#line 58 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 58 "../src/raven/widgets/sound-output/app_sound_control.vala"
		self->app_name = _tmp9_;
#line 59 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp10_ = self->app_name;
#line 59 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp11_ = self->app_name;
#line 59 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp12_ = strlen (_tmp11_);
#line 59 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp13_ = _tmp12_;
#line 59 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp14_ = string_substring (_tmp10_, (glong) 0, (glong) (_tmp13_ - 1));
#line 59 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 59 "../src/raven/widgets/sound-output/app_sound_control.vala"
		self->app_name = _tmp14_;
#line 532 "app_sound_control.c"
	}
#line 62 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp15_ = self->app_name;
#line 62 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp16_ = g_strconcat (_tmp15_, ".desktop", NULL);
#line 62 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp17_ = _tmp16_;
#line 62 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp18_ = g_desktop_app_info_new (_tmp17_);
#line 62 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp19_ = _tmp18_;
#line 62 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (_tmp17_);
#line 62 "../src/raven/widgets/sound-output/app_sound_control.vala"
	info = _tmp19_;
#line 64 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp20_ = info;
#line 64 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (_tmp20_ != NULL) {
#line 552 "app_sound_control.c"
		gchar* desktop_app_name = NULL;
		GDesktopAppInfo* _tmp21_;
		gchar* _tmp22_;
		gboolean _tmp23_ = FALSE;
		const gchar* _tmp24_;
#line 65 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp21_ = info;
#line 65 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp22_ = g_desktop_app_info_get_string (_tmp21_, "Name");
#line 65 "../src/raven/widgets/sound-output/app_sound_control.vala"
		desktop_app_name = _tmp22_;
#line 67 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp24_ = desktop_app_name;
#line 67 "../src/raven/widgets/sound-output/app_sound_control.vala"
		if (g_strcmp0 (_tmp24_, "") != 0) {
#line 568 "app_sound_control.c"
			const gchar* _tmp25_;
#line 67 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_tmp25_ = desktop_app_name;
#line 67 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_tmp23_ = _tmp25_ != NULL;
#line 574 "app_sound_control.c"
		} else {
#line 67 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_tmp23_ = FALSE;
#line 578 "app_sound_control.c"
		}
#line 67 "../src/raven/widgets/sound-output/app_sound_control.vala"
		if (_tmp23_) {
#line 582 "app_sound_control.c"
			const gchar* _tmp26_;
			gchar* _tmp27_;
#line 68 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_tmp26_ = desktop_app_name;
#line 68 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_tmp27_ = g_strdup (_tmp26_);
#line 68 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_g_free0 (self->app_name);
#line 68 "../src/raven/widgets/sound-output/app_sound_control.vala"
			self->app_name = _tmp27_;
#line 593 "app_sound_control.c"
		}
#line 64 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (desktop_app_name);
#line 597 "app_sound_control.c"
	}
#line 72 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp28_ = self->stream;
#line 72 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp29_ = gvc_mixer_stream_get_name (_tmp28_);
#line 72 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp30_ = g_strdup (_tmp29_);
#line 72 "../src/raven/widgets/sound-output/app_sound_control.vala"
	stream_name = _tmp30_;
#line 74 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp31_ = gtk_icon_theme_get_default ();
#line 74 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp32_ = _g_object_ref0 (_tmp31_);
#line 74 "../src/raven/widgets/sound-output/app_sound_control.vala"
	current_theme = _tmp32_;
#line 75 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp33_ = g_strdup (c_icon);
#line 75 "../src/raven/widgets/sound-output/app_sound_control.vala"
	usable_icon_name = _tmp33_;
#line 77 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp34_ = current_theme;
#line 77 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp35_ = self->app_name;
#line 77 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (gtk_icon_theme_has_icon (_tmp34_, _tmp35_)) {
#line 623 "app_sound_control.c"
		const gchar* _tmp36_;
		gchar* _tmp37_;
#line 78 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp36_ = self->app_name;
#line 78 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp37_ = g_strdup (_tmp36_);
#line 78 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (usable_icon_name);
#line 78 "../src/raven/widgets/sound-output/app_sound_control.vala"
		usable_icon_name = _tmp37_;
#line 634 "app_sound_control.c"
	} else {
		GtkIconTheme* _tmp38_;
		const gchar* _tmp39_;
#line 79 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp38_ = current_theme;
#line 79 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp39_ = stream_name;
#line 79 "../src/raven/widgets/sound-output/app_sound_control.vala"
		if (gtk_icon_theme_has_icon (_tmp38_, _tmp39_)) {
#line 644 "app_sound_control.c"
			const gchar* _tmp40_;
			gchar* _tmp41_;
#line 80 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_tmp40_ = stream_name;
#line 80 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_tmp41_ = g_strdup (_tmp40_);
#line 80 "../src/raven/widgets/sound-output/app_sound_control.vala"
			_g_free0 (usable_icon_name);
#line 80 "../src/raven/widgets/sound-output/app_sound_control.vala"
			usable_icon_name = _tmp41_;
#line 655 "app_sound_control.c"
		}
	}
#line 83 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp42_ = usable_icon_name;
#line 83 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (g_strcmp0 (_tmp42_, "applications-multimedia") != 0) {
#line 662 "app_sound_control.c"
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp43_ = self->app_name;
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp44_ = string_substring (_tmp43_, (glong) 0, (glong) 1);
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp45_ = _tmp44_;
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp46_ = g_ascii_strup (_tmp45_, (gssize) -1);
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp47_ = _tmp46_;
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp48_ = self->app_name;
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp49_ = string_substring (_tmp48_, (glong) 1, (glong) -1);
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp50_ = _tmp49_;
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp51_ = g_strconcat (_tmp47_, _tmp50_, NULL);
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		self->app_name = _tmp51_;
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (_tmp50_);
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (_tmp47_);
#line 84 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (_tmp45_);
#line 700 "app_sound_control.c"
	}
#line 90 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp52_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-high-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 90 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp52_);
#line 90 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_not_muted);
#line 90 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->audio_not_muted = _tmp52_;
#line 91 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp53_ = self->priv->audio_not_muted;
#line 91 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_image_set_pixel_size (_tmp53_, 12);
#line 92 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp54_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 92 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp54_);
#line 92 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_muted);
#line 92 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->audio_muted = _tmp54_;
#line 93 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp55_ = self->priv->audio_muted;
#line 93 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_image_set_pixel_size (_tmp55_, 12);
#line 95 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp56_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 95 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp56_);
#line 95 "../src/raven/widgets/sound-output/app_sound_control.vala"
	app_info = _tmp56_;
#line 96 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp57_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 96 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp57_);
#line 96 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_info_header);
#line 96 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_info_header = _tmp57_;
#line 98 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp58_ = self->app_name;
#line 98 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp59_ = (GtkLabel*) gtk_label_new (_tmp58_);
#line 98 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp59_);
#line 98 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_label);
#line 98 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_label = _tmp59_;
#line 99 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp60_ = self->priv->app_label;
#line 99 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_label_set_ellipsize (_tmp60_, PANGO_ELLIPSIZE_END);
#line 100 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp61_ = self->priv->app_label;
#line 100 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp61_, GTK_ALIGN_START);
#line 101 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp62_ = self->priv->app_label;
#line 101 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_label_set_justify (_tmp62_, GTK_JUSTIFY_LEFT);
#line 102 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp63_ = self->priv->app_label;
#line 102 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp63_, 10);
#line 104 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp64_ = (GtkButton*) gtk_button_new ();
#line 104 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp64_);
#line 104 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_mute_button);
#line 104 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_mute_button = _tmp64_;
#line 105 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp65_ = self->priv->app_mute_button;
#line 105 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp66_ = gtk_widget_get_style_context ((GtkWidget*) _tmp65_);
#line 105 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_style_context_add_class (_tmp66_, "flat");
#line 106 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp67_ = self->priv->app_mute_button;
#line 106 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_signal_connect_object (_tmp67_, "clicked", (GCallback) _budgie_app_sound_control_toggle_mute_state_gtk_button_clicked, self, 0);
#line 108 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp68_ = self->priv->app_info_header;
#line 108 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp69_ = self->priv->app_label;
#line 108 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_box_pack_start (_tmp68_, (GtkWidget*) _tmp69_, FALSE, TRUE, (guint) 0);
#line 109 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp70_ = self->priv->app_info_header;
#line 109 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp71_ = self->priv->app_mute_button;
#line 109 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_box_pack_end (_tmp70_, (GtkWidget*) _tmp71_, FALSE, FALSE, (guint) 0);
#line 111 "../src/raven/widgets/sound-output/app_sound_control.vala"
	max_vol = budgie_app_sound_control_get_base_volume (self);
#line 112 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp72_ = self->stream;
#line 112 "../src/raven/widgets/sound-output/app_sound_control.vala"
	stream_volume = gvc_mixer_stream_get_volume (_tmp72_);
#line 113 "../src/raven/widgets/sound-output/app_sound_control.vala"
	max_vol_step = max_vol / 20;
#line 115 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp73_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) max_vol, (gdouble) max_vol_step);
#line 115 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp73_);
#line 115 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 115 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->volume_slider = _tmp73_;
#line 116 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp74_ = self->priv->volume_slider;
#line 116 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_scale_set_draw_value (_tmp74_, FALSE);
#line 117 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp75_ = self->priv->volume_slider;
#line 117 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_range_set_increments ((GtkRange*) _tmp75_, (gdouble) max_vol_step, (gdouble) max_vol_step);
#line 119 "../src/raven/widgets/sound-output/app_sound_control.vala"
	budgie_app_sound_control_set_mute_ui (self);
#line 121 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp76_ = __uint32_dup0 (&stream_volume);
#line 121 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 121 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->volume = _tmp76_;
#line 122 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp77_ = self->priv->volume_slider;
#line 122 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_range_set_value ((GtkRange*) _tmp77_, (gdouble) stream_volume);
#line 124 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp78_ = self->priv->volume_slider;
#line 124 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp79_ = g_signal_connect_object ((GtkRange*) _tmp78_, "value-changed", (GCallback) _budgie_app_sound_control_on_slider_change_gtk_range_value_changed, self, 0);
#line 124 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->scale_id = _tmp79_;
#line 126 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp80_ = app_info;
#line 126 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp81_ = self->priv->app_info_header;
#line 126 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_box_pack_start (_tmp80_, (GtkWidget*) _tmp81_, TRUE, FALSE, (guint) 0);
#line 127 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp82_ = app_info;
#line 127 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp83_ = self->priv->volume_slider;
#line 127 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_box_pack_end (_tmp82_, (GtkWidget*) _tmp83_, TRUE, FALSE, (guint) 0);
#line 129 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp84_ = usable_icon_name;
#line 129 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp85_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp84_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 129 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_object_ref_sink (_tmp85_);
#line 129 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_image);
#line 129 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_image = _tmp85_;
#line 131 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp86_ = self->priv->app_image;
#line 131 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (_tmp86_ != NULL) {
#line 864 "app_sound_control.c"
		GtkImage* _tmp87_;
#line 132 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp87_ = self->priv->app_image;
#line 132 "../src/raven/widgets/sound-output/app_sound_control.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp87_, FALSE, FALSE, (guint) 0);
#line 870 "app_sound_control.c"
	}
#line 135 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp88_ = app_info;
#line 135 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp88_, TRUE, TRUE, (guint) 0);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (app_info);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (usable_icon_name);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (current_theme);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (stream_name);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (info);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (alsa_beg);
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	return self;
#line 890 "app_sound_control.c"
}

BudgieAppSoundControl*
budgie_app_sound_control_new (GvcMixerControl* c_mixer,
                              GvcMixerStream* c_primary,
                              GvcMixerStream* c_stream,
                              const gchar* c_icon,
                              const gchar* c_name)
{
#line 30 "../src/raven/widgets/sound-output/app_sound_control.vala"
	return budgie_app_sound_control_construct (BUDGIE_TYPE_APP_SOUND_CONTROL, c_mixer, c_primary, c_stream, c_icon, c_name);
#line 902 "app_sound_control.c"
}

/**
 * get_base_volume will get the recommended base volume based on the stream and primary device stream
 */
static guint32
budgie_app_sound_control_get_base_volume (BudgieAppSoundControl* self)
{
	guint32 base_vol = 0U;
	GvcMixerStream* _tmp0_;
	guint32 primary_stream_vol = 0U;
	GvcMixerStream* _tmp1_;
	guint32 _tmp2_ = 0U;
	guint32 result;
#line 141 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 142 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 142 "../src/raven/widgets/sound-output/app_sound_control.vala"
	base_vol = gvc_mixer_stream_get_volume (_tmp0_);
#line 143 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp1_ = self->primary_stream;
#line 143 "../src/raven/widgets/sound-output/app_sound_control.vala"
	primary_stream_vol = gvc_mixer_stream_get_base_volume (_tmp1_);
#line 144 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (base_vol < primary_stream_vol) {
#line 144 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp2_ = primary_stream_vol;
#line 931 "app_sound_control.c"
	} else {
#line 144 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp2_ = base_vol;
#line 935 "app_sound_control.c"
	}
#line 144 "../src/raven/widgets/sound-output/app_sound_control.vala"
	result = _tmp2_;
#line 144 "../src/raven/widgets/sound-output/app_sound_control.vala"
	return result;
#line 941 "app_sound_control.c"
}

/**
 * on_slider_change will handle when our volume_slider scale changes
 */
static void
budgie_app_sound_control_on_slider_change (BudgieAppSoundControl* self)
{
	gdouble slider_value = 0.0;
	GtkScale* _tmp0_;
	GtkScale* _tmp1_;
	guint32 stream_vol = 0U;
	guint32* _tmp2_;
	GvcMixerStream* _tmp3_;
	GtkScale* _tmp5_;
#line 150 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = self->priv->volume_slider;
#line 151 "../src/raven/widgets/sound-output/app_sound_control.vala"
	slider_value = gtk_range_get_value ((GtkRange*) _tmp0_);
#line 153 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp1_ = self->priv->volume_slider;
#line 153 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_signal_handler_block (_tmp1_, self->priv->scale_id);
#line 154 "../src/raven/widgets/sound-output/app_sound_control.vala"
	stream_vol = (guint32) slider_value;
#line 156 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp2_ = __uint32_dup0 (&stream_vol);
#line 156 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 156 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->volume = _tmp2_;
#line 158 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp3_ = self->stream;
#line 158 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (gvc_mixer_stream_set_volume (_tmp3_, stream_vol)) {
#line 979 "app_sound_control.c"
		GvcMixerStream* _tmp4_;
#line 159 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp4_ = self->stream;
#line 159 "../src/raven/widgets/sound-output/app_sound_control.vala"
		gvc_mixer_stream_push_volume (_tmp4_);
#line 985 "app_sound_control.c"
	}
#line 162 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp5_ = self->priv->volume_slider;
#line 162 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_signal_handler_unblock (_tmp5_, self->priv->scale_id);
#line 991 "app_sound_control.c"
}

/**
 * refresh is responsible for performing UI refresh / updating
 */
void
budgie_app_sound_control_refresh (BudgieAppSoundControl* self)
{
	gchar* stream_name = NULL;
	GvcMixerStream* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 168 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 169 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp1_ = gvc_mixer_stream_get_name (_tmp0_);
#line 169 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 169 "../src/raven/widgets/sound-output/app_sound_control.vala"
	stream_name = _tmp2_;
#line 171 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp3_ = self->app_name;
#line 171 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp4_ = stream_name;
#line 171 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) != 0) {
#line 1022 "app_sound_control.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
		const gchar* _tmp8_;
#line 172 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp5_ = stream_name;
#line 172 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 172 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 172 "../src/raven/widgets/sound-output/app_sound_control.vala"
		self->app_name = _tmp6_;
#line 173 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp7_ = self->priv->app_label;
#line 173 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp8_ = stream_name;
#line 173 "../src/raven/widgets/sound-output/app_sound_control.vala"
		gtk_label_set_label (_tmp7_, _tmp8_);
#line 1041 "app_sound_control.c"
	}
#line 176 "../src/raven/widgets/sound-output/app_sound_control.vala"
	budgie_app_sound_control_refresh_volume (self);
#line 168 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (stream_name);
#line 1047 "app_sound_control.c"
}

/**
 * refresh_volume is our function for updating the volume slider and mute UI
 */
void
budgie_app_sound_control_refresh_volume (BudgieAppSoundControl* self)
{
	guint32 vol = 0U;
	GvcMixerStream* _tmp0_;
	GtkScale* _tmp1_;
	guint32* _tmp3_;
#line 182 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 183 "../src/raven/widgets/sound-output/app_sound_control.vala"
	vol = gvc_mixer_stream_get_volume (_tmp0_);
#line 185 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp1_ = self->priv->volume_slider;
#line 185 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (gtk_range_get_value ((GtkRange*) _tmp1_) != ((gdouble) vol)) {
#line 1070 "app_sound_control.c"
		GtkScale* _tmp2_;
#line 186 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp2_ = self->priv->volume_slider;
#line 186 "../src/raven/widgets/sound-output/app_sound_control.vala"
		gtk_range_set_value ((GtkRange*) _tmp2_, (gdouble) vol);
#line 1076 "app_sound_control.c"
	}
#line 189 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp3_ = __uint32_dup0 (&vol);
#line 189 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 189 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->volume = _tmp3_;
#line 190 "../src/raven/widgets/sound-output/app_sound_control.vala"
	budgie_app_sound_control_set_mute_ui (self);
#line 1086 "app_sound_control.c"
}

/**
 * set_mute_ui will set the image for the app_mute_button and change dim state of the input
 */
static void
budgie_app_sound_control_set_mute_ui (BudgieAppSoundControl* self)
{
	GvcMixerStream* _tmp0_;
#line 196 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 197 "../src/raven/widgets/sound-output/app_sound_control.vala"
	if (gvc_mixer_stream_get_is_muted (_tmp0_)) {
#line 1102 "app_sound_control.c"
		GtkButton* _tmp1_;
		GtkImage* _tmp2_;
#line 198 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp1_ = self->priv->app_mute_button;
#line 198 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp2_ = self->priv->audio_muted;
#line 198 "../src/raven/widgets/sound-output/app_sound_control.vala"
		gtk_button_set_image (_tmp1_, (GtkWidget*) _tmp2_);
#line 1111 "app_sound_control.c"
	} else {
		GtkButton* _tmp3_;
		GtkImage* _tmp4_;
#line 200 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp3_ = self->priv->app_mute_button;
#line 200 "../src/raven/widgets/sound-output/app_sound_control.vala"
		_tmp4_ = self->priv->audio_not_muted;
#line 200 "../src/raven/widgets/sound-output/app_sound_control.vala"
		gtk_button_set_image (_tmp3_, (GtkWidget*) _tmp4_);
#line 1121 "app_sound_control.c"
	}
}

static void
budgie_app_sound_control_toggle_mute_state (BudgieAppSoundControl* self)
{
	GtkScale* _tmp0_;
	GvcMixerStream* _tmp1_;
	GvcMixerStream* _tmp2_;
	GvcMixerStream* _tmp3_;
	GvcMixerStream* _tmp4_;
	GtkScale* _tmp5_;
#line 204 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = self->priv->volume_slider;
#line 205 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_signal_handler_block (_tmp0_, self->priv->scale_id);
#line 206 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp1_ = self->stream;
#line 206 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp2_ = self->stream;
#line 206 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gvc_mixer_stream_change_is_muted (_tmp1_, !gvc_mixer_stream_get_is_muted (_tmp2_));
#line 207 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp3_ = self->stream;
#line 207 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp4_ = self->stream;
#line 207 "../src/raven/widgets/sound-output/app_sound_control.vala"
	gvc_mixer_stream_set_is_muted (_tmp3_, !gvc_mixer_stream_get_is_muted (_tmp4_));
#line 208 "../src/raven/widgets/sound-output/app_sound_control.vala"
	budgie_app_sound_control_set_mute_ui (self);
#line 209 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp5_ = self->priv->volume_slider;
#line 209 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_signal_handler_unblock (_tmp5_, self->priv->scale_id);
#line 1158 "app_sound_control.c"
}

static void
budgie_app_sound_control_class_init (BudgieAppSoundControlClass * klass,
                                     gpointer klass_data)
{
#line 13 "../src/raven/widgets/sound-output/app_sound_control.vala"
	budgie_app_sound_control_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/raven/widgets/sound-output/app_sound_control.vala"
	g_type_class_adjust_private_offset (klass, &BudgieAppSoundControl_private_offset);
#line 13 "../src/raven/widgets/sound-output/app_sound_control.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_app_sound_control_finalize;
#line 1171 "app_sound_control.c"
}

static void
budgie_app_sound_control_instance_init (BudgieAppSoundControl * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
#line 13 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv = budgie_app_sound_control_get_instance_private (self);
#line 14 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->mixer = NULL;
#line 15 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->primary_stream = NULL;
#line 16 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->stream = NULL;
#line 17 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_info_header = NULL;
#line 18 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_image = NULL;
#line 19 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_label = NULL;
#line 20 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->app_mute_button = NULL;
#line 21 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->volume_slider = NULL;
#line 24 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->audio_not_muted = NULL;
#line 25 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->priv->audio_muted = NULL;
#line 27 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_tmp0_ = g_strdup ("");
#line 27 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self->app_name = _tmp0_;
#line 1205 "app_sound_control.c"
}

static void
budgie_app_sound_control_finalize (GObject * obj)
{
	BudgieAppSoundControl * self;
#line 13 "../src/raven/widgets/sound-output/app_sound_control.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControl);
#line 14 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->mixer);
#line 15 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->primary_stream);
#line 16 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->stream);
#line 17 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_info_header);
#line 18 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_image);
#line 19 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_label);
#line 20 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_mute_button);
#line 21 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 22 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 24 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_not_muted);
#line 25 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_muted);
#line 27 "../src/raven/widgets/sound-output/app_sound_control.vala"
	_g_free0 (self->app_name);
#line 13 "../src/raven/widgets/sound-output/app_sound_control.vala"
	G_OBJECT_CLASS (budgie_app_sound_control_parent_class)->finalize (obj);
#line 1240 "app_sound_control.c"
}

GType
budgie_app_sound_control_get_type (void)
{
	return budgie_app_sound_control_type_id;
}

GType
budgie_app_sound_control_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieAppSoundControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_app_sound_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieAppSoundControl), 0, (GInstanceInitFunc) budgie_app_sound_control_instance_init, NULL };
	budgie_app_sound_control_type_id = g_type_module_register_type (module, gtk_box_get_type (), "BudgieAppSoundControl", &g_define_type_info, 0);
	BudgieAppSoundControl_private_offset = sizeof (BudgieAppSoundControlPrivate);
	return budgie_app_sound_control_type_id;
}

