/* IconButton.c generated by valac 0.56.13, the Vala compiler
 * generated from IconButton.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "icontasklistapplet.h"
#include <libwnck/libwnck.h>
#include <gio/gio.h>
#include "abomination.h"
#include <gio/gdesktopappinfo.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "appsys.h"
#include "plugin.h"
#include <cairo-gobject.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>

#define DEFAULT_OPACITY 0.1
#define INDICATOR_SIZE 2
#define INDICATOR_SPACING 1
#define INACTIVE_INDICATOR_SPACING 2
#define TARGET_ICON_PADDING 18
#define TARGET_ICON_SCALE (2.0 / 3.0)
#define FORMULA_SWAP_POINT (TARGET_ICON_PADDING * 3)

enum  {
	ICON_BUTTON_0_PROPERTY,
	ICON_BUTTON_ABOMINATION_PROPERTY,
	ICON_BUTTON_APP_SYSTEM_PROPERTY,
	ICON_BUTTON_DESKTOP_HELPER_PROPERTY,
	ICON_BUTTON_POPOVER_MANAGER_PROPERTY,
	ICON_BUTTON_NUM_PROPERTIES
};
static GParamSpec* icon_button_properties[ICON_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define __vala_GdkEventButton_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventButton_free (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
enum  {
	ICON_BUTTON_BECAME_EMPTY_SIGNAL,
	ICON_BUTTON_PINNED_CHANGED_SIGNAL,
	ICON_BUTTON_NUM_SIGNALS
};
static guint icon_button_signals[ICON_BUTTON_NUM_SIGNALS] = {0};

struct _IconButtonPrivate {
	BudgieIconPopover* popover;
	WnckScreen* screen;
	GSettings* settings;
	BudgieAbominationAppGroup* class_group;
	GDesktopAppInfo* app_info;
	gint window_count;
	GtkAllocation definite_allocation;
	gboolean originally_pinned;
	GdkAppLaunchContext* launch_context;
	gint64 last_scroll_time;
	gboolean needs_attention;
	gint target_icon_size;
	BudgieAbominationAbomination* _abomination;
	BudgieAppSystem* _app_system;
	DesktopHelper* _desktop_helper;
	BudgiePopoverManager* _popover_manager;
};

struct _Block2Data {
	int _ref_count_;
	IconButton* self;
	gulong xid;
};

struct _Block3Data {
	int _ref_count_;
	IconButton* self;
	WnckWindow* window;
};

struct _Block4Data {
	int _ref_count_;
	IconButton* self;
	GdkEventButton* event;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	gboolean one_active;
};

static gint IconButton_private_offset;
static gpointer icon_button_parent_class = NULL;
static GType icon_button_type_id = 0;

static void icon_button_gobject_constructors_suck (IconButton* self);
static gboolean icon_button_has_valid_windows (IconButton* self,
                                        gint* num_windows);
static gboolean __lambda19_ (IconButton* self);
static gboolean ___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                     GdkEventCrossing* event,
                                                     gpointer self);
static gboolean __lambda20_ (IconButton* self);
static gboolean ___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                     GdkEventCrossing* event,
                                                     gpointer self);
static void __lambda21_ (IconButton* self,
                  GdkDragContext* context);
static void ___lambda21__gtk_widget_drag_begin (GtkWidget* _sender,
                                         GdkDragContext* context,
                                         gpointer self);
static void __lambda22_ (IconButton* self,
                  GtkWidget* widget,
                  GdkDragContext* context,
                  GtkSelectionData* selection_data,
                  guint info,
                  guint time);
static void ___lambda22__gtk_widget_drag_data_get (GtkWidget* _sender,
                                            GdkDragContext* context,
                                            GtkSelectionData* selection_data,
                                            guint info,
                                            guint time_,
                                            gpointer self);
static void _icon_button_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static void icon_button_on_launched (IconButton* self,
                              GAppInfo* info,
                              GVariant* v);
static void _icon_button_on_launched_g_app_launch_context_launched (GAppLaunchContext* _sender,
                                                             GAppInfo* info,
                                                             GVariant* platform_data,
                                                             gpointer self);
static void icon_button_on_launch_failed (IconButton* self,
                                   const gchar* id);
static void _icon_button_on_launch_failed_g_app_launch_context_launch_failed (GAppLaunchContext* _sender,
                                                                       const gchar* startup_notify_id,
                                                                       gpointer self);
static void ___lambda23_ (IconButton* self);
static void ____lambda23__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                               const gchar* old_name,
                                                               const gchar* new_name,
                                                               gpointer self);
static void ___lambda24_ (IconButton* self,
                   GDesktopAppInfo* app_info);
static void ____lambda24__budgie_abomination_running_app_app_info_changed (BudgieAbominationRunningApp* _sender,
                                                                    GDesktopAppInfo* app_info,
                                                                    gpointer self);
static void ___lambda25_ (IconButton* self);
static void ____lambda25__budgie_abomination_running_app_icon_changed (BudgieAbominationRunningApp* _sender,
                                                                const gchar* icon_name,
                                                                gpointer self);
static void __lambda26_ (IconButton* self);
static void icon_button_launch_app (IconButton* self,
                             guint32 time);
static void ___lambda26__budgie_icon_popover_launch_new_instance (BudgieIconPopover* _sender,
                                                           gpointer self);
static void __lambda27_ (IconButton* self);
static void ___lambda27__budgie_icon_popover_added_window (BudgieIconPopover* _sender,
                                                    gpointer self);
static void __lambda28_ (IconButton* self);
static void ___lambda28__budgie_icon_popover_closed_all (BudgieIconPopover* _sender,
                                                  gpointer self);
static void __lambda29_ (IconButton* self);
static void ___lambda29__budgie_icon_popover_closed_window (BudgieIconPopover* _sender,
                                                     gpointer self);
static void __lambda30_ (IconButton* self,
                  gboolean new_pinned_state);
static void ___lambda30__budgie_icon_popover_changed_pin_state (BudgieIconPopover* _sender,
                                                         gboolean new_state,
                                                         gpointer self);
static void __lambda31_ (IconButton* self,
                  gulong xid,
                  gint wid);
static void ___lambda31__budgie_icon_popover_move_window_to_workspace (BudgieIconPopover* _sender,
                                                                gulong xid,
                                                                gint workspace_num,
                                                                gpointer self);
static void __lambda32_ (IconButton* self,
                  const gchar* action);
static void ___lambda32__budgie_icon_popover_perform_action (BudgieIconPopover* _sender,
                                                      const gchar* action,
                                                      gpointer self);
static void __lambda33_ (IconButton* self,
                  WnckWorkspace* workspace);
static void ___lambda33__wnck_screen_workspace_created (WnckScreen* _sender,
                                                 WnckWorkspace* space,
                                                 gpointer self);
static void __lambda34_ (IconButton* self,
                  WnckWorkspace* workspace);
static void ___lambda34__wnck_screen_workspace_destroyed (WnckScreen* _sender,
                                                   WnckWorkspace* space,
                                                   gpointer self);
static void __lambda35_ (IconButton* self);
static void ___lambda35__budgie_abomination_app_group_icon_changed (BudgieAbominationAppGroup* _sender,
                                                             gpointer self);
static void __lambda36_ (IconButton* self,
                  WnckWindow* new_window);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean icon_button_should_add_window (IconButton* self,
                                        WnckWindow* new_window);
static void __lambda37_ (Block2Data* _data2_);
static void ___lambda37__wnck_window_name_changed (WnckWindow* _sender,
                                            gpointer self);
static void ___lambda36__budgie_abomination_app_group_added_window (BudgieAbominationAppGroup* _sender,
                                                             WnckWindow* window,
                                                             gpointer self);
static void __lambda38_ (IconButton* self,
                  WnckWindow* old_window);
static void ___lambda38__budgie_abomination_app_group_removed_window (BudgieAbominationAppGroup* _sender,
                                                               WnckWindow* window,
                                                               gpointer self);
static void icon_button_setup_popover_with_class (IconButton* self);
static gboolean icon_button_real_draw (GtkWidget* base,
                                cairo_t* cr);
static gboolean _cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                                     const cairo_rectangle_int_t * s2);
static void _____lambda39_ (IconButton* self);
static void ______lambda39__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                                 const gchar* old_name,
                                                                 const gchar* new_name,
                                                                 gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _______lambda40_ (Block3Data* _data3_);
static void ________lambda40__wnck_window_name_changed (WnckWindow* _sender,
                                                 gpointer self);
static void _______lambda41_ (Block3Data* _data3_);
static void ________lambda41__wnck_window_state_changed (WnckWindow* _sender,
                                                  WnckWindowState changed_mask,
                                                  WnckWindowState new_state,
                                                  gpointer self);
static void icon_button_real_get_preferred_width (GtkWidget* base,
                                           gint* min,
                                           gint* nat);
static void icon_button_real_get_preferred_height (GtkWidget* base,
                                            gint* min,
                                            gint* nat);
static gboolean icon_button_real_button_press_event (GtkWidget* base,
                                              GdkEventButton* event);
static void icon_button_handle_launch_clicks (IconButton* self,
                                       GdkEventButton* event,
                                       gboolean was_double_click);
static gboolean icon_button_real_button_release_event (GtkWidget* base,
                                                GdkEventButton* event);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static GdkEventButton* _vala_GdkEventButton_copy (GdkEventButton* self);
static void _vala_GdkEventButton_free (GdkEventButton* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void icon_button_toggle_window_minstate (IconButton* self,
                                         guint32 time,
                                         WnckWindow* win);
static void _____lambda42_ (Block5Data* _data5_,
                     WnckWindow* w);
static void ______lambda42__gfunc (gconstpointer data,
                            gpointer self);
static gboolean icon_button_real_scroll_event (GtkWidget* base,
                                        GdkEventScroll* event);
static void icon_button_finalize (GObject * obj);
static void _vala_icon_button_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_icon_button_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const GtkTargetEntry DESKTOP_HELPER_targets[3];

static inline gpointer
icon_button_get_instance_private (IconButton* self)
{
	return G_STRUCT_MEMBER_P (self, IconButton_private_offset);
}

/**
 * Bootstrap a button without window nor group, as it should be for pinned
 * buttons without any active apps.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 321 "IconButton.c"
}

IconButton*
icon_button_construct (GType object_type,
                       BudgieAbominationAbomination* ab,
                       BudgieAppSystem* appsys,
                       GSettings* c_settings,
                       DesktopHelper* helper,
                       BudgiePopoverManager* manager,
                       GDesktopAppInfo* info,
                       const gchar* button_id)
{
	IconButton * self = NULL;
	GSettings* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	gchar* _tmp2_;
#line 61 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 61 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (button_id != NULL, NULL);
#line 62 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) g_object_new (object_type, "abomination", ab, "app-system", appsys, "desktop-helper", helper, "popover-manager", manager, NULL);
#line 63 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (c_settings);
#line 63 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->settings);
#line 63 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->settings = _tmp0_;
#line 64 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 64 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->app_info);
#line 64 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->app_info = _tmp1_;
#line 65 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->pinned = TRUE;
#line 66 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->originally_pinned = TRUE;
#line 67 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = g_strdup (button_id);
#line 67 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_free0 (self->button_id);
#line 67 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->button_id = _tmp2_;
#line 68 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_gobject_constructors_suck (self);
#line 69 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_create_popover (self);
#line 71 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->target_icon_size = helper->icon_size;
#line 73 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (icon_button_has_valid_windows (self, NULL)) {
#line 374 "IconButton.c"
		GtkStyleContext* _tmp3_;
#line 74 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 74 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_add_class (_tmp3_, "running");
#line 380 "IconButton.c"
	}
#line 61 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return self;
#line 384 "IconButton.c"
}

IconButton*
icon_button_new (BudgieAbominationAbomination* ab,
                 BudgieAppSystem* appsys,
                 GSettings* c_settings,
                 DesktopHelper* helper,
                 BudgiePopoverManager* manager,
                 GDesktopAppInfo* info,
                 const gchar* button_id)
{
#line 61 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return icon_button_construct (TYPE_ICON_BUTTON, ab, appsys, c_settings, helper, manager, info, button_id);
#line 398 "IconButton.c"
}

/**
 * Bootstrap our button to be ready to work with grouping ENABLED.
 */
IconButton*
icon_button_construct_from_group (GType object_type,
                                  BudgieAbominationAbomination* ab,
                                  BudgieAppSystem* appsys,
                                  GSettings* c_settings,
                                  DesktopHelper* helper,
                                  BudgiePopoverManager* manager,
                                  BudgieAbominationAppGroup* group,
                                  const gchar* button_id)
{
	IconButton * self = NULL;
	GSettings* _tmp0_;
	BudgieAbominationAbomination* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	BudgieAbominationRunningApp* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	BudgieAbominationRunningApp* _tmp7_;
#line 81 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 81 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (button_id != NULL, NULL);
#line 82 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) g_object_new (object_type, "abomination", ab, "app-system", appsys, "desktop-helper", helper, "popover-manager", manager, NULL);
#line 83 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (c_settings);
#line 83 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->settings);
#line 83 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->settings = _tmp0_;
#line 84 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->pinned = FALSE;
#line 85 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->originally_pinned = FALSE;
#line 86 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->_abomination;
#line 86 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = budgie_abomination_app_group_get_name (group);
#line 86 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = _tmp2_;
#line 86 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = budgie_abomination_abomination_get_first_app_of_group (_tmp1_, _tmp3_);
#line 86 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->first_app);
#line 86 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->first_app = _tmp4_;
#line 86 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_free0 (_tmp3_);
#line 87 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = g_strdup (button_id);
#line 87 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_free0 (self->button_id);
#line 87 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->button_id = _tmp5_;
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = self->first_app;
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp7_ != NULL) {
#line 463 "IconButton.c"
		BudgieAbominationRunningApp* _tmp8_;
		GDesktopAppInfo* _tmp9_;
		GDesktopAppInfo* _tmp10_;
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = self->first_app;
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = budgie_abomination_running_app_get_app_info (_tmp8_);
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = _tmp9_;
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = _tmp10_ != NULL;
#line 475 "IconButton.c"
	} else {
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = FALSE;
#line 479 "IconButton.c"
	}
#line 89 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp6_) {
#line 483 "IconButton.c"
		BudgieAbominationRunningApp* _tmp11_;
		GDesktopAppInfo* _tmp12_;
		GDesktopAppInfo* _tmp13_;
		GDesktopAppInfo* _tmp14_;
#line 90 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = self->first_app;
#line 90 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = budgie_abomination_running_app_get_app_info (_tmp11_);
#line 90 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = _tmp12_;
#line 90 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 90 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self->priv->app_info);
#line 90 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self->priv->app_info = _tmp14_;
#line 500 "IconButton.c"
	}
#line 93 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_gobject_constructors_suck (self);
#line 94 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 95 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_create_popover (self);
#line 97 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (icon_button_has_valid_windows (self, NULL)) {
#line 510 "IconButton.c"
		GtkStyleContext* _tmp15_;
#line 98 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 98 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_add_class (_tmp15_, "running");
#line 516 "IconButton.c"
	}
#line 81 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return self;
#line 520 "IconButton.c"
}

IconButton*
icon_button_new_from_group (BudgieAbominationAbomination* ab,
                            BudgieAppSystem* appsys,
                            GSettings* c_settings,
                            DesktopHelper* helper,
                            BudgiePopoverManager* manager,
                            BudgieAbominationAppGroup* group,
                            const gchar* button_id)
{
#line 81 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return icon_button_construct_from_group (TYPE_ICON_BUTTON, ab, appsys, c_settings, helper, manager, group, button_id);
#line 534 "IconButton.c"
}

/**
 * We have race conditions in glib between the desired properties..
 */
static gboolean
__lambda19_ (IconButton* self)
{
	gboolean result;
#line 111 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 112 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 113 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 113 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 552 "IconButton.c"
}

static gboolean
___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                            GdkEventCrossing* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda19_ ((IconButton*) self);
#line 110 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 564 "IconButton.c"
}

static gboolean
__lambda20_ (IconButton* self)
{
	gboolean result;
#line 117 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, "");
#line 118 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_set_has_tooltip ((GtkWidget*) self, FALSE);
#line 119 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 119 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 579 "IconButton.c"
}

static gboolean
___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                            GdkEventCrossing* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda20_ ((IconButton*) self);
#line 116 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 591 "IconButton.c"
}

static void
__lambda21_ (IconButton* self,
             GdkDragContext* context)
{
	Icon* _tmp0_;
#line 129 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (context != NULL);
#line 130 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->icon;
#line 130 "../src/panel/applets/icon-tasklist/IconButton.vala"
	switch (gtk_image_get_storage_type ((GtkImage*) _tmp0_)) {
#line 130 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case GTK_IMAGE_PIXBUF:
#line 607 "IconButton.c"
		{
			Icon* _tmp1_;
			GdkPixbuf* _tmp2_;
			Icon* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			Icon* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = self->icon;
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp2_ = gtk_image_get_pixbuf ((GtkImage*) _tmp1_);
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = self->icon;
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = gtk_image_get_pixel_size ((GtkImage*) _tmp3_);
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = _tmp4_;
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp6_ = self->icon;
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp7_ = gtk_image_get_pixel_size ((GtkImage*) _tmp6_);
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp8_ = _tmp7_;
#line 132 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_pixbuf (context, _tmp2_, _tmp5_ / 2, _tmp8_ / 2);
#line 133 "../src/panel/applets/icon-tasklist/IconButton.vala"
			break;
#line 637 "IconButton.c"
		}
#line 130 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case GTK_IMAGE_ICON_NAME:
#line 641 "IconButton.c"
		{
			const gchar* icon_name = NULL;
			Icon* _tmp9_;
			const gchar* _tmp10_ = NULL;
			const gchar* _tmp11_;
			Icon* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			Icon* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
#line 135 "../src/panel/applets/icon-tasklist/IconButton.vala"
			icon_name = NULL;
#line 136 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp9_ = self->icon;
#line 136 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_image_get_icon_name ((GtkImage*) _tmp9_, &_tmp10_, (GtkIconSize*) NULL);
#line 136 "../src/panel/applets/icon-tasklist/IconButton.vala"
			icon_name = _tmp10_;
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp11_ = icon_name;
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp12_ = self->icon;
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp13_ = gtk_image_get_pixel_size ((GtkImage*) _tmp12_);
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp14_ = _tmp13_;
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp15_ = self->icon;
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = gtk_image_get_pixel_size ((GtkImage*) _tmp15_);
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = _tmp16_;
#line 137 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_name (context, _tmp11_, _tmp14_ / 2, _tmp17_ / 2);
#line 138 "../src/panel/applets/icon-tasklist/IconButton.vala"
			break;
#line 679 "IconButton.c"
		}
#line 130 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case GTK_IMAGE_GICON:
#line 683 "IconButton.c"
		{
			GIcon* gicon = NULL;
			Icon* _tmp18_;
			GIcon* _tmp19_ = NULL;
			GIcon* _tmp20_;
			Icon* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			Icon* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
#line 140 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gicon = NULL;
#line 141 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = self->icon;
#line 141 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_image_get_gicon ((GtkImage*) _tmp18_, &_tmp19_, (GtkIconSize*) NULL);
#line 141 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gicon = _tmp19_;
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp20_ = gicon;
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp21_ = self->icon;
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp22_ = gtk_image_get_pixel_size ((GtkImage*) _tmp21_);
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp23_ = _tmp22_;
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp24_ = self->icon;
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp25_ = gtk_image_get_pixel_size ((GtkImage*) _tmp24_);
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp26_ = _tmp25_;
#line 142 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_gicon (context, _tmp20_, _tmp23_ / 2, _tmp26_ / 2);
#line 143 "../src/panel/applets/icon-tasklist/IconButton.vala"
			break;
#line 721 "IconButton.c"
		}
		default:
		{
#line 146 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_default (context);
#line 147 "../src/panel/applets/icon-tasklist/IconButton.vala"
			break;
#line 729 "IconButton.c"
		}
	}
}

static void
___lambda21__gtk_widget_drag_begin (GtkWidget* _sender,
                                    GdkDragContext* context,
                                    gpointer self)
{
#line 129 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda21_ ((IconButton*) self, context);
#line 741 "IconButton.c"
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1570 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1571 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1571 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1571 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1572 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1572 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1572 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1572 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1573 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1573 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1574 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1575 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1575 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1575 "glib-2.0.vapi"
	if (result_length1) {
#line 1575 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 789 "IconButton.c"
	}
#line 1575 "glib-2.0.vapi"
	result = _tmp4_;
#line 1575 "glib-2.0.vapi"
	return result;
#line 795 "IconButton.c"
}

static void
__lambda22_ (IconButton* self,
             GtkWidget* widget,
             GdkDragContext* context,
             GtkSelectionData* selection_data,
             guint info,
             guint time)
{
	const gchar* _tmp0_;
	gint _tmp1_ = 0;
	gchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp3__length1;
#line 151 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (widget != NULL);
#line 151 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (context != NULL);
#line 151 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (selection_data != NULL);
#line 152 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->button_id;
#line 152 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = string_to_utf8 (_tmp0_, &_tmp1_);
#line 152 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = (guchar*) _tmp2_;
#line 152 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3__length1 = (_tmp1_ * sizeof (gchar)) / sizeof (guchar);
#line 152 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_selection_data_set (selection_data, gtk_selection_data_get_target (selection_data), 8, _tmp3_, (gint) ((_tmp1_ * sizeof (gchar)) / sizeof (guchar)));
#line 152 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 829 "IconButton.c"
}

static void
___lambda22__gtk_widget_drag_data_get (GtkWidget* _sender,
                                       GdkDragContext* context,
                                       GtkSelectionData* selection_data,
                                       guint info,
                                       guint time_,
                                       gpointer self)
{
#line 151 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda22_ ((IconButton*) self, _sender, context, selection_data, info, time_);
#line 842 "IconButton.c"
}

static void
_icon_button_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
#line 161 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_on_size_allocate ((IconButton*) self, allocation);
#line 852 "IconButton.c"
}

static void
_icon_button_on_launched_g_app_launch_context_launched (GAppLaunchContext* _sender,
                                                        GAppInfo* info,
                                                        GVariant* platform_data,
                                                        gpointer self)
{
#line 162 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_on_launched ((IconButton*) self, info, platform_data);
#line 863 "IconButton.c"
}

static void
_icon_button_on_launch_failed_g_app_launch_context_launch_failed (GAppLaunchContext* _sender,
                                                                  const gchar* startup_notify_id,
                                                                  gpointer self)
{
#line 163 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_on_launch_failed ((IconButton*) self, startup_notify_id);
#line 873 "IconButton.c"
}

static void
___lambda23_ (IconButton* self)
{
#line 167 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 881 "IconButton.c"
}

static void
____lambda23__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                          const gchar* old_name,
                                                          const gchar* new_name,
                                                          gpointer self)
{
#line 166 "../src/panel/applets/icon-tasklist/IconButton.vala"
	___lambda23_ ((IconButton*) self);
#line 892 "IconButton.c"
}

static void
___lambda24_ (IconButton* self,
              GDesktopAppInfo* app_info)
{
	GDesktopAppInfo* _tmp0_;
#line 171 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (app_info);
#line 171 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->app_info);
#line 171 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->app_info = _tmp0_;
#line 906 "IconButton.c"
}

static void
____lambda24__budgie_abomination_running_app_app_info_changed (BudgieAbominationRunningApp* _sender,
                                                               GDesktopAppInfo* app_info,
                                                               gpointer self)
{
#line 170 "../src/panel/applets/icon-tasklist/IconButton.vala"
	___lambda24_ ((IconButton*) self, app_info);
#line 916 "IconButton.c"
}

static void
___lambda25_ (IconButton* self)
{
#line 175 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 924 "IconButton.c"
}

static void
____lambda25__budgie_abomination_running_app_icon_changed (BudgieAbominationRunningApp* _sender,
                                                           const gchar* icon_name,
                                                           gpointer self)
{
#line 174 "../src/panel/applets/icon-tasklist/IconButton.vala"
	___lambda25_ ((IconButton*) self);
#line 934 "IconButton.c"
}

static void
icon_button_gobject_constructors_suck (IconButton* self)
{
	Icon* _tmp0_;
	Icon* _tmp1_;
	GtkStyleContext* _tmp2_;
	Icon* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkAppLaunchContext* _tmp5_;
	DesktopHelper* _tmp6_;
	GtkStyleContext* st = NULL;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkStyleContext* _tmp11_;
	GdkAppLaunchContext* _tmp12_;
	GdkAppLaunchContext* _tmp13_;
	BudgieAbominationRunningApp* _tmp14_;
#line 105 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = icon_new ();
#line 106 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_object_ref_sink (_tmp0_);
#line 106 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->icon);
#line 106 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->icon = _tmp0_;
#line 107 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->icon;
#line 107 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 107 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_add_class (_tmp2_, "icon");
#line 108 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->icon;
#line 108 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
#line 110 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) ___lambda19__gtk_widget_enter_notify_event, self, 0);
#line 116 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) ___lambda20__gtk_widget_leave_notify_event, self, 0);
#line 122 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->definite_allocation.width = 0;
#line 123 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->definite_allocation.height = 0;
#line 125 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = gtk_widget_get_display ((GtkWidget*) self);
#line 125 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = gdk_display_get_app_launch_context (_tmp4_);
#line 125 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->launch_context);
#line 125 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->launch_context = _tmp5_;
#line 126 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_SCROLL_MASK);
#line 127 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = self->priv->_desktop_helper;
#line 127 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_set_draggable (self, !_tmp6_->lock_icons);
#line 129 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) ___lambda21__gtk_widget_drag_begin, self, 0);
#line 151 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) ___lambda22__gtk_widget_drag_data_get, self, 0);
#line 155 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 155 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 155 "../src/panel/applets/icon-tasklist/IconButton.vala"
	st = _tmp8_;
#line 156 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = st;
#line 156 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_remove_class (_tmp9_, GTK_STYLE_CLASS_BUTTON);
#line 157 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp10_ = st;
#line 157 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_remove_class (_tmp10_, "toggle");
#line 158 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = st;
#line 158 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_add_class (_tmp11_, "launcher");
#line 159 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_button_set_relief ((GtkButton*) self, GTK_RELIEF_NONE);
#line 161 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _icon_button_on_size_allocate_gtk_widget_size_allocate, self, 0);
#line 162 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = self->priv->launch_context;
#line 162 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GAppLaunchContext*) _tmp12_, "launched", (GCallback) _icon_button_on_launched_g_app_launch_context_launched, self, 0);
#line 163 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp13_ = self->priv->launch_context;
#line 163 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GAppLaunchContext*) _tmp13_, "launch-failed", (GCallback) _icon_button_on_launch_failed_g_app_launch_context_launch_failed, self, 0);
#line 165 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp14_ = self->first_app;
#line 165 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp14_ != NULL) {
#line 1036 "IconButton.c"
		BudgieAbominationRunningApp* _tmp15_;
		BudgieAbominationRunningApp* _tmp16_;
		BudgieAbominationRunningApp* _tmp17_;
#line 166 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp15_ = self->first_app;
#line 166 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_signal_connect_object (_tmp15_, "renamed-app", (GCallback) ____lambda23__budgie_abomination_running_app_renamed_app, self, 0);
#line 170 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = self->first_app;
#line 170 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_signal_connect_object (_tmp16_, "app-info-changed", (GCallback) ____lambda24__budgie_abomination_running_app_app_info_changed, self, 0);
#line 174 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp17_ = self->first_app;
#line 174 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_signal_connect_object (_tmp17_, "icon-changed", (GCallback) ____lambda25__budgie_abomination_running_app_icon_changed, self, 0);
#line 1052 "IconButton.c"
	}
#line 105 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (st);
#line 1056 "IconButton.c"
}

/**
 * create_popover will create our popover
 */
static void
__lambda26_ (IconButton* self)
{
#line 189 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_launch_app (self, gtk_get_current_event_time ());
#line 1067 "IconButton.c"
}

static void
___lambda26__budgie_icon_popover_launch_new_instance (BudgieIconPopover* _sender,
                                                      gpointer self)
{
#line 188 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda26_ ((IconButton*) self);
#line 1076 "IconButton.c"
}

static void
__lambda27_ (IconButton* self)
{
	gint _tmp0_;
#line 193 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->window_count;
#line 193 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = _tmp0_ + 1;
#line 1087 "IconButton.c"
}

static void
___lambda27__budgie_icon_popover_added_window (BudgieIconPopover* _sender,
                                               gpointer self)
{
#line 192 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda27_ ((IconButton*) self);
#line 1096 "IconButton.c"
}

static void
__lambda28_ (IconButton* self)
{
	BudgieIconPopover* _tmp0_;
#line 197 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = 0;
#line 198 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 198 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 199 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_emit (self, icon_button_signals[ICON_BUTTON_BECAME_EMPTY_SIGNAL], 0);
#line 1111 "IconButton.c"
}

static void
___lambda28__budgie_icon_popover_closed_all (BudgieIconPopover* _sender,
                                             gpointer self)
{
#line 196 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda28_ ((IconButton*) self);
#line 1120 "IconButton.c"
}

static void
__lambda29_ (IconButton* self)
{
	gint _tmp0_;
#line 203 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->window_count;
#line 203 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = _tmp0_ - 1;
#line 1131 "IconButton.c"
}

static void
___lambda29__budgie_icon_popover_closed_window (BudgieIconPopover* _sender,
                                                gpointer self)
{
#line 202 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda29_ ((IconButton*) self);
#line 1140 "IconButton.c"
}

static void
__lambda30_ (IconButton* self,
             gboolean new_pinned_state)
{
	DesktopHelper* _tmp0_;
#line 207 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->pinned = new_pinned_state;
#line 208 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 208 "../src/panel/applets/icon-tasklist/IconButton.vala"
	desktop_helper_update_pinned (_tmp0_);
#line 209 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_emit (self, icon_button_signals[ICON_BUTTON_PINNED_CHANGED_SIGNAL], 0);
#line 211 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_has_valid_windows (self, NULL)) {
#line 212 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_signal_emit (self, icon_button_signals[ICON_BUTTON_BECAME_EMPTY_SIGNAL], 0);
#line 1160 "IconButton.c"
	}
}

static void
___lambda30__budgie_icon_popover_changed_pin_state (BudgieIconPopover* _sender,
                                                    gboolean new_state,
                                                    gpointer self)
{
#line 206 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda30_ ((IconButton*) self, new_state);
#line 1171 "IconButton.c"
}

static void
__lambda31_ (IconButton* self,
             gulong xid,
             gint wid)
{
	WnckWindow* requested_window = NULL;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWorkspace* workspace = NULL;
	WnckScreen* _tmp2_;
	WnckWorkspace* _tmp3_;
	WnckWorkspace* _tmp4_;
	gboolean _tmp5_ = FALSE;
	WnckWindow* _tmp6_;
#line 217 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = wnck_window_get (xid);
#line 217 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 217 "../src/panel/applets/icon-tasklist/IconButton.vala"
	requested_window = _tmp1_;
#line 218 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->screen;
#line 218 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = wnck_screen_get_workspace (_tmp2_, wid - 1);
#line 218 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 218 "../src/panel/applets/icon-tasklist/IconButton.vala"
	workspace = _tmp4_;
#line 220 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = requested_window;
#line 220 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp6_ != NULL) {
#line 1206 "IconButton.c"
		WnckWorkspace* _tmp7_;
#line 220 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = workspace;
#line 220 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = _tmp7_ != NULL;
#line 1212 "IconButton.c"
	} else {
#line 220 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = FALSE;
#line 1216 "IconButton.c"
	}
#line 220 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp5_) {
#line 1220 "IconButton.c"
		WnckWindow* _tmp8_;
		WnckWorkspace* _tmp9_;
#line 221 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = requested_window;
#line 221 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = workspace;
#line 221 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_move_to_workspace (_tmp8_, _tmp9_);
#line 1229 "IconButton.c"
	}
#line 216 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (workspace);
#line 216 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (requested_window);
#line 1235 "IconButton.c"
}

static void
___lambda31__budgie_icon_popover_move_window_to_workspace (BudgieIconPopover* _sender,
                                                           gulong xid,
                                                           gint workspace_num,
                                                           gpointer self)
{
#line 216 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda31_ ((IconButton*) self, xid, workspace_num);
#line 1246 "IconButton.c"
}

static void
__lambda32_ (IconButton* self,
             const gchar* action)
{
	GDesktopAppInfo* _tmp0_;
#line 225 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (action != NULL);
#line 226 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->app_info;
#line 226 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ != NULL) {
#line 1260 "IconButton.c"
		GdkAppLaunchContext* _tmp1_;
		GdkScreen* _tmp2_;
		GdkAppLaunchContext* _tmp3_;
		GDesktopAppInfo* _tmp4_;
		GdkAppLaunchContext* _tmp5_;
		BudgieIconPopover* _tmp6_;
#line 227 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->launch_context;
#line 227 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 227 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gdk_app_launch_context_set_screen (_tmp1_, _tmp2_);
#line 228 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = self->priv->launch_context;
#line 228 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gdk_app_launch_context_set_timestamp (_tmp3_, (guint32) GDK_CURRENT_TIME);
#line 229 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->app_info;
#line 229 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->launch_context;
#line 229 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_desktop_app_info_launch_action (_tmp4_, action, (GAppLaunchContext*) _tmp5_);
#line 230 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = self->priv->popover;
#line 230 "../src/panel/applets/icon-tasklist/IconButton.vala"
		budgie_icon_popover_render (_tmp6_);
#line 1287 "IconButton.c"
	}
}

static void
___lambda32__budgie_icon_popover_perform_action (BudgieIconPopover* _sender,
                                                 const gchar* action,
                                                 gpointer self)
{
#line 225 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda32_ ((IconButton*) self, action);
#line 1298 "IconButton.c"
}

static void
__lambda33_ (IconButton* self,
             WnckWorkspace* workspace)
{
	BudgieIconPopover* _tmp0_;
	WnckScreen* _tmp1_;
#line 238 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (workspace != NULL);
#line 239 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 239 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->screen;
#line 239 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_set_workspace_count (_tmp0_, wnck_screen_get_workspace_count (_tmp1_));
#line 1315 "IconButton.c"
}

static void
___lambda33__wnck_screen_workspace_created (WnckScreen* _sender,
                                            WnckWorkspace* space,
                                            gpointer self)
{
#line 238 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda33_ ((IconButton*) self, space);
#line 1325 "IconButton.c"
}

static void
__lambda34_ (IconButton* self,
             WnckWorkspace* workspace)
{
	BudgieIconPopover* _tmp0_;
	WnckScreen* _tmp1_;
#line 242 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (workspace != NULL);
#line 243 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 243 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->screen;
#line 243 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_set_workspace_count (_tmp0_, wnck_screen_get_workspace_count (_tmp1_));
#line 1342 "IconButton.c"
}

static void
___lambda34__wnck_screen_workspace_destroyed (WnckScreen* _sender,
                                              WnckWorkspace* space,
                                              gpointer self)
{
#line 242 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda34_ ((IconButton*) self, space);
#line 1352 "IconButton.c"
}

void
icon_button_create_popover (IconButton* self)
{
	WnckScreen* _tmp0_;
	WnckScreen* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	WnckScreen* _tmp3_;
	BudgieIconPopover* _tmp4_;
	BudgieIconPopover* _tmp5_;
	BudgieIconPopover* _tmp6_;
	BudgieIconPopover* _tmp7_;
	BudgieIconPopover* _tmp8_;
	BudgieIconPopover* _tmp9_;
	BudgieIconPopover* _tmp10_;
	BudgieIconPopover* _tmp11_;
	BudgieIconPopover* _tmp12_;
	WnckScreen* _tmp13_;
	WnckScreen* _tmp14_;
	BudgiePopoverManager* _tmp15_;
	BudgieIconPopover* _tmp16_;
#line 183 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = wnck_screen_get_default ();
#line 184 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 184 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->screen);
#line 184 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->screen = _tmp1_;
#line 185 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->app_info;
#line 185 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->screen;
#line 185 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = budgie_icon_popover_new ((GtkWidget*) self, _tmp2_, wnck_screen_get_workspace_count (_tmp3_));
#line 185 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_object_ref_sink (_tmp4_);
#line 185 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->popover);
#line 185 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->popover = _tmp4_;
#line 186 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = self->priv->popover;
#line 186 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_set_pinned_state (_tmp5_, self->pinned);
#line 188 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = self->priv->popover;
#line 188 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp6_, "launch-new-instance", (GCallback) ___lambda26__budgie_icon_popover_launch_new_instance, self, 0);
#line 192 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = self->priv->popover;
#line 192 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp7_, "added-window", (GCallback) ___lambda27__budgie_icon_popover_added_window, self, 0);
#line 196 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = self->priv->popover;
#line 196 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp8_, "closed-all", (GCallback) ___lambda28__budgie_icon_popover_closed_all, self, 0);
#line 202 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = self->priv->popover;
#line 202 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp9_, "closed-window", (GCallback) ___lambda29__budgie_icon_popover_closed_window, self, 0);
#line 206 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp10_ = self->priv->popover;
#line 206 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp10_, "changed-pin-state", (GCallback) ___lambda30__budgie_icon_popover_changed_pin_state, self, 0);
#line 216 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = self->priv->popover;
#line 216 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp11_, "move-window-to-workspace", (GCallback) ___lambda31__budgie_icon_popover_move_window_to_workspace, self, 0);
#line 225 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = self->priv->popover;
#line 225 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp12_, "perform-action", (GCallback) ___lambda32__budgie_icon_popover_perform_action, self, 0);
#line 238 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp13_ = self->priv->screen;
#line 238 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp13_, "workspace-created", (GCallback) ___lambda33__wnck_screen_workspace_created, self, 0);
#line 242 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp14_ = self->priv->screen;
#line 242 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp14_, "workspace-destroyed", (GCallback) ___lambda34__wnck_screen_workspace_destroyed, self, 0);
#line 246 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp15_ = self->priv->_popover_manager;
#line 246 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp16_ = self->priv->popover;
#line 246 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_popover_manager_register_popover (_tmp15_, (GtkWidget*) self, (BudgiePopover*) _tmp16_);
#line 1443 "IconButton.c"
}

static void
__lambda35_ (IconButton* self)
{
#line 257 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 1451 "IconButton.c"
}

static void
___lambda35__budgie_abomination_app_group_icon_changed (BudgieAbominationAppGroup* _sender,
                                                        gpointer self)
{
#line 256 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda35_ ((IconButton*) self);
#line 1460 "IconButton.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return _data2_;
#line 1470 "IconButton.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1480 "IconButton.c"
		IconButton* self;
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self = _data2_->self;
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block2Data, _data2_);
#line 1488 "IconButton.c"
	}
}

static void
__lambda37_ (Block2Data* _data2_)
{
	IconButton* self;
	BudgieIconPopover* _tmp0_;
#line 269 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = _data2_->self;
#line 270 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 270 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_rename_window (_tmp0_, _data2_->xid);
#line 1503 "IconButton.c"
}

static void
___lambda37__wnck_window_name_changed (WnckWindow* _sender,
                                       gpointer self)
{
#line 269 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda37_ (self);
#line 1512 "IconButton.c"
}

static void
__lambda36_ (IconButton* self,
             WnckWindow* new_window)
{
	Block2Data* _data2_;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* name = NULL;
	gchar* _tmp2_;
	BudgieIconPopover* _tmp3_;
	const gchar* _tmp4_;
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (new_window != NULL);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data2_->_ref_count_ = 1;
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data2_->self = g_object_ref (self);
#line 261 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_should_add_window (self, new_window)) {
#line 262 "../src/panel/applets/icon-tasklist/IconButton.vala"
		block2_data_unref (_data2_);
#line 262 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_data2_ = NULL;
#line 262 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return;
#line 1542 "IconButton.c"
	}
#line 265 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data2_->xid = wnck_window_get_xid (new_window);
#line 266 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = wnck_window_get_name (new_window);
#line 266 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _tmp1_;
#line 266 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 266 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = "Loading...";
#line 1554 "IconButton.c"
	}
#line 266 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 266 "../src/panel/applets/icon-tasklist/IconButton.vala"
	name = _tmp2_;
#line 268 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->popover;
#line 268 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = name;
#line 268 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_add_window (_tmp3_, _data2_->xid, _tmp4_);
#line 269 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_data (new_window, "name-changed", (GCallback) ___lambda37__wnck_window_name_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 272 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_update (self);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_free0 (name);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	block2_data_unref (_data2_);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data2_ = NULL;
#line 1576 "IconButton.c"
}

static void
___lambda36__budgie_abomination_app_group_added_window (BudgieAbominationAppGroup* _sender,
                                                        WnckWindow* window,
                                                        gpointer self)
{
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda36_ ((IconButton*) self, window);
#line 1586 "IconButton.c"
}

static void
__lambda38_ (IconButton* self,
             WnckWindow* old_window)
{
	BudgieIconPopover* _tmp0_;
#line 275 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (old_window != NULL);
#line 276 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 276 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_remove_window (_tmp0_, wnck_window_get_xid (old_window));
#line 277 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_update (self);
#line 1602 "IconButton.c"
}

static void
___lambda38__budgie_abomination_app_group_removed_window (BudgieAbominationAppGroup* _sender,
                                                          WnckWindow* window,
                                                          gpointer self)
{
#line 275 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__lambda38_ ((IconButton*) self, window);
#line 1612 "IconButton.c"
}

void
icon_button_set_class_group (IconButton* self,
                             BudgieAbominationAppGroup* class_group)
{
	BudgieAbominationAppGroup* _tmp0_;
	BudgieAbominationAppGroup* _tmp1_;
	BudgieAbominationAppGroup* _tmp2_;
	BudgieAbominationAppGroup* _tmp3_;
#line 249 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (class_group);
#line 250 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->class_group);
#line 250 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->class_group = _tmp0_;
#line 252 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (icon_button_is_empty (self)) {
#line 253 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return;
#line 1635 "IconButton.c"
	}
#line 256 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->class_group;
#line 256 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp1_, "icon-changed", (GCallback) ___lambda35__budgie_abomination_app_group_icon_changed, self, G_CONNECT_AFTER);
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->class_group;
#line 260 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp2_, "added-window", (GCallback) ___lambda36__budgie_abomination_app_group_added_window, self, 0);
#line 275 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->class_group;
#line 275 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp3_, "removed-window", (GCallback) ___lambda38__budgie_abomination_app_group_removed_window, self, 0);
#line 280 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_set_app_for_class_group (self);
#line 281 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_setup_popover_with_class (self);
#line 1653 "IconButton.c"
}

void
icon_button_set_draggable (IconButton* self,
                           gboolean draggable)
{
#line 284 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (draggable) {
#line 286 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, DESKTOP_HELPER_targets, (gint) G_N_ELEMENTS (DESKTOP_HELPER_targets), GDK_ACTION_COPY);
#line 1666 "IconButton.c"
	} else {
#line 288 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_drag_source_unset ((GtkWidget*) self);
#line 1670 "IconButton.c"
	}
}

/**
 * should_add_window will return whether or not we should add this window to our popover
 */
static gboolean
icon_button_should_add_window (IconButton* self,
                               WnckWindow* new_window)
{
	gboolean add = FALSE;
	gboolean should_try_name_match = FALSE;
	gboolean is_matching_class_name = FALSE;
	BudgieAbominationRunningApp* _tmp0_;
	gboolean result;
#line 295 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 295 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (new_window != NULL, FALSE);
#line 296 "../src/panel/applets/icon-tasklist/IconButton.vala"
	add = FALSE;
#line 297 "../src/panel/applets/icon-tasklist/IconButton.vala"
	should_try_name_match = FALSE;
#line 298 "../src/panel/applets/icon-tasklist/IconButton.vala"
	is_matching_class_name = FALSE;
#line 300 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->first_app;
#line 300 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ != NULL) {
#line 1700 "IconButton.c"
		BudgieAbominationRunningApp* app = NULL;
		BudgieAbominationAbomination* _tmp1_;
		BudgieAbominationRunningApp* _tmp2_;
		gboolean _tmp3_ = FALSE;
		BudgieAbominationRunningApp* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_;
#line 301 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_abomination;
#line 301 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = budgie_abomination_abomination_get_app_from_window_id (_tmp1_, wnck_window_get_xid (new_window));
#line 301 "../src/panel/applets/icon-tasklist/IconButton.vala"
		app = _tmp2_;
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->first_app;
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = budgie_abomination_running_app_get_group_name (_tmp4_);
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = _tmp5_;
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = g_str_has_prefix (_tmp6_, "chrome-");
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_free0 (_tmp6_);
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp7_) {
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = TRUE;
#line 1729 "IconButton.c"
		} else {
			BudgieAbominationRunningApp* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp8_ = self->first_app;
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp9_ = budgie_abomination_running_app_get_group_name (_tmp8_);
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp10_ = _tmp9_;
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = g_str_has_prefix (_tmp10_, "google-chrome");
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp10_);
#line 1744 "IconButton.c"
		}
#line 302 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp3_) {
#line 1748 "IconButton.c"
			BudgieAbominationRunningApp* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			BudgieAbominationRunningApp* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 303 "../src/panel/applets/icon-tasklist/IconButton.vala"
			should_try_name_match = TRUE;
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp11_ = self->first_app;
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp12_ = budgie_abomination_running_app_get_group_name (_tmp11_);
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp13_ = _tmp12_;
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp14_ = app;
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp15_ = budgie_abomination_running_app_get_group_name (_tmp14_);
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = _tmp15_;
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			is_matching_class_name = g_strcmp0 (_tmp13_, _tmp16_) == 0;
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp16_);
#line 304 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp13_);
#line 1775 "IconButton.c"
		} else {
			BudgieAbominationRunningApp* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gboolean _tmp20_;
#line 305 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = self->first_app;
#line 305 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = budgie_abomination_running_app_get_group_name (_tmp17_);
#line 305 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp19_ = _tmp18_;
#line 305 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp20_ = g_str_has_prefix (_tmp19_, "libreoffice");
#line 305 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp19_);
#line 305 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (_tmp20_) {
#line 1793 "IconButton.c"
				BudgieAbominationRunningApp* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				BudgieAbominationRunningApp* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
#line 306 "../src/panel/applets/icon-tasklist/IconButton.vala"
				should_try_name_match = TRUE;
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp21_ = self->first_app;
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp22_ = budgie_abomination_running_app_get_group_name (_tmp21_);
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp23_ = _tmp22_;
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp24_ = app;
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp25_ = budgie_abomination_running_app_get_group_name (_tmp24_);
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp26_ = _tmp25_;
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				is_matching_class_name = g_strcmp0 (_tmp23_, _tmp26_) == 0;
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_free0 (_tmp26_);
#line 307 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_free0 (_tmp23_);
#line 1820 "IconButton.c"
			}
		}
#line 300 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (app);
#line 1825 "IconButton.c"
	}
#line 311 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (should_try_name_match) {
#line 312 "../src/panel/applets/icon-tasklist/IconButton.vala"
		add = is_matching_class_name;
#line 1831 "IconButton.c"
	} else {
		WnckWindow* old_window = NULL;
		BudgieAbominationAppGroup* _tmp27_;
		GList* _tmp28_;
		GList* _tmp29_;
		gconstpointer _tmp30_;
		WnckWindow* _tmp31_;
		WnckWindow* _tmp32_;
		const gchar* _tmp33_;
		WnckWindow* _tmp34_;
		const gchar* _tmp35_;
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp27_ = self->priv->class_group;
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp28_ = budgie_abomination_app_group_get_windows (_tmp27_);
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp29_ = _tmp28_;
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp30_ = g_list_nth_data (_tmp29_, (guint) 0);
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp31_ = _g_object_ref0 ((WnckWindow*) _tmp30_);
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp32_ = _tmp31_;
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(_tmp29_ == NULL) ? NULL : (_tmp29_ = (g_list_free (_tmp29_), NULL));
#line 314 "../src/panel/applets/icon-tasklist/IconButton.vala"
		old_window = _tmp32_;
#line 315 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp33_ = wnck_window_get_class_instance_name (new_window);
#line 315 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp34_ = old_window;
#line 315 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp35_ = wnck_window_get_class_instance_name (_tmp34_);
#line 315 "../src/panel/applets/icon-tasklist/IconButton.vala"
		add = g_strcmp0 (_tmp33_, _tmp35_) == 0;
#line 311 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (old_window);
#line 1869 "IconButton.c"
	}
#line 318 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = add;
#line 318 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 1875 "IconButton.c"
}

void
icon_button_update_icon (IconButton* self)
{
	GIcon* app_icon = NULL;
	GDesktopAppInfo* _tmp1_;
	GdkPixbuf* pixbuf_icon = NULL;
	GIcon* _tmp6_;
#line 321 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (icon_button_has_valid_windows (self, NULL)) {
#line 1889 "IconButton.c"
		Icon* _tmp0_;
#line 323 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = self->icon;
#line 323 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_->waiting = FALSE;
#line 1895 "IconButton.c"
	}
#line 326 "../src/panel/applets/icon-tasklist/IconButton.vala"
	app_icon = NULL;
#line 327 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->app_info;
#line 327 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 1903 "IconButton.c"
		GDesktopAppInfo* _tmp2_;
		GIcon* _tmp3_;
#line 328 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = self->priv->app_info;
#line 328 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = g_app_info_get_icon ((GAppInfo*) _tmp2_);
#line 328 "../src/panel/applets/icon-tasklist/IconButton.vala"
		app_icon = _tmp3_;
#line 1912 "IconButton.c"
	}
#line 331 "../src/panel/applets/icon-tasklist/IconButton.vala"
	pixbuf_icon = NULL;
#line 332 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 1918 "IconButton.c"
		BudgieAbominationAppGroup* _tmp4_;
		GdkPixbuf* _tmp5_;
#line 333 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->class_group;
#line 333 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = budgie_abomination_app_group_get_icon (_tmp4_);
#line 333 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (pixbuf_icon);
#line 333 "../src/panel/applets/icon-tasklist/IconButton.vala"
		pixbuf_icon = _tmp5_;
#line 1929 "IconButton.c"
	}
#line 336 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = app_icon;
#line 336 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp6_ != NULL) {
#line 1935 "IconButton.c"
		Icon* _tmp7_;
		GIcon* _tmp8_;
#line 337 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = self->icon;
#line 337 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = app_icon;
#line 337 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_image_set_from_gicon ((GtkImage*) _tmp7_, _tmp8_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 1944 "IconButton.c"
	} else {
		GdkPixbuf* _tmp9_;
#line 338 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = pixbuf_icon;
#line 338 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp9_ != NULL) {
#line 1951 "IconButton.c"
			gboolean _tmp10_ = FALSE;
			Icon* _tmp20_;
			GdkPixbuf* _tmp21_;
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (self->priv->target_icon_size > 0) {
#line 1957 "IconButton.c"
				gboolean _tmp11_ = FALSE;
				GdkPixbuf* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp12_ = pixbuf_icon;
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp14_ = _tmp13_;
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (_tmp14_ != self->priv->target_icon_size) {
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp11_ = TRUE;
#line 1972 "IconButton.c"
				} else {
					GdkPixbuf* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp15_ = pixbuf_icon;
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp16_ = gdk_pixbuf_get_height (_tmp15_);
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp17_ = _tmp16_;
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp11_ = _tmp17_ != self->priv->target_icon_size;
#line 1985 "IconButton.c"
				}
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp10_ = _tmp11_;
#line 1989 "IconButton.c"
			} else {
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp10_ = FALSE;
#line 1993 "IconButton.c"
			}
#line 340 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (_tmp10_) {
#line 1997 "IconButton.c"
				GdkPixbuf* _tmp18_;
				GdkPixbuf* _tmp19_;
#line 341 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp18_ = pixbuf_icon;
#line 341 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp19_ = gdk_pixbuf_scale_simple (_tmp18_, self->priv->target_icon_size, self->priv->target_icon_size, GDK_INTERP_BILINEAR);
#line 341 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (pixbuf_icon);
#line 341 "../src/panel/applets/icon-tasklist/IconButton.vala"
				pixbuf_icon = _tmp19_;
#line 2008 "IconButton.c"
			}
#line 343 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp20_ = self->icon;
#line 343 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp21_ = pixbuf_icon;
#line 343 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_image_set_from_pixbuf ((GtkImage*) _tmp20_, _tmp21_);
#line 2016 "IconButton.c"
		} else {
			Icon* _tmp22_;
#line 345 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp22_ = self->icon;
#line 345 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_image_set_from_icon_name ((GtkImage*) _tmp22_, "image-missing", (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 2023 "IconButton.c"
		}
	}
#line 348 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (self->priv->target_icon_size > 0) {
#line 2028 "IconButton.c"
		Icon* _tmp23_;
#line 349 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp23_ = self->icon;
#line 349 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_image_set_pixel_size ((GtkImage*) _tmp23_, self->priv->target_icon_size);
#line 2034 "IconButton.c"
	} else {
		Icon* _tmp24_;
		DesktopHelper* _tmp25_;
#line 352 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp24_ = self->icon;
#line 352 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp25_ = self->priv->_desktop_helper;
#line 352 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_image_set_pixel_size ((GtkImage*) _tmp24_, _tmp25_->icon_size);
#line 2044 "IconButton.c"
	}
#line 321 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (pixbuf_icon);
#line 2048 "IconButton.c"
}

void
icon_button_update (IconButton* self)
{
	gboolean has_active = FALSE;
	DesktopHelper* _tmp9_;
#line 356 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_has_valid_windows (self, NULL)) {
#line 2060 "IconButton.c"
		GtkStyleContext* _tmp0_;
#line 358 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 358 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_remove_class (_tmp0_, "running");
#line 359 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (!self->pinned) {
#line 360 "../src/panel/applets/icon-tasklist/IconButton.vala"
			return;
#line 2070 "IconButton.c"
		} else {
#line 362 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_object_unref0 (self->priv->class_group);
#line 362 "../src/panel/applets/icon-tasklist/IconButton.vala"
			self->priv->class_group = NULL;
#line 2076 "IconButton.c"
		}
	} else {
		GtkStyleContext* _tmp1_;
#line 365 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 365 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_add_class (_tmp1_, "running");
#line 2084 "IconButton.c"
	}
#line 368 "../src/panel/applets/icon-tasklist/IconButton.vala"
	has_active = FALSE;
#line 369 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 2090 "IconButton.c"
		BudgieAbominationAppGroup* _tmp2_;
		GList* _tmp3_;
		GList* _tmp4_;
		DesktopHelper* _tmp5_;
		WnckWindow* _tmp6_;
		WnckWindow* _tmp7_;
		GList* _tmp8_;
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = self->priv->class_group;
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = budgie_abomination_app_group_get_windows (_tmp2_);
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = _tmp3_;
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->_desktop_helper;
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = desktop_helper_get_active_window (_tmp5_);
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = _tmp6_;
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = g_list_find (_tmp4_, _tmp7_);
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		has_active = _tmp8_ != NULL;
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (_tmp7_);
#line 370 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 2118 "IconButton.c"
	}
#line 372 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) self, has_active);
#line 374 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 376 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = self->priv->_desktop_helper;
#line 376 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_set_draggable (self, !_tmp9_->lock_icons);
#line 378 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 379 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 2132 "IconButton.c"
}

static gboolean
icon_button_has_valid_windows (IconButton* self,
                               gint* num_windows)
{
	gint _vala_num_windows = 0;
	gboolean result;
#line 382 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 383 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_vala_num_windows = self->priv->window_count;
#line 384 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = self->priv->window_count != 0;
#line 384 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (num_windows) {
#line 384 "../src/panel/applets/icon-tasklist/IconButton.vala"
		*num_windows = _vala_num_windows;
#line 2151 "IconButton.c"
	}
#line 384 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2155 "IconButton.c"
}

gboolean
icon_button_has_window (IconButton* self,
                        WnckWindow* window)
{
	BudgieAbominationAppGroup* _tmp0_;
	GList* _tmp1_;
	gboolean result;
#line 387 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 388 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (window == NULL) {
#line 389 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = FALSE;
#line 389 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 2173 "IconButton.c"
	}
#line 392 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (icon_button_is_empty (self)) {
#line 393 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = FALSE;
#line 393 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 2181 "IconButton.c"
	}
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->class_group;
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = budgie_abomination_app_group_get_windows (_tmp0_);
#line 2187 "IconButton.c"
	{
		GList* win_collection = NULL;
		GList* win_it = NULL;
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
		win_collection = _tmp1_;
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 2195 "IconButton.c"
			WnckWindow* _tmp2_;
			WnckWindow* win = NULL;
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp2_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
			win = _tmp2_;
#line 2202 "IconButton.c"
			{
				WnckWindow* _tmp3_;
#line 397 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp3_ = win;
#line 397 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (_tmp3_ == window) {
#line 398 "../src/panel/applets/icon-tasklist/IconButton.vala"
					result = TRUE;
#line 398 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 398 "../src/panel/applets/icon-tasklist/IconButton.vala"
					(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 398 "../src/panel/applets/icon-tasklist/IconButton.vala"
					return result;
#line 2217 "IconButton.c"
				}
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (win);
#line 2221 "IconButton.c"
			}
		}
#line 396 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 2226 "IconButton.c"
	}
#line 402 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 402 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2232 "IconButton.c"
}

gboolean
icon_button_has_window_on_workspace (IconButton* self,
                                     WnckWorkspace* workspace)
{
	gboolean result;
#line 405 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 405 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (workspace != NULL, FALSE);
#line 406 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (workspace == NULL) {
#line 407 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = FALSE;
#line 407 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 2250 "IconButton.c"
	}
#line 410 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 2254 "IconButton.c"
		BudgieAbominationAppGroup* _tmp0_;
		GList* _tmp1_;
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = self->priv->class_group;
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = budgie_abomination_app_group_get_windows (_tmp0_);
#line 2261 "IconButton.c"
		{
			GList* win_collection = NULL;
			GList* win_it = NULL;
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
			win_collection = _tmp1_;
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 2269 "IconButton.c"
				WnckWindow* _tmp2_;
				WnckWindow* win = NULL;
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp2_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
				win = _tmp2_;
#line 2276 "IconButton.c"
				{
					gboolean _tmp3_ = FALSE;
					gboolean _tmp4_ = FALSE;
					WnckWindow* _tmp5_;
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp5_ = win;
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (!wnck_window_is_skip_pager (_tmp5_)) {
#line 2285 "IconButton.c"
						WnckWindow* _tmp6_;
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp6_ = win;
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp4_ = !wnck_window_is_skip_tasklist (_tmp6_);
#line 2291 "IconButton.c"
					} else {
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp4_ = FALSE;
#line 2295 "IconButton.c"
					}
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (_tmp4_) {
#line 2299 "IconButton.c"
						WnckWindow* _tmp7_;
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp7_ = win;
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp3_ = wnck_window_is_on_workspace (_tmp7_, workspace);
#line 2305 "IconButton.c"
					} else {
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp3_ = FALSE;
#line 2309 "IconButton.c"
					}
#line 412 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (_tmp3_) {
#line 413 "../src/panel/applets/icon-tasklist/IconButton.vala"
						result = TRUE;
#line 413 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_g_object_unref0 (win);
#line 413 "../src/panel/applets/icon-tasklist/IconButton.vala"
						(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 413 "../src/panel/applets/icon-tasklist/IconButton.vala"
						return result;
#line 2321 "IconButton.c"
					}
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 2325 "IconButton.c"
				}
			}
#line 411 "../src/panel/applets/icon-tasklist/IconButton.vala"
			(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 2330 "IconButton.c"
		}
	}
#line 418 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 418 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2337 "IconButton.c"
}

static void
icon_button_launch_app (IconButton* self,
                        guint32 time)
{
	GDesktopAppInfo* _tmp0_;
	GdkAppLaunchContext* _tmp1_;
	GdkScreen* _tmp2_;
	GdkAppLaunchContext* _tmp3_;
	Icon* _tmp4_;
	DesktopHelper* _tmp5_;
	Icon* _tmp6_;
	Icon* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 421 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->app_info;
#line 422 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 423 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return;
#line 2361 "IconButton.c"
	}
#line 426 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->launch_context;
#line 426 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 426 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gdk_app_launch_context_set_screen (_tmp1_, _tmp2_);
#line 427 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->launch_context;
#line 427 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gdk_app_launch_context_set_timestamp (_tmp3_, time);
#line 429 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = self->icon;
#line 429 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = self->priv->_desktop_helper;
#line 429 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_animate_launch (_tmp4_, _tmp5_->panel_position);
#line 430 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = self->icon;
#line 430 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp6_->waiting = TRUE;
#line 431 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = self->icon;
#line 431 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_animate_wait (_tmp7_);
#line 2387 "IconButton.c"
	{
		GDesktopAppInfo* _tmp8_;
		GdkAppLaunchContext* _tmp9_;
#line 434 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = self->priv->app_info;
#line 434 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = self->priv->launch_context;
#line 434 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_app_info_launch ((GAppInfo*) _tmp8_, NULL, (GAppLaunchContext*) _tmp9_, &_inner_error0_);
#line 434 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2399 "IconButton.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 433 "../src/panel/applets/icon-tasklist/IconButton.vala"
		e = _inner_error0_;
#line 433 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_inner_error0_ = NULL;
#line 436 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = e;
#line 436 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = _tmp10_->message;
#line 436 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_warning ("IconButton.vala:436: %s", _tmp11_);
#line 433 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_error_free0 (e);
#line 2421 "IconButton.c"
	}
	__finally0:
#line 433 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 433 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 433 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_clear_error (&_inner_error0_);
#line 433 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return;
#line 2432 "IconButton.c"
	}
}

gboolean
icon_button_is_empty (IconButton* self)
{
	BudgieAbominationAppGroup* _tmp0_;
	gboolean result;
#line 440 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 441 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->class_group;
#line 441 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_ == NULL;
#line 441 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2449 "IconButton.c"
}

gboolean
icon_button_is_pinned (IconButton* self)
{
	gboolean result;
#line 444 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 445 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = self->pinned;
#line 445 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2462 "IconButton.c"
}

void
icon_button_attention (IconButton* self,
                       gboolean needs_it)
{
#line 448 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->needs_attention = needs_it;
#line 450 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 451 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (needs_it) {
#line 2477 "IconButton.c"
		Icon* _tmp0_;
		DesktopHelper* _tmp1_;
#line 452 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = self->icon;
#line 452 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_desktop_helper;
#line 452 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_animate_attention (_tmp0_, &_tmp1_->panel_position);
#line 2486 "IconButton.c"
	}
}

/**
 * set_tooltip will set the tooltip text for this IconButton
 */
void
icon_button_set_tooltip (IconButton* self)
{
#line 459 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (self->priv->window_count != 0) {
#line 2500 "IconButton.c"
		gboolean _tmp0_ = FALSE;
#line 461 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (self->priv->window_count == 1) {
#line 2504 "IconButton.c"
			BudgieAbominationRunningApp* _tmp1_;
#line 461 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = self->first_app;
#line 461 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp0_ = _tmp1_ != NULL;
#line 2510 "IconButton.c"
		} else {
#line 461 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp0_ = FALSE;
#line 2514 "IconButton.c"
		}
#line 461 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp0_) {
#line 2518 "IconButton.c"
			gboolean is_budgie_screenshot = FALSE;
			BudgieAbominationRunningApp* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_ = NULL;
#line 462 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp2_ = self->first_app;
#line 462 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = budgie_abomination_running_app_get_name (_tmp2_);
#line 462 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = _tmp3_;
#line 462 "../src/panel/applets/icon-tasklist/IconButton.vala"
			is_budgie_screenshot = g_strcmp0 (_tmp4_, "budgie-daemon") == 0;
#line 463 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (is_budgie_screenshot) {
#line 463 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp5_ = _ ("Budgie Screenshot");
#line 2536 "IconButton.c"
			} else {
				BudgieAbominationRunningApp* _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
#line 463 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp6_ = self->first_app;
#line 463 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp7_ = budgie_abomination_running_app_get_name (_tmp6_);
#line 463 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp8_ = _tmp7_;
#line 463 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp5_ = _tmp8_;
#line 2549 "IconButton.c"
			}
#line 463 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp5_);
#line 2553 "IconButton.c"
		} else {
			GDesktopAppInfo* _tmp9_;
#line 464 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp9_ = self->priv->app_info;
#line 464 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (_tmp9_ != NULL) {
#line 2560 "IconButton.c"
				GDesktopAppInfo* _tmp10_;
				const gchar* _tmp11_;
#line 465 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp10_ = self->priv->app_info;
#line 465 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp11_ = g_app_info_get_display_name ((GAppInfo*) _tmp10_);
#line 465 "../src/panel/applets/icon-tasklist/IconButton.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp11_);
#line 2569 "IconButton.c"
			}
		}
	} else {
		GDesktopAppInfo* _tmp12_;
#line 468 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = self->priv->app_info;
#line 468 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp12_ != NULL) {
#line 2578 "IconButton.c"
			GDesktopAppInfo* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 469 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp13_ = self->priv->app_info;
#line 469 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp14_ = g_app_info_get_display_name ((GAppInfo*) _tmp13_);
#line 469 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp15_ = g_strdup_printf ("Launch %s", _tmp14_);
#line 469 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = _tmp15_;
#line 469 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp16_);
#line 469 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp16_);
#line 2595 "IconButton.c"
		} else {
#line 470 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (!icon_button_is_empty (self)) {
#line 2599 "IconButton.c"
				BudgieAbominationAppGroup* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 471 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp17_ = self->priv->class_group;
#line 471 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp18_ = budgie_abomination_app_group_get_name (_tmp17_);
#line 471 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp19_ = _tmp18_;
#line 471 "../src/panel/applets/icon-tasklist/IconButton.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp19_);
#line 471 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_free0 (_tmp19_);
#line 2613 "IconButton.c"
			}
		}
	}
}

/**
 * Handle startup notification, set our own ID to the ID selected
 */
static void
icon_button_on_launched (IconButton* self,
                         GAppInfo* info,
                         GVariant* v)
{
	GVariant* elem = NULL;
	GVariantIter* iter = NULL;
	GVariantIter* _tmp0_;
#line 479 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 479 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (info != NULL);
#line 479 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (v != NULL);
#line 482 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = g_variant_iter_new (v);
#line 482 "../src/panel/applets/icon-tasklist/IconButton.vala"
	iter = _tmp0_;
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
	while (TRUE) {
#line 2642 "IconButton.c"
		GVariantIter* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		gchar* key = NULL;
		GVariant* val = NULL;
		GVariant* _tmp4_;
		gchar* _tmp5_ = NULL;
		GVariant* _tmp6_ = NULL;
		const gchar* _tmp7_;
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
		const gchar* _tmp10_;
		GdkDisplay* _tmp11_;
		GVariant* _tmp12_;
		const gchar* _tmp13_;
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = iter;
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = g_variant_iter_next_value (_tmp1_);
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_variant_unref0 (elem);
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		elem = _tmp2_;
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = elem;
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (!(_tmp3_ != NULL)) {
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
			break;
#line 2672 "IconButton.c"
		}
#line 485 "../src/panel/applets/icon-tasklist/IconButton.vala"
		key = NULL;
#line 486 "../src/panel/applets/icon-tasklist/IconButton.vala"
		val = NULL;
#line 488 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = elem;
#line 488 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_variant_get (_tmp4_, "{sv}", &_tmp5_, &_tmp6_, NULL);
#line 488 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_free0 (key);
#line 488 "../src/panel/applets/icon-tasklist/IconButton.vala"
		key = _tmp5_;
#line 488 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_variant_unref0 (val);
#line 488 "../src/panel/applets/icon-tasklist/IconButton.vala"
		val = _tmp6_;
#line 490 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = key;
#line 490 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp7_ == NULL) {
#line 491 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_variant_unref0 (val);
#line 491 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (key);
#line 491 "../src/panel/applets/icon-tasklist/IconButton.vala"
			continue;
#line 2700 "IconButton.c"
		}
#line 494 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = val;
#line 494 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = G_VARIANT_TYPE_STRING;
#line 494 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (!g_variant_is_of_type (_tmp8_, _tmp9_)) {
#line 495 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_variant_unref0 (val);
#line 495 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (key);
#line 495 "../src/panel/applets/icon-tasklist/IconButton.vala"
			continue;
#line 2714 "IconButton.c"
		}
#line 498 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = key;
#line 498 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (g_strcmp0 (_tmp10_, "startup-notification-id") != 0) {
#line 499 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_variant_unref0 (val);
#line 499 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_free0 (key);
#line 499 "../src/panel/applets/icon-tasklist/IconButton.vala"
			continue;
#line 2726 "IconButton.c"
		}
#line 502 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = gtk_widget_get_display ((GtkWidget*) self);
#line 502 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = val;
#line 502 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = g_variant_get_string (_tmp12_, NULL);
#line 502 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gdk_display_notify_startup_complete (_tmp11_, _tmp13_);
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_variant_unref0 (val);
#line 484 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_free0 (key);
#line 2740 "IconButton.c"
	}
#line 479 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_variant_iter_free0 (iter);
#line 479 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_variant_unref0 (elem);
#line 2746 "IconButton.c"
}

static void
icon_button_on_launch_failed (IconButton* self,
                              const gchar* id)
{
	GdkDisplay* _tmp0_;
#line 506 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (id != NULL);
#line 507 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_warning ("IconButton.vala:507: launch_failed");
#line 508 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 508 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gdk_display_notify_startup_complete (_tmp0_, id);
#line 2764 "IconButton.c"
}

void
icon_button_draw_inactive (IconButton* self,
                           cairo_t* cr,
                           GdkRGBA* col)
{
	gint x = 0;
	GtkAllocation _tmp0_;
	gint y = 0;
	GtkAllocation _tmp1_;
	gint width = 0;
	GtkAllocation _tmp2_;
	gint height = 0;
	GtkAllocation _tmp3_;
	GList* windows = NULL;
	gint count = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_;
	gint _tmp8_ = 0;
	gint counter = 0;
	GList* _tmp9_;
#line 511 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 511 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (cr != NULL);
#line 511 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (col != NULL);
#line 512 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 512 "../src/panel/applets/icon-tasklist/IconButton.vala"
	x = _tmp0_.x;
#line 513 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->definite_allocation;
#line 513 "../src/panel/applets/icon-tasklist/IconButton.vala"
	y = _tmp1_.y;
#line 514 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->definite_allocation;
#line 514 "../src/panel/applets/icon-tasklist/IconButton.vala"
	width = _tmp2_.width;
#line 515 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->definite_allocation;
#line 515 "../src/panel/applets/icon-tasklist/IconButton.vala"
	height = _tmp3_.height;
#line 518 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 2811 "IconButton.c"
		BudgieAbominationAppGroup* _tmp4_;
		GList* _tmp5_;
#line 519 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->class_group;
#line 519 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = budgie_abomination_app_group_get_windows (_tmp4_);
#line 519 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 519 "../src/panel/applets/icon-tasklist/IconButton.vala"
		windows = _tmp5_;
#line 2822 "IconButton.c"
	} else {
#line 521 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 521 "../src/panel/applets/icon-tasklist/IconButton.vala"
		windows = NULL;
#line 2828 "IconButton.c"
	}
#line 525 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = icon_button_has_valid_windows (self, &_tmp6_);
#line 525 "../src/panel/applets/icon-tasklist/IconButton.vala"
	count = _tmp6_;
#line 525 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!_tmp7_) {
#line 526 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 526 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return;
#line 2840 "IconButton.c"
	}
#line 529 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (count > 5) {
#line 529 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = 5;
#line 2846 "IconButton.c"
	} else {
#line 529 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = count;
#line 2850 "IconButton.c"
	}
#line 529 "../src/panel/applets/icon-tasklist/IconButton.vala"
	count = _tmp8_;
#line 531 "../src/panel/applets/icon-tasklist/IconButton.vala"
	counter = 0;
#line 532 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = windows;
#line 2858 "IconButton.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 532 "../src/panel/applets/icon-tasklist/IconButton.vala"
		window_collection = _tmp9_;
#line 532 "../src/panel/applets/icon-tasklist/IconButton.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2866 "IconButton.c"
			WnckWindow* _tmp10_;
			WnckWindow* window = NULL;
#line 532 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp10_ = _g_object_ref0 ((WnckWindow*) window_it->data);
#line 532 "../src/panel/applets/icon-tasklist/IconButton.vala"
			window = _tmp10_;
#line 2873 "IconButton.c"
			{
				gboolean _tmp11_ = FALSE;
				WnckWindow* _tmp12_;
#line 533 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (counter == count) {
#line 534 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (window);
#line 534 "../src/panel/applets/icon-tasklist/IconButton.vala"
					break;
#line 2883 "IconButton.c"
				}
#line 537 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp12_ = window;
#line 537 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (!wnck_window_is_skip_pager (_tmp12_)) {
#line 2889 "IconButton.c"
					WnckWindow* _tmp13_;
#line 537 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp13_ = window;
#line 537 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp11_ = !wnck_window_is_skip_tasklist (_tmp13_);
#line 2895 "IconButton.c"
				} else {
#line 537 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp11_ = FALSE;
#line 2899 "IconButton.c"
				}
#line 537 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (_tmp11_) {
#line 2903 "IconButton.c"
					gint indicator_x = 0;
					gint indicator_y = 0;
					DesktopHelper* _tmp14_;
					GdkRGBA _tmp15_;
					GdkRGBA _tmp16_;
					GdkRGBA _tmp17_;
					gint _tmp18_;
#line 538 "../src/panel/applets/icon-tasklist/IconButton.vala"
					indicator_x = 0;
#line 539 "../src/panel/applets/icon-tasklist/IconButton.vala"
					indicator_y = 0;
#line 540 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp14_ = self->priv->_desktop_helper;
#line 540 "../src/panel/applets/icon-tasklist/IconButton.vala"
					switch (_tmp14_->panel_position) {
#line 540 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_TOP:
#line 2921 "IconButton.c"
						{
#line 542 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x = x + (width / 2);
#line 543 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - INACTIVE_INDICATOR_SPACING;
#line 544 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 545 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y = y + (INDICATOR_SIZE / 2);
#line 546 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 2933 "IconButton.c"
						}
#line 540 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_BOTTOM:
#line 2937 "IconButton.c"
						{
#line 548 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x = x + (width / 2);
#line 549 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - INACTIVE_INDICATOR_SPACING;
#line 550 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 551 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y = (y + height) - (INDICATOR_SIZE / 2);
#line 552 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 2949 "IconButton.c"
						}
#line 540 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_LEFT:
#line 2953 "IconButton.c"
						{
#line 554 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y = x + (height / 2);
#line 555 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - (INACTIVE_INDICATOR_SPACING * 2);
#line 556 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 557 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x = y + (INDICATOR_SIZE / 2);
#line 558 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 2965 "IconButton.c"
						}
#line 540 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_RIGHT:
#line 2969 "IconButton.c"
						{
#line 560 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y = x + (height / 2);
#line 561 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - INACTIVE_INDICATOR_SPACING;
#line 562 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 563 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x = (y + width) - (INDICATOR_SIZE / 2);
#line 564 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 2981 "IconButton.c"
						}
						default:
						{
#line 566 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 2987 "IconButton.c"
						}
					}
#line 569 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp15_ = *col;
#line 569 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp16_ = *col;
#line 569 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp17_ = *col;
#line 569 "../src/panel/applets/icon-tasklist/IconButton.vala"
					cairo_set_source_rgba (cr, _tmp15_.red, _tmp16_.green, _tmp17_.blue, (gdouble) 1);
#line 570 "../src/panel/applets/icon-tasklist/IconButton.vala"
					cairo_arc (cr, (gdouble) indicator_x, (gdouble) indicator_y, (gdouble) INDICATOR_SIZE, (gdouble) 0, G_PI * 2);
#line 571 "../src/panel/applets/icon-tasklist/IconButton.vala"
					cairo_fill (cr);
#line 572 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp18_ = counter;
#line 572 "../src/panel/applets/icon-tasklist/IconButton.vala"
					counter = _tmp18_ + 1;
#line 3006 "IconButton.c"
				}
#line 532 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (window);
#line 3010 "IconButton.c"
			}
		}
	}
#line 511 "../src/panel/applets/icon-tasklist/IconButton.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 3016 "IconButton.c"
}

static gboolean
icon_button_real_draw (GtkWidget* base,
                       cairo_t* cr)
{
	IconButton * self;
	gint x = 0;
	GtkAllocation _tmp0_;
	gint y = 0;
	GtkAllocation _tmp1_;
	gint width = 0;
	GtkAllocation _tmp2_;
	gint height = 0;
	GtkAllocation _tmp3_;
	GList* windows = NULL;
	gint count = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_;
	gint _tmp8_ = 0;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	GdkRGBA col = {0};
	GtkStyleContext* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	gboolean _tmp13_;
	gint counter = 0;
	gint previous_x = 0;
	gint previous_y = 0;
	gint spacing = 0;
	gint _tmp21_ = 0;
	GList* _tmp22_;
	gboolean result;
#line 577 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 577 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 578 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 578 "../src/panel/applets/icon-tasklist/IconButton.vala"
	x = _tmp0_.x;
#line 579 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->definite_allocation;
#line 579 "../src/panel/applets/icon-tasklist/IconButton.vala"
	y = _tmp1_.y;
#line 580 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->definite_allocation;
#line 580 "../src/panel/applets/icon-tasklist/IconButton.vala"
	width = _tmp2_.width;
#line 581 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->definite_allocation;
#line 581 "../src/panel/applets/icon-tasklist/IconButton.vala"
	height = _tmp3_.height;
#line 584 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 3073 "IconButton.c"
		BudgieAbominationAppGroup* _tmp4_;
		GList* _tmp5_;
#line 585 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->class_group;
#line 585 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = budgie_abomination_app_group_get_windows (_tmp4_);
#line 585 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 585 "../src/panel/applets/icon-tasklist/IconButton.vala"
		windows = _tmp5_;
#line 3084 "IconButton.c"
	} else {
#line 587 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 587 "../src/panel/applets/icon-tasklist/IconButton.vala"
		windows = NULL;
#line 3090 "IconButton.c"
	}
#line 591 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = icon_button_has_valid_windows (self, &_tmp6_);
#line 591 "../src/panel/applets/icon-tasklist/IconButton.vala"
	count = _tmp6_;
#line 591 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!_tmp7_) {
#line 592 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), cr);
#line 592 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 592 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 3104 "IconButton.c"
	}
#line 595 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (count > 5) {
#line 595 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = 5;
#line 3110 "IconButton.c"
	} else {
#line 595 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = count;
#line 3114 "IconButton.c"
	}
#line 595 "../src/panel/applets/icon-tasklist/IconButton.vala"
	count = _tmp8_;
#line 597 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 597 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 597 "../src/panel/applets/icon-tasklist/IconButton.vala"
	context = _tmp10_;
#line 600 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = context;
#line 600 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp13_ = gtk_style_context_lookup_color (_tmp11_, "budgie_tasklist_indicator_color", &_tmp12_);
#line 600 "../src/panel/applets/icon-tasklist/IconButton.vala"
	col = _tmp12_;
#line 600 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!_tmp13_) {
#line 601 "../src/panel/applets/icon-tasklist/IconButton.vala"
		gdk_rgba_parse (&col, "#3C6DA6");
#line 3134 "IconButton.c"
	}
#line 604 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) self)) {
#line 3138 "IconButton.c"
		GtkStyleContext* _tmp14_;
		GdkRGBA _tmp15_ = {0};
		gboolean _tmp16_;
#line 605 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp14_ = context;
#line 605 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = gtk_style_context_lookup_color (_tmp14_, "budgie_tasklist_indicator_color_active", &_tmp15_);
#line 605 "../src/panel/applets/icon-tasklist/IconButton.vala"
		col = _tmp15_;
#line 605 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (!_tmp16_) {
#line 606 "../src/panel/applets/icon-tasklist/IconButton.vala"
			gdk_rgba_parse (&col, "#5294E2");
#line 3152 "IconButton.c"
		}
	} else {
		GdkRGBA _tmp20_;
#line 609 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (self->priv->needs_attention) {
#line 3158 "IconButton.c"
			GtkStyleContext* _tmp17_;
			GdkRGBA _tmp18_ = {0};
			gboolean _tmp19_;
#line 610 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = context;
#line 610 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp19_ = gtk_style_context_lookup_color (_tmp17_, "budgie_tasklist_indicator_color_attention", &_tmp18_);
#line 610 "../src/panel/applets/icon-tasklist/IconButton.vala"
			col = _tmp18_;
#line 610 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (!_tmp19_) {
#line 611 "../src/panel/applets/icon-tasklist/IconButton.vala"
				gdk_rgba_parse (&col, "#D84E4E");
#line 3172 "IconButton.c"
			}
		}
#line 614 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp20_ = col;
#line 614 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_draw_inactive (self, cr, &_tmp20_);
#line 615 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), cr);
#line 615 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (context);
#line 615 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 615 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 3187 "IconButton.c"
	}
#line 618 "../src/panel/applets/icon-tasklist/IconButton.vala"
	counter = 0;
#line 619 "../src/panel/applets/icon-tasklist/IconButton.vala"
	previous_x = 0;
#line 620 "../src/panel/applets/icon-tasklist/IconButton.vala"
	previous_y = 0;
#line 621 "../src/panel/applets/icon-tasklist/IconButton.vala"
	spacing = width % count;
#line 622 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (spacing == 0) {
#line 622 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp21_ = 1;
#line 3201 "IconButton.c"
	} else {
#line 622 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp21_ = spacing;
#line 3205 "IconButton.c"
	}
#line 622 "../src/panel/applets/icon-tasklist/IconButton.vala"
	spacing = _tmp21_;
#line 623 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp22_ = windows;
#line 3211 "IconButton.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 623 "../src/panel/applets/icon-tasklist/IconButton.vala"
		window_collection = _tmp22_;
#line 623 "../src/panel/applets/icon-tasklist/IconButton.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 3219 "IconButton.c"
			WnckWindow* _tmp23_;
			WnckWindow* window = NULL;
#line 623 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp23_ = _g_object_ref0 ((WnckWindow*) window_it->data);
#line 623 "../src/panel/applets/icon-tasklist/IconButton.vala"
			window = _tmp23_;
#line 3226 "IconButton.c"
			{
				WnckWindow* _tmp24_;
#line 624 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (counter == count) {
#line 625 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (window);
#line 625 "../src/panel/applets/icon-tasklist/IconButton.vala"
					break;
#line 3235 "IconButton.c"
				}
#line 628 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp24_ = window;
#line 628 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (!wnck_window_is_skip_tasklist (_tmp24_)) {
#line 3241 "IconButton.c"
					gint indicator_x = 0;
					gint indicator_y = 0;
					DesktopHelper* _tmp25_;
					gboolean _tmp26_ = FALSE;
					DesktopHelper* _tmp27_;
					WnckWindow* _tmp28_;
					WnckWindow* _tmp29_;
					WnckWindow* _tmp30_;
					gboolean _tmp31_;
					DesktopHelper* _tmp42_;
					gint _tmp43_;
#line 629 "../src/panel/applets/icon-tasklist/IconButton.vala"
					indicator_x = 0;
#line 630 "../src/panel/applets/icon-tasklist/IconButton.vala"
					indicator_y = 0;
#line 631 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp25_ = self->priv->_desktop_helper;
#line 631 "../src/panel/applets/icon-tasklist/IconButton.vala"
					switch (_tmp25_->panel_position) {
#line 631 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_TOP:
#line 3263 "IconButton.c"
						{
#line 633 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 634 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_x = x;
#line 3269 "IconButton.c"
							} else {
#line 636 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_x = previous_x + (width / count);
#line 636 "../src/panel/applets/icon-tasklist/IconButton.vala"
								previous_x = indicator_x;
#line 637 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_x += spacing;
#line 3277 "IconButton.c"
							}
#line 639 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y = y;
#line 640 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 3283 "IconButton.c"
						}
#line 631 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_BOTTOM:
#line 3287 "IconButton.c"
						{
#line 642 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 643 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_x = x;
#line 3293 "IconButton.c"
							} else {
#line 645 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_x = previous_x + (width / count);
#line 645 "../src/panel/applets/icon-tasklist/IconButton.vala"
								previous_x = indicator_x;
#line 646 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_x += spacing;
#line 3301 "IconButton.c"
							}
#line 648 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_y = y + height;
#line 649 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 3307 "IconButton.c"
						}
#line 631 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_LEFT:
#line 3311 "IconButton.c"
						{
#line 651 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 652 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_y = y;
#line 3317 "IconButton.c"
							} else {
#line 654 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_y = previous_y + (height / count);
#line 654 "../src/panel/applets/icon-tasklist/IconButton.vala"
								previous_y = indicator_y;
#line 655 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_y += spacing;
#line 3325 "IconButton.c"
							}
#line 657 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x = x;
#line 658 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 3331 "IconButton.c"
						}
#line 631 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_RIGHT:
#line 3335 "IconButton.c"
						{
#line 660 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 661 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_y = y;
#line 3341 "IconButton.c"
							} else {
#line 663 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_y = previous_y + (height / count);
#line 663 "../src/panel/applets/icon-tasklist/IconButton.vala"
								previous_y = indicator_y;
#line 664 "../src/panel/applets/icon-tasklist/IconButton.vala"
								indicator_y += spacing;
#line 3349 "IconButton.c"
							}
#line 666 "../src/panel/applets/icon-tasklist/IconButton.vala"
							indicator_x = x + width;
#line 667 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 3355 "IconButton.c"
						}
						default:
						{
#line 669 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 3361 "IconButton.c"
						}
					}
#line 672 "../src/panel/applets/icon-tasklist/IconButton.vala"
					cairo_set_line_width (cr, (gdouble) 6);
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp27_ = self->priv->_desktop_helper;
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp28_ = desktop_helper_get_active_window (_tmp27_);
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp29_ = _tmp28_;
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp30_ = window;
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp31_ = _tmp29_ == _tmp30_;
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (_tmp29_);
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (_tmp31_) {
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp26_ = count > 1;
#line 3382 "IconButton.c"
					} else {
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp26_ = FALSE;
#line 3386 "IconButton.c"
					}
#line 673 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (_tmp26_) {
#line 3390 "IconButton.c"
						GdkRGBA col2 = {0};
						GdkRGBA _tmp32_;
						GtkStyleContext* _tmp33_;
						GdkRGBA _tmp34_ = {0};
						gboolean _tmp35_;
						GdkRGBA _tmp36_;
						GdkRGBA _tmp37_;
						GdkRGBA _tmp38_;
#line 674 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp32_ = col;
#line 674 "../src/panel/applets/icon-tasklist/IconButton.vala"
						col2 = _tmp32_;
#line 675 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp33_ = context;
#line 675 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp35_ = gtk_style_context_lookup_color (_tmp33_, "budgie_tasklist_indicator_color_active_window", &_tmp34_);
#line 675 "../src/panel/applets/icon-tasklist/IconButton.vala"
						col2 = _tmp34_;
#line 675 "../src/panel/applets/icon-tasklist/IconButton.vala"
						if (!_tmp35_) {
#line 676 "../src/panel/applets/icon-tasklist/IconButton.vala"
							gdk_rgba_parse (&col2, "#6BBFFF");
#line 3413 "IconButton.c"
						}
#line 678 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp36_ = col2;
#line 678 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp37_ = col2;
#line 678 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp38_ = col2;
#line 678 "../src/panel/applets/icon-tasklist/IconButton.vala"
						cairo_set_source_rgba (cr, _tmp36_.red, _tmp37_.green, _tmp38_.blue, (gdouble) 1);
#line 3423 "IconButton.c"
					} else {
						GdkRGBA _tmp39_;
						GdkRGBA _tmp40_;
						GdkRGBA _tmp41_;
#line 680 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp39_ = col;
#line 680 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp40_ = col;
#line 680 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp41_ = col;
#line 680 "../src/panel/applets/icon-tasklist/IconButton.vala"
						cairo_set_source_rgba (cr, _tmp39_.red, _tmp40_.green, _tmp41_.blue, (gdouble) 1);
#line 3436 "IconButton.c"
					}
#line 682 "../src/panel/applets/icon-tasklist/IconButton.vala"
					cairo_move_to (cr, (gdouble) indicator_x, (gdouble) indicator_y);
#line 684 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp42_ = self->priv->_desktop_helper;
#line 684 "../src/panel/applets/icon-tasklist/IconButton.vala"
					switch (_tmp42_->panel_position) {
#line 684 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_LEFT:
#line 684 "../src/panel/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_RIGHT:
#line 3448 "IconButton.c"
						{
							gint to = 0;
#line 687 "../src/panel/applets/icon-tasklist/IconButton.vala"
							to = 0;
#line 688 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (counter == (count - 1)) {
#line 689 "../src/panel/applets/icon-tasklist/IconButton.vala"
								to = y + height;
#line 3457 "IconButton.c"
							} else {
#line 691 "../src/panel/applets/icon-tasklist/IconButton.vala"
								to = previous_y + (height / count);
#line 3461 "IconButton.c"
							}
#line 693 "../src/panel/applets/icon-tasklist/IconButton.vala"
							cairo_line_to (cr, (gdouble) indicator_x, (gdouble) to);
#line 694 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 3467 "IconButton.c"
						}
						default:
						{
							gint to = 0;
#line 696 "../src/panel/applets/icon-tasklist/IconButton.vala"
							to = 0;
#line 697 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (counter == (count - 1)) {
#line 698 "../src/panel/applets/icon-tasklist/IconButton.vala"
								to = x + width;
#line 3478 "IconButton.c"
							} else {
#line 700 "../src/panel/applets/icon-tasklist/IconButton.vala"
								to = previous_x + (width / count);
#line 3482 "IconButton.c"
							}
#line 702 "../src/panel/applets/icon-tasklist/IconButton.vala"
							cairo_line_to (cr, (gdouble) to, (gdouble) indicator_y);
#line 703 "../src/panel/applets/icon-tasklist/IconButton.vala"
							break;
#line 3488 "IconButton.c"
						}
					}
#line 706 "../src/panel/applets/icon-tasklist/IconButton.vala"
					cairo_stroke (cr);
#line 707 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp43_ = counter;
#line 707 "../src/panel/applets/icon-tasklist/IconButton.vala"
					counter = _tmp43_ + 1;
#line 3497 "IconButton.c"
				}
#line 623 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (window);
#line 3501 "IconButton.c"
			}
		}
	}
#line 711 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), cr);
#line 711 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (context);
#line 711 "../src/panel/applets/icon-tasklist/IconButton.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 711 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 3513 "IconButton.c"
}

static gboolean
_cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                            const cairo_rectangle_int_t * s2)
{
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (s1 == s2) {
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return TRUE;
#line 3524 "IconButton.c"
	}
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (s1 == NULL) {
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return FALSE;
#line 3530 "IconButton.c"
	}
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (s2 == NULL) {
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return FALSE;
#line 3536 "IconButton.c"
	}
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (s1->x != s2->x) {
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return FALSE;
#line 3542 "IconButton.c"
	}
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (s1->y != s2->y) {
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return FALSE;
#line 3548 "IconButton.c"
	}
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (s1->width != s2->width) {
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return FALSE;
#line 3554 "IconButton.c"
	}
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (s1->height != s2->height) {
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return FALSE;
#line 3560 "IconButton.c"
	}
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return TRUE;
#line 3564 "IconButton.c"
}

void
icon_button_on_size_allocate (IconButton* self,
                              GtkAllocation* allocation)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	GtkAllocation _tmp4_;
	GtkAllocation _tmp5_;
	gint x = 0;
	gint y = 0;
	GtkWidget* toplevel = NULL;
	GtkWidget* _tmp6_;
	GtkWidget* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GtkWidget* _tmp9_;
	GtkWidget* _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	GtkWidget* _tmp15_;
	GdkWindow* _tmp16_;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
#line 714 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 714 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (allocation != NULL);
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = *allocation;
#line 715 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_cairo_rectangle_int_equal (&_tmp0_, &_tmp1_) != TRUE) {
#line 3599 "IconButton.c"
		gint max = 0;
		GtkAllocation _tmp2_;
		GtkAllocation _tmp3_;
#line 716 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = *allocation;
#line 716 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = *allocation;
#line 716 "../src/panel/applets/icon-tasklist/IconButton.vala"
		max = (gint) fmin ((gdouble) _tmp2_.width, (gdouble) _tmp3_.height);
#line 718 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (max > FORMULA_SWAP_POINT) {
#line 719 "../src/panel/applets/icon-tasklist/IconButton.vala"
			self->priv->target_icon_size = max - TARGET_ICON_PADDING;
#line 3613 "IconButton.c"
		} else {
#line 721 "../src/panel/applets/icon-tasklist/IconButton.vala"
			self->priv->target_icon_size = (gint) round (TARGET_ICON_SCALE * max);
#line 3617 "IconButton.c"
		}
#line 724 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_update_icon (self);
#line 3621 "IconButton.c"
	}
#line 727 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = *allocation;
#line 727 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->definite_allocation = _tmp4_;
#line 728 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = self->priv->definite_allocation;
#line 728 "../src/panel/applets/icon-tasklist/IconButton.vala"
	GTK_WIDGET_CLASS (icon_button_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp5_);
#line 731 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 731 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 731 "../src/panel/applets/icon-tasklist/IconButton.vala"
	toplevel = _tmp7_;
#line 732 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = toplevel;
#line 732 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp9_ == NULL) {
#line 732 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = TRUE;
#line 3643 "IconButton.c"
	} else {
		GtkWidget* _tmp10_;
		GdkWindow* _tmp11_;
#line 732 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = toplevel;
#line 732 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = gtk_widget_get_window (_tmp10_);
#line 732 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = _tmp11_ == NULL;
#line 3653 "IconButton.c"
	}
#line 732 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp8_) {
#line 733 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (toplevel);
#line 733 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return;
#line 3661 "IconButton.c"
	}
#line 735 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = toplevel;
#line 735 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gtk_widget_translate_coordinates ((GtkWidget*) self, _tmp12_, 0, 0, &_tmp13_, &_tmp14_);
#line 735 "../src/panel/applets/icon-tasklist/IconButton.vala"
	x = _tmp13_;
#line 735 "../src/panel/applets/icon-tasklist/IconButton.vala"
	y = _tmp14_;
#line 736 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp15_ = toplevel;
#line 736 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp16_ = gtk_widget_get_window (_tmp15_);
#line 736 "../src/panel/applets/icon-tasklist/IconButton.vala"
	gdk_window_get_root_coords (_tmp16_, x, y, &_tmp17_, &_tmp18_);
#line 736 "../src/panel/applets/icon-tasklist/IconButton.vala"
	x = _tmp17_;
#line 736 "../src/panel/applets/icon-tasklist/IconButton.vala"
	y = _tmp18_;
#line 738 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 3683 "IconButton.c"
		BudgieAbominationAppGroup* _tmp19_;
		GList* _tmp20_;
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp19_ = self->priv->class_group;
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp20_ = budgie_abomination_app_group_get_windows (_tmp19_);
#line 3690 "IconButton.c"
		{
			GList* win_collection = NULL;
			GList* win_it = NULL;
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
			win_collection = _tmp20_;
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 3698 "IconButton.c"
				WnckWindow* _tmp21_;
				WnckWindow* win = NULL;
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp21_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
				win = _tmp21_;
#line 3705 "IconButton.c"
				{
					WnckWindow* _tmp22_;
					GtkAllocation _tmp23_;
					GtkAllocation _tmp24_;
#line 740 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp22_ = win;
#line 740 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp23_ = self->priv->definite_allocation;
#line 740 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp24_ = self->priv->definite_allocation;
#line 740 "../src/panel/applets/icon-tasklist/IconButton.vala"
					wnck_window_set_icon_geometry (_tmp22_, x, y, _tmp23_.width, _tmp24_.height);
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 3720 "IconButton.c"
				}
			}
#line 739 "../src/panel/applets/icon-tasklist/IconButton.vala"
			(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 3725 "IconButton.c"
		}
	}
#line 714 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (toplevel);
#line 3730 "IconButton.c"
}

/**
 * set_app_for_class_group will set our AbominationApp for the first window in a given class group, if there is any
 */
static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5245 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5245 "glib-2.0.vapi"
	return result;
#line 3744 "IconButton.c"
}

static void
_____lambda39_ (IconButton* self)
{
#line 759 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 3752 "IconButton.c"
}

static void
______lambda39__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                            const gchar* old_name,
                                                            const gchar* new_name,
                                                            gpointer self)
{
#line 758 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_____lambda39_ ((IconButton*) self);
#line 3763 "IconButton.c"
}

void
icon_button_set_app_for_class_group (IconButton* self)
{
	BudgieAbominationRunningApp* _tmp0_;
#line 748 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 749 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->first_app;
#line 749 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 3776 "IconButton.c"
		GList* class_windows = NULL;
		BudgieAbominationAppGroup* _tmp1_;
		GList* _tmp2_;
		GList* _tmp3_;
#line 750 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->class_group;
#line 750 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = budgie_abomination_app_group_get_windows (_tmp1_);
#line 750 "../src/panel/applets/icon-tasklist/IconButton.vala"
		class_windows = _tmp2_;
#line 752 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = class_windows;
#line 752 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (!vala_g_list_is_empty (_tmp3_)) {
#line 3791 "IconButton.c"
			WnckWindow* first_window = NULL;
			GList* _tmp4_;
			gconstpointer _tmp5_;
			WnckWindow* _tmp6_;
			WnckWindow* _tmp7_;
#line 753 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = class_windows;
#line 753 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = g_list_nth_data (_tmp4_, (guint) 0);
#line 753 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp6_ = _g_object_ref0 ((WnckWindow*) _tmp5_);
#line 753 "../src/panel/applets/icon-tasklist/IconButton.vala"
			first_window = _tmp6_;
#line 755 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp7_ = first_window;
#line 755 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (_tmp7_ != NULL) {
#line 3809 "IconButton.c"
				BudgieAbominationAbomination* _tmp8_;
				WnckWindow* _tmp9_;
				BudgieAbominationRunningApp* _tmp10_;
				BudgieAbominationRunningApp* _tmp11_;
				GDesktopAppInfo* _tmp12_;
#line 756 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp8_ = self->priv->_abomination;
#line 756 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp9_ = first_window;
#line 756 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp10_ = budgie_abomination_abomination_get_app_from_window_id (_tmp8_, wnck_window_get_xid (_tmp9_));
#line 756 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (self->first_app);
#line 756 "../src/panel/applets/icon-tasklist/IconButton.vala"
				self->first_app = _tmp10_;
#line 758 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp11_ = self->first_app;
#line 758 "../src/panel/applets/icon-tasklist/IconButton.vala"
				g_signal_connect_object (_tmp11_, "renamed-app", (GCallback) ______lambda39__budgie_abomination_running_app_renamed_app, self, 0);
#line 762 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp12_ = self->priv->app_info;
#line 762 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (_tmp12_ == NULL) {
#line 3833 "IconButton.c"
					BudgieAbominationRunningApp* _tmp13_;
					GDesktopAppInfo* _tmp14_;
					GDesktopAppInfo* _tmp15_;
					GDesktopAppInfo* _tmp16_;
#line 763 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp13_ = self->first_app;
#line 763 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp14_ = budgie_abomination_running_app_get_app_info (_tmp13_);
#line 763 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp15_ = _tmp14_;
#line 763 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 763 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (self->priv->app_info);
#line 763 "../src/panel/applets/icon-tasklist/IconButton.vala"
					self->priv->app_info = _tmp16_;
#line 3850 "IconButton.c"
				}
			}
#line 752 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_object_unref0 (first_window);
#line 3855 "IconButton.c"
		}
#line 749 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(class_windows == NULL) ? NULL : (class_windows = (g_list_free (class_windows), NULL));
#line 3859 "IconButton.c"
	}
}

/**
 * setup_popover_with_class will set up our popover with windows from the class
 */
static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return _data3_;
#line 3873 "IconButton.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3883 "IconButton.c"
		IconButton* self;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self = _data3_->self;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block3Data, _data3_);
#line 3891 "IconButton.c"
	}
}

static void
_______lambda40_ (Block3Data* _data3_)
{
	IconButton* self;
	gulong win_xid = 0UL;
	WnckWindow* _tmp0_;
	BudgieIconPopover* _tmp1_;
#line 786 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = _data3_->self;
#line 787 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _data3_->window;
#line 787 "../src/panel/applets/icon-tasklist/IconButton.vala"
	win_xid = wnck_window_get_xid (_tmp0_);
#line 788 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->popover;
#line 788 "../src/panel/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_rename_window (_tmp1_, win_xid);
#line 3912 "IconButton.c"
}

static void
________lambda40__wnck_window_name_changed (WnckWindow* _sender,
                                            gpointer self)
{
#line 786 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_______lambda40_ (self);
#line 3921 "IconButton.c"
}

static void
_______lambda41_ (Block3Data* _data3_)
{
	IconButton* self;
	WnckWindow* _tmp0_;
#line 791 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = _data3_->self;
#line 792 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _data3_->window;
#line 792 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (wnck_window_needs_attention (_tmp0_)) {
#line 793 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_attention (self, TRUE);
#line 3937 "IconButton.c"
	}
}

static void
________lambda41__wnck_window_state_changed (WnckWindow* _sender,
                                             WnckWindowState changed_mask,
                                             WnckWindowState new_state,
                                             gpointer self)
{
#line 791 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_______lambda41_ (self);
#line 3949 "IconButton.c"
}

static void
icon_button_setup_popover_with_class (IconButton* self)
{
	BudgieAbominationRunningApp* _tmp0_;
	BudgieAbominationAppGroup* _tmp1_;
	GList* _tmp2_;
#line 773 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 774 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->first_app;
#line 774 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 775 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_set_app_for_class_group (self);
#line 3966 "IconButton.c"
	}
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->class_group;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = budgie_abomination_app_group_get_windows (_tmp1_);
#line 3972 "IconButton.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
		window_collection = _tmp2_;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 3980 "IconButton.c"
			WnckWindow* window = NULL;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
			window = (WnckWindow*) window_it->data;
#line 3984 "IconButton.c"
			{
				Block3Data* _data3_;
				WnckWindow* _tmp3_;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_data3_ = g_slice_new0 (Block3Data);
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_data3_->_ref_count_ = 1;
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_data3_->self = g_object_ref (self);
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_data3_->window = window;
#line 779 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp3_ = _data3_->window;
#line 779 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (_tmp3_ != NULL) {
#line 4000 "IconButton.c"
					BudgieAbominationAbomination* _tmp4_;
					WnckWindow* _tmp5_;
#line 780 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp4_ = self->priv->_abomination;
#line 780 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp5_ = _data3_->window;
#line 780 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (!budgie_abomination_abomination_is_disallowed_window_type (_tmp4_, _tmp5_)) {
#line 4009 "IconButton.c"
						WnckWindow* _tmp6_;
#line 781 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp6_ = _data3_->window;
#line 781 "../src/panel/applets/icon-tasklist/IconButton.vala"
						if (icon_button_should_add_window (self, _tmp6_)) {
#line 4015 "IconButton.c"
							gulong xid = 0UL;
							WnckWindow* _tmp7_;
							gchar* name = NULL;
							WnckWindow* _tmp8_;
							const gchar* _tmp9_;
							gchar* _tmp10_;
							BudgieIconPopover* _tmp11_;
							const gchar* _tmp12_;
							WnckWindow* _tmp13_;
							WnckWindow* _tmp14_;
#line 782 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp7_ = _data3_->window;
#line 782 "../src/panel/applets/icon-tasklist/IconButton.vala"
							xid = wnck_window_get_xid (_tmp7_);
#line 783 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp8_ = _data3_->window;
#line 783 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp9_ = wnck_window_get_name (_tmp8_);
#line 783 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp10_ = g_strdup (_tmp9_);
#line 783 "../src/panel/applets/icon-tasklist/IconButton.vala"
							name = _tmp10_;
#line 785 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp11_ = self->priv->popover;
#line 785 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp12_ = name;
#line 785 "../src/panel/applets/icon-tasklist/IconButton.vala"
							budgie_icon_popover_add_window (_tmp11_, xid, _tmp12_);
#line 786 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp13_ = _data3_->window;
#line 786 "../src/panel/applets/icon-tasklist/IconButton.vala"
							g_signal_connect_data (_tmp13_, "name-changed", (GCallback) ________lambda40__wnck_window_name_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, G_CONNECT_AFTER);
#line 791 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp14_ = _data3_->window;
#line 791 "../src/panel/applets/icon-tasklist/IconButton.vala"
							g_signal_connect_data (_tmp14_, "state-changed", (GCallback) ________lambda41__wnck_window_state_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, G_CONNECT_AFTER);
#line 781 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_g_free0 (name);
#line 4054 "IconButton.c"
						}
					}
				}
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
				block3_data_unref (_data3_);
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_data3_ = NULL;
#line 4062 "IconButton.c"
			}
		}
#line 778 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 4067 "IconButton.c"
	}
}

static void
icon_button_real_get_preferred_width (GtkWidget* base,
                                      gint* min,
                                      gint* nat)
{
	IconButton * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	DesktopHelper* _tmp0_;
#line 802 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 803 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 803 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_->orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 4086 "IconButton.c"
		DesktopHelper* _tmp1_;
#line 804 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_desktop_helper;
#line 804 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_nat = _tmp1_->panel_size;
#line 804 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_min = _vala_nat;
#line 805 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (min) {
#line 805 "../src/panel/applets/icon-tasklist/IconButton.vala"
			*min = _vala_min;
#line 4098 "IconButton.c"
		}
#line 805 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (nat) {
#line 805 "../src/panel/applets/icon-tasklist/IconButton.vala"
			*nat = _vala_nat;
#line 4104 "IconButton.c"
		}
#line 805 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return;
#line 4108 "IconButton.c"
	} else {
		gint m = 0;
		gint n = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 808 "../src/panel/applets/icon-tasklist/IconButton.vala"
		GTK_WIDGET_CLASS (icon_button_parent_class)->get_preferred_width ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp2_, &_tmp3_);
#line 808 "../src/panel/applets/icon-tasklist/IconButton.vala"
		m = _tmp2_;
#line 808 "../src/panel/applets/icon-tasklist/IconButton.vala"
		n = _tmp3_;
#line 809 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_min = m;
#line 810 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_nat = n;
#line 4124 "IconButton.c"
	}
#line 802 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (min) {
#line 802 "../src/panel/applets/icon-tasklist/IconButton.vala"
		*min = _vala_min;
#line 4130 "IconButton.c"
	}
#line 802 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (nat) {
#line 802 "../src/panel/applets/icon-tasklist/IconButton.vala"
		*nat = _vala_nat;
#line 4136 "IconButton.c"
	}
}

static void
icon_button_real_get_preferred_height (GtkWidget* base,
                                       gint* min,
                                       gint* nat)
{
	IconButton * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	DesktopHelper* _tmp0_;
#line 814 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 815 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 815 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_->orientation == GTK_ORIENTATION_VERTICAL) {
#line 4155 "IconButton.c"
		DesktopHelper* _tmp1_;
#line 816 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_desktop_helper;
#line 816 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_nat = _tmp1_->panel_size;
#line 816 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_min = _vala_nat;
#line 4163 "IconButton.c"
	} else {
		gint m = 0;
		gint n = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 819 "../src/panel/applets/icon-tasklist/IconButton.vala"
		GTK_WIDGET_CLASS (icon_button_parent_class)->get_preferred_height ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp2_, &_tmp3_);
#line 819 "../src/panel/applets/icon-tasklist/IconButton.vala"
		m = _tmp2_;
#line 819 "../src/panel/applets/icon-tasklist/IconButton.vala"
		n = _tmp3_;
#line 820 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_min = m;
#line 821 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_vala_nat = n;
#line 4179 "IconButton.c"
	}
#line 814 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (min) {
#line 814 "../src/panel/applets/icon-tasklist/IconButton.vala"
		*min = _vala_min;
#line 4185 "IconButton.c"
	}
#line 814 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (nat) {
#line 814 "../src/panel/applets/icon-tasklist/IconButton.vala"
		*nat = _vala_nat;
#line 4191 "IconButton.c"
	}
}

static gboolean
icon_button_real_button_press_event (GtkWidget* base,
                                     GdkEventButton* event)
{
	IconButton * self;
	gboolean was_double_click = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 825 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 825 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 826 "../src/panel/applets/icon-tasklist/IconButton.vala"
	was_double_click = event->type == GDK_DOUBLE_BUTTON_PRESS;
#line 828 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!was_double_click) {
#line 828 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = TRUE;
#line 4213 "IconButton.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 828 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (was_double_click) {
#line 828 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = event->button != ((guint) 1);
#line 4220 "IconButton.c"
		} else {
#line 828 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = FALSE;
#line 4224 "IconButton.c"
		}
#line 828 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = _tmp1_;
#line 4228 "IconButton.c"
	}
#line 828 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_) {
#line 829 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = GDK_EVENT_PROPAGATE;
#line 829 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 4236 "IconButton.c"
	}
#line 832 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_handle_launch_clicks (self, event, TRUE);
#line 834 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), event);
#line 834 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 4244 "IconButton.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (length >= 0) {
#line 4253 "IconButton.c"
		gchar** result;
		gssize i;
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = g_new0 (gchar*, length + 1);
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
		for (i = 0; i < length; i++) {
#line 4260 "IconButton.c"
			gchar* _tmp0_;
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp0_ = g_strdup (self[i]);
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
			result[i] = _tmp0_;
#line 4266 "IconButton.c"
		}
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 4270 "IconButton.c"
	}
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return NULL;
#line 4274 "IconButton.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 868 "../src/panel/applets/icon-tasklist/IconButton.vala"
	for (i = 0; i < stack_length; i++) {
#line 868 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 868 "../src/panel/applets/icon-tasklist/IconButton.vala"
			return TRUE;
#line 4289 "IconButton.c"
		}
	}
#line 868 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return FALSE;
#line 4294 "IconButton.c"
}

static gboolean
icon_button_real_button_release_event (GtkWidget* base,
                                       GdkEventButton* event)
{
	IconButton * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 837 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 837 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 4310 "IconButton.c"
		gboolean _tmp1_ = FALSE;
		WnckWindow* _tmp2_;
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = self->last_active_window;
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp2_ == NULL) {
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = TRUE;
#line 4319 "IconButton.c"
		} else {
			BudgieAbominationAppGroup* _tmp3_;
			GList* _tmp4_;
			GList* _tmp5_;
			WnckWindow* _tmp6_;
			GList* _tmp7_;
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = self->priv->class_group;
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = budgie_abomination_app_group_get_windows (_tmp3_);
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = _tmp4_;
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp6_ = self->last_active_window;
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp7_ = g_list_find (_tmp5_, _tmp6_);
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = _tmp7_ == NULL;
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
			(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 4340 "IconButton.c"
		}
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = _tmp1_;
#line 4344 "IconButton.c"
	} else {
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = FALSE;
#line 4348 "IconButton.c"
	}
#line 838 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_) {
#line 4352 "IconButton.c"
		BudgieAbominationAppGroup* _tmp8_;
		GList* _tmp9_;
		GList* _tmp10_;
		gconstpointer _tmp11_;
		WnckWindow* _tmp12_;
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = self->priv->class_group;
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = budgie_abomination_app_group_get_windows (_tmp8_);
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = _tmp9_;
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = g_list_nth_data (_tmp10_, (guint) 0);
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = _g_object_ref0 ((WnckWindow*) _tmp11_);
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self->last_active_window);
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self->last_active_window = _tmp12_;
#line 839 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(_tmp10_ == NULL) ? NULL : (_tmp10_ = (g_list_free (_tmp10_), NULL));
#line 4374 "IconButton.c"
	}
#line 842 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (event->button == ((guint) 3)) {
#line 4378 "IconButton.c"
		BudgieIconPopover* _tmp13_;
		BudgiePopoverManager* _tmp14_;
#line 843 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = self->priv->popover;
#line 843 "../src/panel/applets/icon-tasklist/IconButton.vala"
		budgie_icon_popover_render (_tmp13_);
#line 844 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp14_ = self->priv->_popover_manager;
#line 844 "../src/panel/applets/icon-tasklist/IconButton.vala"
		budgie_popover_manager_show_popover (_tmp14_, (GtkWidget*) self);
#line 845 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = GDK_EVENT_STOP;
#line 845 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 4393 "IconButton.c"
	} else {
#line 846 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (event->button == ((guint) 1)) {
#line 847 "../src/panel/applets/icon-tasklist/IconButton.vala"
			icon_button_handle_launch_clicks (self, event, FALSE);
#line 4399 "IconButton.c"
		} else {
#line 848 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (event->button == ((guint) 2)) {
#line 4403 "IconButton.c"
				GList* windows = NULL;
				gboolean middle_click_create_new_instance = FALSE;
				GSettings* _tmp15_;
#line 850 "../src/panel/applets/icon-tasklist/IconButton.vala"
				middle_click_create_new_instance = FALSE;
#line 852 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp15_ = self->priv->settings;
#line 852 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (_tmp15_ != NULL) {
#line 4413 "IconButton.c"
					GSettings* _tmp16_;
#line 853 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp16_ = self->priv->settings;
#line 853 "../src/panel/applets/icon-tasklist/IconButton.vala"
					middle_click_create_new_instance = g_settings_get_boolean (_tmp16_, "middle-click-launch-new-instance");
#line 4419 "IconButton.c"
				}
#line 856 "../src/panel/applets/icon-tasklist/IconButton.vala"
				if (middle_click_create_new_instance) {
#line 4423 "IconButton.c"
					GList* _tmp19_;
#line 857 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (!icon_button_is_empty (self)) {
#line 4427 "IconButton.c"
						BudgieAbominationAppGroup* _tmp17_;
						GList* _tmp18_;
#line 858 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp17_ = self->priv->class_group;
#line 858 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp18_ = budgie_abomination_app_group_get_windows (_tmp17_);
#line 858 "../src/panel/applets/icon-tasklist/IconButton.vala"
						(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 858 "../src/panel/applets/icon-tasklist/IconButton.vala"
						windows = _tmp18_;
#line 4438 "IconButton.c"
					} else {
#line 860 "../src/panel/applets/icon-tasklist/IconButton.vala"
						(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 860 "../src/panel/applets/icon-tasklist/IconButton.vala"
						windows = NULL;
#line 4444 "IconButton.c"
					}
#line 863 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp19_ = windows;
#line 863 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (vala_g_list_is_empty (_tmp19_)) {
#line 864 "../src/panel/applets/icon-tasklist/IconButton.vala"
						icon_button_launch_app (self, gtk_get_current_event_time ());
#line 4452 "IconButton.c"
					} else {
						GDesktopAppInfo* _tmp20_;
#line 865 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp20_ = self->priv->app_info;
#line 865 "../src/panel/applets/icon-tasklist/IconButton.vala"
						if (_tmp20_ != NULL) {
#line 4459 "IconButton.c"
							gchar** actions = NULL;
							GDesktopAppInfo* _tmp21_;
							gchar** _tmp22_;
							gchar** _tmp23_;
							gchar** _tmp24_;
							gint _tmp24__length1;
							gint actions_length1;
							gint _actions_size_;
							gchar** _tmp25_;
							gint _tmp25__length1;
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp21_ = self->priv->app_info;
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp23_ = _tmp22_ = g_desktop_app_info_list_actions (_tmp21_);
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp24_ = (_tmp23_ != NULL) ? _vala_array_dup1 (_tmp23_, _vala_array_length (_tmp22_)) : _tmp23_;
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp24__length1 = _vala_array_length (_tmp22_);
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
							actions = _tmp24_;
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
							actions_length1 = _tmp24__length1;
#line 866 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_actions_size_ = actions_length1;
#line 868 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp25_ = actions;
#line 868 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp25__length1 = actions_length1;
#line 868 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (_vala_string_array_contains (_tmp25_, _tmp25__length1, "new-window")) {
#line 4490 "IconButton.c"
								GdkAppLaunchContext* _tmp26_;
								GdkScreen* _tmp27_;
								GdkAppLaunchContext* _tmp28_;
								GDesktopAppInfo* _tmp29_;
								GdkAppLaunchContext* _tmp30_;
#line 869 "../src/panel/applets/icon-tasklist/IconButton.vala"
								_tmp26_ = self->priv->launch_context;
#line 869 "../src/panel/applets/icon-tasklist/IconButton.vala"
								_tmp27_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 869 "../src/panel/applets/icon-tasklist/IconButton.vala"
								gdk_app_launch_context_set_screen (_tmp26_, _tmp27_);
#line 870 "../src/panel/applets/icon-tasklist/IconButton.vala"
								_tmp28_ = self->priv->launch_context;
#line 870 "../src/panel/applets/icon-tasklist/IconButton.vala"
								gdk_app_launch_context_set_timestamp (_tmp28_, (guint32) GDK_CURRENT_TIME);
#line 871 "../src/panel/applets/icon-tasklist/IconButton.vala"
								_tmp29_ = self->priv->app_info;
#line 871 "../src/panel/applets/icon-tasklist/IconButton.vala"
								_tmp30_ = self->priv->launch_context;
#line 871 "../src/panel/applets/icon-tasklist/IconButton.vala"
								g_desktop_app_info_launch_action (_tmp29_, "new-window", (GAppLaunchContext*) _tmp30_);
#line 4512 "IconButton.c"
							} else {
#line 873 "../src/panel/applets/icon-tasklist/IconButton.vala"
								icon_button_launch_app (self, gtk_get_current_event_time ());
#line 4516 "IconButton.c"
							}
#line 865 "../src/panel/applets/icon-tasklist/IconButton.vala"
							actions = (_vala_array_free (actions, actions_length1, (GDestroyNotify) g_free), NULL);
#line 4520 "IconButton.c"
						}
					}
				}
#line 848 "../src/panel/applets/icon-tasklist/IconButton.vala"
				(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 4526 "IconButton.c"
			}
		}
	}
#line 879 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->button_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), event);
#line 879 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 4534 "IconButton.c"
}

static GdkEventButton*
_vala_GdkEventButton_copy (GdkEventButton* self)
{
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return g_boxed_copy (gdk_event_get_type (), self);
#line 4542 "IconButton.c"
}

static gpointer
__vala_GdkEventButton_copy0 (gpointer self)
{
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return self ? _vala_GdkEventButton_copy (self) : NULL;
#line 4550 "IconButton.c"
}

static void
_vala_GdkEventButton_free (GdkEventButton* self)
{
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 4558 "IconButton.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return _data4_;
#line 4568 "IconButton.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4578 "IconButton.c"
		IconButton* self;
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self = _data4_->self;
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
		__vala_GdkEventButton_free0 (_data4_->event);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block4Data, _data4_);
#line 4588 "IconButton.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return _data5_;
#line 4599 "IconButton.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4609 "IconButton.c"
		IconButton* self;
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self = _data5_->_data4_->self;
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		block4_data_unref (_data5_->_data4_);
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_data5_->_data4_ = NULL;
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block5Data, _data5_);
#line 4619 "IconButton.c"
	}
}

static void
_____lambda42_ (Block5Data* _data5_,
                WnckWindow* w)
{
	Block4Data* _data4_;
	IconButton* self;
#line 929 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data4_ = _data5_->_data4_;
#line 929 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = _data4_->self;
#line 929 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (w != NULL);
#line 930 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_data5_->one_active) {
#line 931 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_minimize (w);
#line 4639 "IconButton.c"
	} else {
#line 933 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_unminimize (w, _data4_->event->time);
#line 934 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_activate (w, _data4_->event->time);
#line 4645 "IconButton.c"
	}
}

static void
______lambda42__gfunc (gconstpointer data,
                       gpointer self)
{
#line 929 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_____lambda42_ (self, (WnckWindow*) data);
#line 4655 "IconButton.c"
}

static void
icon_button_handle_launch_clicks (IconButton* self,
                                  GdkEventButton* event,
                                  gboolean was_double_click)
{
	Block4Data* _data4_;
	GdkEventButton* _tmp0_;
	gboolean should_launch_app = FALSE;
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (event != NULL);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data4_->_ref_count_ = 1;
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data4_->self = g_object_ref (self);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = __vala_GdkEventButton_copy0 (event);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	__vala_GdkEventButton_free0 (_data4_->event);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data4_->event = _tmp0_;
#line 883 "../src/panel/applets/icon-tasklist/IconButton.vala"
	should_launch_app = FALSE;
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 4686 "IconButton.c"
		Block5Data* _data5_;
		WnckWorkspace* active_workspace = NULL;
		WnckScreen* _tmp1_;
		WnckWorkspace* _tmp2_;
		WnckWorkspace* _tmp3_;
		GList* list = NULL;
		GList* win_ids = NULL;
		BudgieIconPopover* _tmp4_;
		GHashTable* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
		GList* _tmp12_;
		guint len = 0U;
		GList* _tmp15_;
		gboolean show_all_windows_on_click = FALSE;
		GSettings* _tmp16_;
		gboolean _tmp18_ = FALSE;
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_data5_ = g_slice_new0 (Block5Data);
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_data5_->_ref_count_ = 1;
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_data5_->_data4_ = block4_data_ref (_data4_);
#line 886 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_data5_->one_active = FALSE;
#line 887 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->screen;
#line 887 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = wnck_screen_get_active_workspace (_tmp1_);
#line 887 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 887 "../src/panel/applets/icon-tasklist/IconButton.vala"
		active_workspace = _tmp3_;
#line 889 "../src/panel/applets/icon-tasklist/IconButton.vala"
		list = NULL;
#line 890 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->popover;
#line 890 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = _tmp4_->window_id_to_name;
#line 890 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = g_hash_table_get_keys (_tmp5_);
#line 890 "../src/panel/applets/icon-tasklist/IconButton.vala"
		win_ids = _tmp6_;
#line 892 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = win_ids;
#line 4732 "IconButton.c"
		{
			GList* id_collection = NULL;
			GList* id_it = NULL;
#line 892 "../src/panel/applets/icon-tasklist/IconButton.vala"
			id_collection = _tmp7_;
#line 892 "../src/panel/applets/icon-tasklist/IconButton.vala"
			for (id_it = id_collection; id_it != NULL; id_it = id_it->next) {
#line 4740 "IconButton.c"
				gulong id = 0UL;
#line 892 "../src/panel/applets/icon-tasklist/IconButton.vala"
				id = *((gulong*) id_it->data);
#line 4744 "IconButton.c"
				{
					WnckWindow* win = NULL;
					WnckWindow* _tmp8_;
					WnckWindow* _tmp9_;
					WnckWindow* _tmp10_;
					WnckWindow* _tmp11_;
#line 893 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp8_ = wnck_window_get (id);
#line 893 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp9_ = _g_object_ref0 (_tmp8_);
#line 893 "../src/panel/applets/icon-tasklist/IconButton.vala"
					win = _tmp9_;
#line 895 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp10_ = win;
#line 895 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (_tmp10_ == NULL) {
#line 896 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_g_object_unref0 (win);
#line 896 "../src/panel/applets/icon-tasklist/IconButton.vala"
						continue;
#line 4765 "IconButton.c"
					}
#line 899 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp11_ = win;
#line 899 "../src/panel/applets/icon-tasklist/IconButton.vala"
					list = g_list_append (list, _tmp11_);
#line 892 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 4773 "IconButton.c"
				}
			}
		}
#line 902 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = list;
#line 4779 "IconButton.c"
		{
			GList* win_collection = NULL;
			GList* win_it = NULL;
#line 902 "../src/panel/applets/icon-tasklist/IconButton.vala"
			win_collection = _tmp12_;
#line 902 "../src/panel/applets/icon-tasklist/IconButton.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 4787 "IconButton.c"
				WnckWindow* _tmp13_;
				WnckWindow* win = NULL;
#line 902 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp13_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 902 "../src/panel/applets/icon-tasklist/IconButton.vala"
				win = _tmp13_;
#line 4794 "IconButton.c"
				{
					WnckWindow* _tmp14_;
#line 903 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_tmp14_ = win;
#line 903 "../src/panel/applets/icon-tasklist/IconButton.vala"
					if (wnck_window_is_active (_tmp14_)) {
#line 904 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_data5_->one_active = TRUE;
#line 905 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_g_object_unref0 (win);
#line 905 "../src/panel/applets/icon-tasklist/IconButton.vala"
						break;
#line 4807 "IconButton.c"
					}
#line 902 "../src/panel/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 4811 "IconButton.c"
				}
			}
		}
#line 909 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp15_ = list;
#line 909 "../src/panel/applets/icon-tasklist/IconButton.vala"
		len = g_list_length (_tmp15_);
#line 911 "../src/panel/applets/icon-tasklist/IconButton.vala"
		show_all_windows_on_click = FALSE;
#line 913 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = self->priv->settings;
#line 913 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp16_ != NULL) {
#line 4825 "IconButton.c"
			GSettings* _tmp17_;
#line 914 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = self->priv->settings;
#line 914 "../src/panel/applets/icon-tasklist/IconButton.vala"
			show_all_windows_on_click = g_settings_get_boolean (_tmp17_, "show-all-windows-on-click");
#line 4831 "IconButton.c"
		}
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (len == ((guint) 1)) {
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = TRUE;
#line 4837 "IconButton.c"
		} else {
			gboolean _tmp19_ = FALSE;
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (len > ((guint) 1)) {
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp19_ = !show_all_windows_on_click;
#line 4844 "IconButton.c"
			} else {
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp19_ = FALSE;
#line 4848 "IconButton.c"
			}
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = _tmp19_;
#line 4852 "IconButton.c"
		}
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp18_) {
#line 4856 "IconButton.c"
			WnckWindow* only_window = NULL;
			GList* _tmp20_;
			gconstpointer _tmp21_;
			WnckWindow* _tmp22_;
			WnckWindow* _tmp23_;
			WnckWorkspace* _tmp24_;
#line 918 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp20_ = list;
#line 918 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp21_ = g_list_nth_data (_tmp20_, (guint) 0);
#line 918 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp22_ = _g_object_ref0 ((WnckWindow*) _tmp21_);
#line 918 "../src/panel/applets/icon-tasklist/IconButton.vala"
			only_window = _tmp22_;
#line 920 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp23_ = only_window;
#line 920 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp24_ = active_workspace;
#line 920 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (!wnck_window_is_on_workspace (_tmp23_, _tmp24_)) {
#line 4877 "IconButton.c"
				WnckWorkspace* winspace = NULL;
				WnckWindow* _tmp25_;
				WnckWorkspace* _tmp26_;
				WnckWorkspace* _tmp27_;
				WnckWorkspace* _tmp28_;
				WnckWindow* _tmp29_;
				WnckWindow* _tmp30_;
#line 921 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp25_ = only_window;
#line 921 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp26_ = wnck_window_get_workspace (_tmp25_);
#line 921 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp27_ = _g_object_ref0 (_tmp26_);
#line 921 "../src/panel/applets/icon-tasklist/IconButton.vala"
				winspace = _tmp27_;
#line 922 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp28_ = winspace;
#line 922 "../src/panel/applets/icon-tasklist/IconButton.vala"
				wnck_workspace_activate (_tmp28_, _data4_->event->time);
#line 923 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp29_ = only_window;
#line 923 "../src/panel/applets/icon-tasklist/IconButton.vala"
				wnck_window_activate (_tmp29_, _data4_->event->time);
#line 924 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp30_ = only_window;
#line 924 "../src/panel/applets/icon-tasklist/IconButton.vala"
				wnck_window_unminimize (_tmp30_, _data4_->event->time);
#line 920 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (winspace);
#line 4907 "IconButton.c"
			} else {
				GList* _tmp31_;
				gconstpointer _tmp32_;
#line 926 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp31_ = list;
#line 926 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp32_ = g_list_nth_data (_tmp31_, (guint) 0);
#line 926 "../src/panel/applets/icon-tasklist/IconButton.vala"
				icon_button_toggle_window_minstate (self, _data4_->event->time, (WnckWindow*) _tmp32_);
#line 4917 "IconButton.c"
			}
#line 917 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_g_object_unref0 (only_window);
#line 4921 "IconButton.c"
		} else {
			gboolean _tmp33_ = FALSE;
#line 928 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (len > ((guint) 1)) {
#line 928 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp33_ = show_all_windows_on_click;
#line 4928 "IconButton.c"
			} else {
#line 928 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp33_ = FALSE;
#line 4932 "IconButton.c"
			}
#line 928 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (_tmp33_) {
#line 4936 "IconButton.c"
				GList* _tmp34_;
#line 929 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp34_ = list;
#line 929 "../src/panel/applets/icon-tasklist/IconButton.vala"
				g_list_foreach (_tmp34_, ______lambda42__gfunc, _data5_);
#line 4942 "IconButton.c"
			} else {
#line 938 "../src/panel/applets/icon-tasklist/IconButton.vala"
				should_launch_app = TRUE;
#line 4946 "IconButton.c"
			}
		}
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(win_ids == NULL) ? NULL : (win_ids = (g_list_free (win_ids), NULL));
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(list == NULL) ? NULL : (list = (g_list_free (list), NULL));
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (active_workspace);
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		block5_data_unref (_data5_);
#line 885 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_data5_ = NULL;
#line 4959 "IconButton.c"
	} else {
#line 941 "../src/panel/applets/icon-tasklist/IconButton.vala"
		should_launch_app = TRUE;
#line 4963 "IconButton.c"
	}
#line 944 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (should_launch_app) {
#line 4967 "IconButton.c"
		gboolean require_double_click = FALSE;
		GSettings* _tmp35_;
		gboolean _tmp36_ = FALSE;
		gboolean _tmp37_ = FALSE;
#line 945 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp35_ = self->priv->settings;
#line 945 "../src/panel/applets/icon-tasklist/IconButton.vala"
		require_double_click = g_settings_get_boolean (_tmp35_, "require-double-click-to-launch");
#line 947 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (was_double_click) {
#line 947 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp37_ = require_double_click;
#line 4980 "IconButton.c"
		} else {
#line 947 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp37_ = FALSE;
#line 4984 "IconButton.c"
		}
#line 947 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp37_) {
#line 947 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp36_ = TRUE;
#line 4990 "IconButton.c"
		} else {
#line 947 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp36_ = !require_double_click;
#line 4994 "IconButton.c"
		}
#line 947 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp36_) {
#line 948 "../src/panel/applets/icon-tasklist/IconButton.vala"
			icon_button_launch_app (self, _data4_->event->time);
#line 5000 "IconButton.c"
		}
	}
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	block4_data_unref (_data4_);
#line 882 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_data4_ = NULL;
#line 5007 "IconButton.c"
}

static gboolean
icon_button_real_scroll_event (GtkWidget* base,
                               GdkEventScroll* event)
{
	IconButton * self;
	gboolean _tmp0_ = FALSE;
	WnckWindow* target_window = NULL;
	WnckWindow* current_window = NULL;
	DesktopHelper* _tmp1_;
	WnckWindow* _tmp2_;
	gboolean have_current_window = FALSE;
	WnckWindow* _tmp3_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean result;
#line 953 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 953 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 954 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (event->direction >= 4) {
#line 954 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = TRUE;
#line 5034 "IconButton.c"
	} else {
#line 954 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = (g_get_monotonic_time () - self->priv->last_scroll_time) < ((gint64) 300000);
#line 5038 "IconButton.c"
	}
#line 954 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_) {
#line 955 "../src/panel/applets/icon-tasklist/IconButton.vala"
		result = GDK_EVENT_STOP;
#line 955 "../src/panel/applets/icon-tasklist/IconButton.vala"
		return result;
#line 5046 "IconButton.c"
	}
#line 958 "../src/panel/applets/icon-tasklist/IconButton.vala"
	target_window = NULL;
#line 960 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->_desktop_helper;
#line 960 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = desktop_helper_get_active_window (_tmp1_);
#line 960 "../src/panel/applets/icon-tasklist/IconButton.vala"
	current_window = _tmp2_;
#line 961 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = current_window;
#line 961 "../src/panel/applets/icon-tasklist/IconButton.vala"
	have_current_window = _tmp3_ != NULL;
#line 963 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_is_empty (self)) {
#line 5062 "IconButton.c"
		GList* windows = NULL;
		BudgieAbominationAppGroup* _tmp4_;
		GList* _tmp5_;
		guint windows_length = 0U;
		GList* _tmp6_;
#line 964 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->class_group;
#line 964 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = budgie_abomination_app_group_get_windows (_tmp4_);
#line 964 "../src/panel/applets/icon-tasklist/IconButton.vala"
		windows = _tmp5_;
#line 965 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = windows;
#line 965 "../src/panel/applets/icon-tasklist/IconButton.vala"
		windows_length = g_list_length (_tmp6_);
#line 967 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (windows_length > ((guint) 1)) {
#line 5080 "IconButton.c"
			gulong _tmp7_ = 0UL;
			gulong win_id = 0UL;
			gint current_window_position = 0;
			gint _tmp15_ = 0;
			gint incr_index = 0;
			gulong new_window_id = 0UL;
			GList* _tmp16_;
			gconstpointer _tmp17_;
#line 968 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (event->direction != GDK_SCROLL_UP) {
#line 969 "../src/panel/applets/icon-tasklist/IconButton.vala"
				windows = g_list_reverse (windows);
#line 5093 "IconButton.c"
			}
#line 972 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (have_current_window) {
#line 5097 "IconButton.c"
				WnckWindow* _tmp8_;
#line 972 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp8_ = current_window;
#line 972 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp7_ = wnck_window_get_xid (_tmp8_);
#line 5103 "IconButton.c"
			} else {
#line 972 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp7_ = (gulong) 0;
#line 5107 "IconButton.c"
			}
#line 972 "../src/panel/applets/icon-tasklist/IconButton.vala"
			win_id = _tmp7_;
#line 973 "../src/panel/applets/icon-tasklist/IconButton.vala"
			current_window_position = 0;
#line 975 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (have_current_window) {
#line 5115 "IconButton.c"
				{
					gint current_id_index = 0;
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
					current_id_index = 0;
#line 5120 "IconButton.c"
					{
						gboolean _tmp9_ = FALSE;
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
						_tmp9_ = TRUE;
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
						while (TRUE) {
#line 5127 "IconButton.c"
							WnckWindow* window = NULL;
							GList* _tmp11_;
							gconstpointer _tmp12_;
							WnckWindow* _tmp13_;
							WnckWindow* _tmp14_;
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (!_tmp9_) {
#line 5135 "IconButton.c"
								gint _tmp10_;
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
								_tmp10_ = current_id_index;
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
								current_id_index = _tmp10_ + 1;
#line 5141 "IconButton.c"
							}
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp9_ = FALSE;
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (!(((guint) current_id_index) < windows_length)) {
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
								break;
#line 5149 "IconButton.c"
							}
#line 977 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp11_ = windows;
#line 977 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp12_ = g_list_nth_data (_tmp11_, (guint) current_id_index);
#line 977 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp13_ = _g_object_ref0 ((WnckWindow*) _tmp12_);
#line 977 "../src/panel/applets/icon-tasklist/IconButton.vala"
							window = _tmp13_;
#line 978 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_tmp14_ = window;
#line 978 "../src/panel/applets/icon-tasklist/IconButton.vala"
							if (win_id == wnck_window_get_xid (_tmp14_)) {
#line 979 "../src/panel/applets/icon-tasklist/IconButton.vala"
								current_window_position = current_id_index;
#line 980 "../src/panel/applets/icon-tasklist/IconButton.vala"
								_g_object_unref0 (window);
#line 980 "../src/panel/applets/icon-tasklist/IconButton.vala"
								break;
#line 5169 "IconButton.c"
							}
#line 976 "../src/panel/applets/icon-tasklist/IconButton.vala"
							_g_object_unref0 (window);
#line 5173 "IconButton.c"
						}
					}
				}
			}
#line 985 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (have_current_window) {
#line 985 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp15_ = current_window_position + 1;
#line 5182 "IconButton.c"
			} else {
#line 985 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp15_ = 0;
#line 5186 "IconButton.c"
			}
#line 985 "../src/panel/applets/icon-tasklist/IconButton.vala"
			incr_index = _tmp15_;
#line 986 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (((guint) incr_index) == windows_length) {
#line 987 "../src/panel/applets/icon-tasklist/IconButton.vala"
				incr_index = 0;
#line 5194 "IconButton.c"
			}
#line 990 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = windows;
#line 990 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = g_list_nth_data (_tmp16_, (guint) incr_index);
#line 990 "../src/panel/applets/icon-tasklist/IconButton.vala"
			new_window_id = wnck_window_get_xid ((WnckWindow*) _tmp17_);
#line 991 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (new_window_id >= ((gulong) 0)) {
#line 5204 "IconButton.c"
				WnckWindow* _tmp18_;
				WnckWindow* _tmp19_;
#line 992 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp18_ = wnck_window_get (new_window_id);
#line 992 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 992 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (target_window);
#line 992 "../src/panel/applets/icon-tasklist/IconButton.vala"
				target_window = _tmp19_;
#line 5215 "IconButton.c"
			}
		} else {
#line 994 "../src/panel/applets/icon-tasklist/IconButton.vala"
			if (windows_length == ((guint) 1)) {
#line 5220 "IconButton.c"
				gulong id = 0UL;
				GList* _tmp20_;
				gconstpointer _tmp21_;
				WnckWindow* _tmp22_;
				WnckWindow* _tmp23_;
#line 995 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp20_ = windows;
#line 995 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp21_ = g_list_nth_data (_tmp20_, (guint) 0);
#line 995 "../src/panel/applets/icon-tasklist/IconButton.vala"
				id = wnck_window_get_xid ((WnckWindow*) _tmp21_);
#line 996 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp22_ = wnck_window_get (id);
#line 996 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_tmp23_ = _g_object_ref0 (_tmp22_);
#line 996 "../src/panel/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (target_window);
#line 996 "../src/panel/applets/icon-tasklist/IconButton.vala"
				target_window = _tmp23_;
#line 5240 "IconButton.c"
			}
		}
#line 963 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 5245 "IconButton.c"
	}
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (icon_button_is_empty (self)) {
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp26_ = TRUE;
#line 5251 "IconButton.c"
	} else {
		BudgieAbominationAppGroup* _tmp27_;
		GList* _tmp28_;
		GList* _tmp29_;
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp27_ = self->priv->class_group;
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp28_ = budgie_abomination_app_group_get_windows (_tmp27_);
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp29_ = _tmp28_;
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp26_ = g_list_length (_tmp29_) == ((guint) 1);
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		(_tmp29_ == NULL) ? NULL : (_tmp29_ = (g_list_free (_tmp29_), NULL));
#line 5266 "IconButton.c"
	}
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp26_) {
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp25_ = have_current_window;
#line 5272 "IconButton.c"
	} else {
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp25_ = FALSE;
#line 5276 "IconButton.c"
	}
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp25_) {
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp24_ = event->direction != GDK_SCROLL_UP;
#line 5282 "IconButton.c"
	} else {
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp24_ = FALSE;
#line 5286 "IconButton.c"
	}
#line 1000 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp24_) {
#line 5290 "IconButton.c"
		WnckWindow* _tmp30_;
#line 1001 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp30_ = target_window;
#line 1001 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_minimize (_tmp30_);
#line 5296 "IconButton.c"
	} else {
		WnckWindow* _tmp31_;
#line 1002 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp31_ = target_window;
#line 1002 "../src/panel/applets/icon-tasklist/IconButton.vala"
		if (_tmp31_ != NULL) {
#line 5303 "IconButton.c"
			WnckWindow* _tmp32_;
			WnckWindow* _tmp33_;
#line 1003 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp32_ = target_window;
#line 1003 "../src/panel/applets/icon-tasklist/IconButton.vala"
			wnck_window_activate (_tmp32_, event->time);
#line 1004 "../src/panel/applets/icon-tasklist/IconButton.vala"
			_tmp33_ = target_window;
#line 1004 "../src/panel/applets/icon-tasklist/IconButton.vala"
			wnck_window_unminimize (_tmp33_, event->time);
#line 5314 "IconButton.c"
		}
	}
#line 1007 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->last_scroll_time = g_get_monotonic_time ();
#line 1009 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = GDK_EVENT_STOP;
#line 1009 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (current_window);
#line 1009 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (target_window);
#line 1009 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5327 "IconButton.c"
}

static void
icon_button_toggle_window_minstate (IconButton* self,
                                    guint32 time,
                                    WnckWindow* win)
{
	WnckWindow* current_active_window = NULL;
	WnckScreen* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	gulong _tmp3_ = 0UL;
	WnckWindow* _tmp4_;
	gboolean is_current_active_window = FALSE;
	gboolean _tmp6_ = FALSE;
#line 1013 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 1013 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (win != NULL);
#line 1014 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = wnck_window_get_screen (win);
#line 1014 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = wnck_screen_get_active_window (_tmp0_);
#line 1014 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1014 "../src/panel/applets/icon-tasklist/IconButton.vala"
	current_active_window = _tmp2_;
#line 1015 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = current_active_window;
#line 1015 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp4_ != NULL) {
#line 5359 "IconButton.c"
		WnckWindow* _tmp5_;
#line 1015 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = current_active_window;
#line 1015 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = wnck_window_get_xid (_tmp5_);
#line 5365 "IconButton.c"
	} else {
#line 1015 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = (gulong) 0;
#line 5369 "IconButton.c"
	}
#line 1015 "../src/panel/applets/icon-tasklist/IconButton.vala"
	is_current_active_window = wnck_window_get_xid (win) == _tmp3_;
#line 1017 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (wnck_window_is_minimized (win)) {
#line 1017 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = TRUE;
#line 5377 "IconButton.c"
	} else {
#line 1017 "../src/panel/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = !is_current_active_window;
#line 5381 "IconButton.c"
	}
#line 1017 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (_tmp6_) {
#line 1018 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_activate (win, time);
#line 1019 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_unminimize (win, time);
#line 5389 "IconButton.c"
	} else {
#line 1021 "../src/panel/applets/icon-tasklist/IconButton.vala"
		wnck_window_minimize (win);
#line 5393 "IconButton.c"
	}
#line 1013 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (current_active_window);
#line 5397 "IconButton.c"
}

GDesktopAppInfo*
icon_button_get_appinfo (IconButton* self)
{
	GDesktopAppInfo* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* result;
#line 1025 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1026 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->app_info;
#line 1026 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1026 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = _tmp1_;
#line 1026 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5416 "IconButton.c"
}

BudgieAbominationAppGroup*
icon_button_get_class_group (IconButton* self)
{
	BudgieAbominationAppGroup* _tmp0_;
	BudgieAbominationAppGroup* result;
#line 1029 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1030 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->class_group;
#line 1030 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 1030 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5432 "IconButton.c"
}

BudgieAbominationAbomination*
icon_button_get_abomination (IconButton* self)
{
	BudgieAbominationAbomination* result;
	BudgieAbominationAbomination* _tmp0_;
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_abomination;
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5448 "IconButton.c"
}

void
icon_button_set_abomination (IconButton* self,
                             BudgieAbominationAbomination* value)
{
	BudgieAbominationAbomination* old_value;
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_abomination (self);
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self->priv->_abomination = value;
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_ABOMINATION_PROPERTY]);
#line 5466 "IconButton.c"
	}
}

BudgieAppSystem*
icon_button_get_app_system (IconButton* self)
{
	BudgieAppSystem* result;
	BudgieAppSystem* _tmp0_;
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_app_system;
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5483 "IconButton.c"
}

void
icon_button_set_app_system (IconButton* self,
                            BudgieAppSystem* value)
{
	BudgieAppSystem* old_value;
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_app_system (self);
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self->priv->_app_system = value;
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_APP_SYSTEM_PROPERTY]);
#line 5501 "IconButton.c"
	}
}

DesktopHelper*
icon_button_get_desktop_helper (IconButton* self)
{
	DesktopHelper* result;
	DesktopHelper* _tmp0_;
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5518 "IconButton.c"
}

void
icon_button_set_desktop_helper (IconButton* self,
                                DesktopHelper* value)
{
	DesktopHelper* old_value;
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_desktop_helper (self);
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self->priv->_desktop_helper = value;
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_DESKTOP_HELPER_PROPERTY]);
#line 5536 "IconButton.c"
	}
}

BudgiePopoverManager*
icon_button_get_popover_manager (IconButton* self)
{
	BudgiePopoverManager* result;
	BudgiePopoverManager* _tmp0_;
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_popover_manager;
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5553 "IconButton.c"
}

void
icon_button_set_popover_manager (IconButton* self,
                                 BudgiePopoverManager* value)
{
	BudgiePopoverManager* old_value;
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_popover_manager (self);
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
		self->priv->_popover_manager = value;
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_POPOVER_MANAGER_PROPERTY]);
#line 5571 "IconButton.c"
	}
}

static void
icon_button_class_init (IconButtonClass * klass,
                        gpointer klass_data)
{
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_type_class_adjust_private_offset (klass, &IconButton_private_offset);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) icon_button_real_draw;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) icon_button_real_get_preferred_width;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) icon_button_real_get_preferred_height;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) icon_button_real_button_press_event;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) icon_button_real_button_release_event;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->scroll_event = (gboolean (*) (GtkWidget*, GdkEventScroll*)) icon_button_real_scroll_event;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_button_get_property;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_button_set_property;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_button_finalize;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_ABOMINATION_PROPERTY, icon_button_properties[ICON_BUTTON_ABOMINATION_PROPERTY] = g_param_spec_object ("abomination", "abomination", "abomination", BUDGIE_ABOMINATION_TYPE_ABOMINATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_APP_SYSTEM_PROPERTY, icon_button_properties[ICON_BUTTON_APP_SYSTEM_PROPERTY] = g_param_spec_object ("app-system", "app-system", "app-system", BUDGIE_TYPE_APP_SYSTEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_DESKTOP_HELPER_PROPERTY, icon_button_properties[ICON_BUTTON_DESKTOP_HELPER_PROPERTY] = g_param_spec_object ("desktop-helper", "desktop-helper", "desktop-helper", TYPE_DESKTOP_HELPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_POPOVER_MANAGER_PROPERTY, icon_button_properties[ICON_BUTTON_POPOVER_MANAGER_PROPERTY] = g_param_spec_object ("popover-manager", "popover-manager", "popover-manager", budgie_popover_manager_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5609 "IconButton.c"
	/**
	 * Signals
	 */
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_signals[ICON_BUTTON_BECAME_EMPTY_SIGNAL] = g_signal_new ("became-empty", TYPE_ICON_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	icon_button_signals[ICON_BUTTON_PINNED_CHANGED_SIGNAL] = g_signal_new ("pinned-changed", TYPE_ICON_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5617 "IconButton.c"
}

static void
icon_button_instance_init (IconButton * self,
                           gpointer klass)
{
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv = icon_button_get_instance_private (self);
#line 27 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->first_app = NULL;
#line 29 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->pinned = FALSE;
#line 30 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->last_active_window = NULL;
#line 33 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->popover = NULL;
#line 34 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->screen = NULL;
#line 35 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->settings = NULL;
#line 36 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->class_group = NULL;
#line 37 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->app_info = NULL;
#line 38 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = 0;
#line 40 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->originally_pinned = FALSE;
#line 42 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->last_scroll_time = (gint64) 0;
#line 43 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->needs_attention = FALSE;
#line 46 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->_abomination = NULL;
#line 47 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->_app_system = NULL;
#line 48 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->_desktop_helper = NULL;
#line 49 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self->priv->_popover_manager = NULL;
#line 5658 "IconButton.c"
}

static void
icon_button_finalize (GObject * obj)
{
	IconButton * self;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_BUTTON, IconButton);
#line 27 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->first_app);
#line 28 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->icon);
#line 30 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->last_active_window);
#line 31 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_free0 (self->button_id);
#line 33 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->popover);
#line 34 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->screen);
#line 35 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->settings);
#line 36 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->class_group);
#line 37 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->app_info);
#line 41 "../src/panel/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->launch_context);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (icon_button_parent_class)->finalize (obj);
#line 5689 "IconButton.c"
}

/**
 * IconButton provides the pretty IconTasklist button to house one or more
 * windows in a group, as well as selection capabilities, interaction, animations
 * and rendering of "dots" for the renderable windows.
 */
GType
icon_button_get_type (void)
{
	return icon_button_type_id;
}

GType
icon_button_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconButton), 0, (GInstanceInitFunc) icon_button_instance_init, NULL };
	icon_button_type_id = g_type_module_register_type (module, gtk_toggle_button_get_type (), "IconButton", &g_define_type_info, 0);
	IconButton_private_offset = sizeof (IconButtonPrivate);
	return icon_button_type_id;
}

static void
_vala_icon_button_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	IconButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_BUTTON, IconButton);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	switch (property_id) {
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_ABOMINATION_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_abomination (self));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_APP_SYSTEM_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_app_system (self));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_DESKTOP_HELPER_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_desktop_helper (self));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_POPOVER_MANAGER_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_popover_manager (self));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 5746 "IconButton.c"
		default:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 5752 "IconButton.c"
	}
}

static void
_vala_icon_button_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	IconButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_BUTTON, IconButton);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
	switch (property_id) {
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_ABOMINATION_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_set_abomination (self, g_value_get_object (value));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_APP_SYSTEM_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_set_app_system (self, g_value_get_object (value));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_DESKTOP_HELPER_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_set_desktop_helper (self, g_value_get_object (value));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_POPOVER_MANAGER_PROPERTY:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		icon_button_set_popover_manager (self, g_value_get_object (value));
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 5790 "IconButton.c"
		default:
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/panel/applets/icon-tasklist/IconButton.vala"
		break;
#line 5796 "IconButton.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

